/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef MP7JRS_DOCUMENT_H
#define MP7JRS_DOCUMENT_H

#include "Mp7JrsFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsPtr.h"

/** Represents an XML document. */
class MP7JRS_EXPORT Mp7JrsDocument {
public:
	/** Create a document with the given node as root node. */
	Mp7JrsDocument();

	Mp7JrsDocument(Mp7JrsNodePtr root); 

	virtual ~Mp7JrsDocument();

	/** Set the root node of the document. */
	void SetRoot(Mp7JrsNodePtr root); 

	/** Get the root node of the document. */
	Mp7JrsNodePtr GetRoot(); 

	/** Get a node of this document which is described by an absolute XPath expression.
	  */
	virtual Mp7JrsNodePtr GetNode(const XMLCh* xpath);

protected:
	Mp7JrsNodePtr		_root;
};

#endif
