/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


#ifndef MP7JRSEVERYTHING_INCLUDED_H
#define MP7JRSEVERYTHING_INCLUDED_H

#include "Mp7JrsDefines.h"

#include "Mp7JrsUnknown.h"
#include "Mp7Jrsspace_LocalType.h"
#include "Mp7JrsAbstractionLevelType.h"
#include "Mp7JrsAccessUnitType.h"
#include "Mp7JrsAccessUnitType_FragmentUpdateUnit_CollectionType.h"
#include "Mp7JrsAdvancedFaceRecognitionType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_CollectionType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_CollectionType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_FourierFeature_CollectionType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_CollectionType.h"
#include "Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalType.h"
#include "Mp7JrsAffectiveType.h"
#include "Mp7JrsAffectiveType_Score_CollectionType.h"
#include "Mp7JrsAffectiveType_Score_LocalType.h"
#include "Mp7JrsAgentObjectType.h"
#include "Mp7JrsAgentType.h"
#include "Mp7JrsAgentType_Icon_CollectionType.h"
#include "Mp7JrsAnalyticClipType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentType_type_LocalType.h"
#include "Mp7JrsAnalyticEditedVideoType.h"
#include "Mp7JrsAnalyticModelType.h"
#include "Mp7JrsAnalyticModelType_CollectionType.h"
#include "Mp7JrsAnalyticModelType_function_LocalType.h"
#include "Mp7JrsAnalyticModelType_Label_LocalType.h"
#include "Mp7JrsAnalyticModelType_LocalType.h"
#include "Mp7JrsAnalyticModelType_Semantics_LocalType.h"
#include "Mp7JrsAnalyticTransitionType.h"
#include "Mp7JrsAudioBPMType.h"
#include "Mp7JrsAudioDSType.h"
#include "Mp7JrsAudioDType.h"
#include "Mp7JrsAudioFundamentalFrequencyType.h"
#include "Mp7JrsAudioHarmonicityType.h"
#include "Mp7JrsAudioLLDScalarType.h"
#include "Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType.h"
#include "Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalType.h"
#include "Mp7JrsAudioLLDVectorType.h"
#include "Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionType.h"
#include "Mp7JrsAudioLLDVectorType_SeriesOfVector_LocalType.h"
#include "Mp7JrsAudioPowerType.h"
#include "Mp7JrsAudioSegmentMediaSourceDecompositionType.h"
#include "Mp7JrsAudioSegmentMediaSourceDecompositionType_CollectionType.h"
#include "Mp7JrsAudioSegmentMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsAudioSegmentTemporalDecompositionType.h"
#include "Mp7JrsAudioSegmentTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsAudioSegmentTemporalDecompositionType_LocalType.h"
#include "Mp7JrsAudioSegmentType.h"
#include "Mp7JrsAudioSegmentType_CollectionType.h"
#include "Mp7JrsAudioSegmentType_CollectionType0.h"
#include "Mp7JrsAudioSegmentType_LocalType.h"
#include "Mp7JrsAudioSegmentType_LocalType0.h"
#include "Mp7JrsAudioSignalQualityType.h"
#include "Mp7JrsAudioSignalQualityType_ErrorEventList_ErrorEvent_CollectionType.h"
#include "Mp7JrsAudioSignalQualityType_ErrorEventList_LocalType.h"
#include "Mp7JrsAudioSignatureType.h"
#include "Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType.h"
#include "Mp7JrsAudioSpectrumBasisType.h"
#include "Mp7JrsAudioSpectrumCentroidType.h"
#include "Mp7JrsAudioSpectrumEnvelopeType.h"
#include "Mp7JrsAudioSpectrumFlatnessType.h"
#include "Mp7JrsAudioSpectrumProjectionType.h"
#include "Mp7JrsAudioSpectrumSpreadType.h"
#include "Mp7JrsAudioSummaryComponentType.h"
#include "Mp7JrsAudioSummaryComponentType_Title_CollectionType.h"
#include "Mp7JrsAudioTempoType.h"
#include "Mp7JrsAudioType.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionType.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualRegionSpatialDecompositionType.h"
#include "Mp7JrsAudioVisualRegionSpatialDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualRegionSpatialDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType.h"
#include "Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualRegionTemporalDecompositionType.h"
#include "Mp7JrsAudioVisualRegionTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualRegionTemporalDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualRegionType.h"
#include "Mp7JrsAudioVisualRegionType_CollectionType.h"
#include "Mp7JrsAudioVisualRegionType_LocalType.h"
#include "Mp7JrsAudioVisualSegmentMediaSourceDecompositionType.h"
#include "Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualSegmentSpatialDecompositionType.h"
#include "Mp7JrsAudioVisualSegmentSpatialDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualSegmentSpatialDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType.h"
#include "Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualSegmentTemporalDecompositionType.h"
#include "Mp7JrsAudioVisualSegmentTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalType.h"
#include "Mp7JrsAudioVisualSegmentType.h"
#include "Mp7JrsAudioVisualSegmentType_CollectionType.h"
#include "Mp7JrsAudioVisualSegmentType_LocalType.h"
#include "Mp7JrsAudioVisualType.h"
#include "Mp7JrsAudioWaveformType.h"
#include "Mp7JrsauxiliaryLanguageType.h"
#include "Mp7JrsauxiliaryLanguageType_LocalType.h"
#include "Mp7JrsauxiliaryLanguageType_LocalType0.h"
#include "Mp7JrsauxiliaryLanguageType_LocalType1.h"
#include "Mp7JrsAvailabilityType.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_CollectionType.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType0.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType1.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType2.h"
#include "Mp7JrsBackgroundNoiseLevelType.h"
#include "Mp7JrsBalanceType.h"
#include "Mp7JrsBandwidthType.h"
#include "Mp7JrsbasicDurationType.h"
#include "Mp7JrsbasicTimePointType.h"
#include "Mp7JrsbeatType.h"
#include "Mp7JrsBinomialDistributionType.h"
#include "Mp7JrsBoxListType.h"
#include "Mp7JrsBrowsingPreferencesType.h"
#include "Mp7JrsBrowsingPreferencesType_BrowsingLocation_CollectionType.h"
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionType.h"
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType.h"
#include "Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionType.h"
#include "Mp7JrsCameraMotionSegmentType.h"
#include "Mp7JrsCameraMotionType.h"
#include "Mp7JrsCameraMotionType_Segment_CollectionType.h"
#include "Mp7JrscharacterSetCode.h"
#include "Mp7JrsClassificationModelType.h"
#include "Mp7JrsClassificationPreferencesType.h"
#include "Mp7JrsClassificationPreferencesType_AssociatedData_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_AssociatedData_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_Country_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Country_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_DatePeriod_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_DatePeriod_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_Form_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Form_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_Genre_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Genre_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_Language_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Language_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_LanguageFormat_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_Review_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Review_LocalType.h"
#include "Mp7JrsClassificationPreferencesType_Subject_CollectionType.h"
#include "Mp7JrsClassificationPreferencesType_Subject_LocalType.h"
#include "Mp7JrsClassificationSchemeAliasType.h"
#include "Mp7JrsClassificationSchemeBaseType.h"
#include "Mp7JrsClassificationSchemeBaseType_domain_CollectionType.h"
#include "Mp7JrsClassificationSchemeBaseType_Import_CollectionType.h"
#include "Mp7JrsClassificationSchemeDescriptionType.h"
#include "Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionType.h"
#include "Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionType.h"
#include "Mp7JrsClassificationSchemeType.h"
#include "Mp7JrsClassificationSchemeType_Term_CollectionType.h"
#include "Mp7JrsClassificationType.h"
#include "Mp7JrsClassificationType_CaptionLanguage_CollectionType.h"
#include "Mp7JrsClassificationType_CaptionLanguage_LocalType.h"
#include "Mp7JrsClassificationType_Genre_CollectionType.h"
#include "Mp7JrsClassificationType_Genre_LocalType.h"
#include "Mp7JrsClassificationType_Genre_type_LocalType.h"
#include "Mp7JrsClassificationType_Language_CollectionType.h"
#include "Mp7JrsClassificationType_MediaReview_CollectionType.h"
#include "Mp7JrsClassificationType_ParentalGuidance_CollectionType.h"
#include "Mp7JrsClassificationType_Purpose_CollectionType.h"
#include "Mp7JrsClassificationType_Release_LocalType.h"
#include "Mp7JrsClassificationType_Release_Region_CollectionType.h"
#include "Mp7JrsClassificationType_SignLanguage_CollectionType.h"
#include "Mp7JrsClassificationType_SignLanguage_LocalType.h"
#include "Mp7JrsClassificationType_Target_Age_LocalType.h"
#include "Mp7JrsClassificationType_Target_LocalType.h"
#include "Mp7JrsClassificationType_Target_Market_CollectionType.h"
#include "Mp7JrsClassificationType_Target_Region_CollectionType.h"
#include "Mp7JrsClusterClassificationModelType.h"
#include "Mp7JrsClusterClassificationModelType_CollectionType.h"
#include "Mp7JrsClusterClassificationModelType_LocalType.h"
#include "Mp7JrsClusterModelType.h"
#include "Mp7JrsClusterModelType_CollectionType.h"
#include "Mp7JrsClusterModelType_CollectionType0.h"
#include "Mp7JrsClusterModelType_LocalType.h"
#include "Mp7JrsClusterModelType_LocalType0.h"
#include "Mp7JrsCollectionModelType.h"
#include "Mp7JrsCollectionModelType_CollectionType.h"
#include "Mp7JrsCollectionModelType_LocalType.h"
#include "Mp7JrsCollectionType.h"
#include "Mp7JrsCollectionType_TextAnnotation_CollectionType.h"
#include "Mp7JrsColorLayoutType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff14_CollectionType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff14_LocalType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff2_CollectionType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff2_LocalType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff20_CollectionType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff20_LocalType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff27_CollectionType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff27_LocalType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff5_CollectionType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff5_LocalType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff63_CollectionType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff63_LocalType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff9_CollectionType.h"
#include "Mp7JrsColorLayoutType_CbACCoeff9_LocalType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff14_CollectionType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff14_LocalType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff2_CollectionType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff2_LocalType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff20_CollectionType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff20_LocalType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff27_CollectionType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff27_LocalType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff5_CollectionType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff5_LocalType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff63_CollectionType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff63_LocalType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff9_CollectionType.h"
#include "Mp7JrsColorLayoutType_CrACCoeff9_LocalType.h"
#include "Mp7JrsColorLayoutType_YACCoeff14_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff14_LocalType.h"
#include "Mp7JrsColorLayoutType_YACCoeff2_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff2_LocalType.h"
#include "Mp7JrsColorLayoutType_YACCoeff20_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff20_LocalType.h"
#include "Mp7JrsColorLayoutType_YACCoeff27_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff27_LocalType.h"
#include "Mp7JrsColorLayoutType_YACCoeff5_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff5_LocalType.h"
#include "Mp7JrsColorLayoutType_YACCoeff63_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff63_LocalType.h"
#include "Mp7JrsColorLayoutType_YACCoeff9_CollectionType.h"
#include "Mp7JrsColorLayoutType_YACCoeff9_LocalType.h"
#include "Mp7JrsColorQuantizationType.h"
#include "Mp7JrsColorQuantizationType_CollectionType.h"
#include "Mp7JrsColorQuantizationType_Component_LocalType.h"
#include "Mp7JrsColorQuantizationType_LocalType.h"
#include "Mp7JrsColorSamplingType.h"
#include "Mp7JrsColorSamplingType_Field_CollectionType.h"
#include "Mp7JrsColorSamplingType_Field_Component_CollectionType.h"
#include "Mp7JrsColorSamplingType_Field_Component_LocalType.h"
#include "Mp7JrsColorSamplingType_Field_Component_Offset_LocalType.h"
#include "Mp7JrsColorSamplingType_Field_Component_Period_LocalType.h"
#include "Mp7JrsColorSamplingType_Field_LocalType.h"
#include "Mp7JrsColorSamplingType_Lattice_LocalType.h"
#include "Mp7JrsColorSpaceType.h"
#include "Mp7JrsColorSpaceType_ColorTransMat_CollectionType.h"
#include "Mp7JrsColorSpaceType_ColorTransMat_LocalType.h"
#include "Mp7JrsColorSpaceType_type_LocalType.h"
#include "Mp7JrsColorStructureType.h"
#include "Mp7JrsColorStructureType_Values_CollectionType.h"
#include "Mp7JrsColorStructureType_Values_LocalType.h"
#include "Mp7JrsColorTemperatureType.h"
#include "Mp7JrsColorTemperatureType_BrowsingCategory_LocalType.h"
#include "Mp7JrsCompleteDescriptionType.h"
#include "Mp7JrsCompleteDescriptionType_OrderingKey_CollectionType.h"
#include "Mp7JrsCompleteDescriptionType_Relationships_CollectionType.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType.h"
#include "Mp7JrsCompositionShotType.h"
#include "Mp7JrsCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType.h"
#include "Mp7JrsCompositionTransitionType.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType0.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType1.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType2.h"
#include "Mp7JrsConceptCollectionType.h"
#include "Mp7JrsConceptCollectionType_CollectionType.h"
#include "Mp7JrsConceptCollectionType_CollectionType0.h"
#include "Mp7JrsConceptCollectionType_LocalType.h"
#include "Mp7JrsConceptCollectionType_LocalType0.h"
#include "Mp7JrsConceptType.h"
#include "Mp7JrsConfusionCountType.h"
#include "Mp7JrsContentAbstractionType.h"
#include "Mp7JrsContentCollectionType.h"
#include "Mp7JrsContentCollectionType_CollectionType.h"
#include "Mp7JrsContentCollectionType_CollectionType0.h"
#include "Mp7JrsContentCollectionType_CollectionType1.h"
#include "Mp7JrsContentCollectionType_LocalType.h"
#include "Mp7JrsContentCollectionType_LocalType0.h"
#include "Mp7JrsContentCollectionType_LocalType1.h"
#include "Mp7JrsContentDescriptionType.h"
#include "Mp7JrsContentDescriptionType_Affective_CollectionType.h"
#include "Mp7JrsContentEntityType.h"
#include "Mp7JrsContentEntityType_MultimediaContent_CollectionType.h"
#include "Mp7JrsContentManagementType.h"
#include "Mp7JrsContinuousDistributionType.h"
#include "Mp7JrsContinuousHiddenMarkovModelType.h"
#include "Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionType.h"
#include "Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType.h"
#include "Mp7JrsContinuousUniformDistributionType.h"
#include "Mp7JrsContourShapeType.h"
#include "Mp7JrsContourShapeType_Peak_CollectionType.h"
#include "Mp7JrsContourShapeType_Peak_LocalType.h"
#include "Mp7JrscontourType.h"
#include "Mp7JrscontourType_LocalType.h"
#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrscountryCode.h"
#include "Mp7JrsCreationDescriptionType.h"
#include "Mp7JrsCreationDescriptionType_CreationInformation_CollectionType.h"
#include "Mp7JrsCreationInformationType.h"
#include "Mp7JrsCreationInformationType_RelatedMaterial_CollectionType.h"
#include "Mp7JrsCreationPreferencesType.h"
#include "Mp7JrsCreationPreferencesType_Creator_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Creator_LocalType.h"
#include "Mp7JrsCreationPreferencesType_DatePeriod_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_DatePeriod_LocalType.h"
#include "Mp7JrsCreationPreferencesType_Keyword_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Keyword_LocalType.h"
#include "Mp7JrsCreationPreferencesType_Location_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Location_LocalType.h"
#include "Mp7JrsCreationPreferencesType_Title_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Title_LocalType.h"
#include "Mp7JrsCreationPreferencesType_Tool_CollectionType.h"
#include "Mp7JrsCreationPreferencesType_Tool_LocalType.h"
#include "Mp7JrsCreationToolType.h"
#include "Mp7JrsCreationToolType_Setting_CollectionType.h"
#include "Mp7JrsCreationToolType_Setting_LocalType.h"
#include "Mp7JrsCreationType.h"
#include "Mp7JrsCreationType_Abstract_CollectionType.h"
#include "Mp7JrsCreationType_CopyrightString_CollectionType.h"
#include "Mp7JrsCreationType_CreationCoordinates_CollectionType.h"
#include "Mp7JrsCreationType_CreationCoordinates_LocalType.h"
#include "Mp7JrsCreationType_CreationTool_CollectionType.h"
#include "Mp7JrsCreationType_Creator_CollectionType.h"
#include "Mp7JrsCreationType_Title_CollectionType.h"
#include "Mp7JrsCreatorType.h"
#include "Mp7JrsCreatorType_Character_CollectionType.h"
#include "Mp7JrsCreatorType_Instrument_CollectionType.h"
#include "Mp7JrsCrossChannelCorrelationType.h"
#include "Mp7JrscurrencyCode.h"
#include "Mp7JrscurvatureType.h"
#include "Mp7JrscurvatureType_CollectionType.h"
#include "Mp7JrsDcOffsetType.h"
#include "Mp7JrsDecoderInitType.h"
#include "Mp7JrsDecoderInitType_SchemaReference_CollectionType.h"
#include "Mp7JrsdegreeAccidentalType.h"
#include "Mp7JrsdegreeNoteType.h"
#include "Mp7JrsdependencyOperatorType.h"
#include "Mp7JrsDependencyStructurePhraseType.h"
#include "Mp7JrsDependencyStructurePhraseType_CollectionType.h"
#include "Mp7JrsDependencyStructurePhraseType_CollectionType0.h"
#include "Mp7JrsDependencyStructurePhraseType_LocalType.h"
#include "Mp7JrsDependencyStructurePhraseType_LocalType0.h"
#include "Mp7JrsDependencyStructurePhraseType_operator_LocalType.h"
#include "Mp7JrsDependencyStructureType.h"
#include "Mp7JrsDependencyStructureType_Sentence_CollectionType.h"
#include "Mp7JrsDescriptionMetadataType.h"
#include "Mp7JrsDescriptionMetadataType_Creator_CollectionType.h"
#include "Mp7JrsDescriptionMetadataType_Instrument_CollectionType.h"
#include "Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionType.h"
#include "Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionType.h"
#include "Mp7JrsDescriptionProfileType.h"
#include "Mp7JrsDescriptionProfileType_profileAndLevelIndication_CollectionType.h"
#include "Mp7JrsDescriptorCollectionType.h"
#include "Mp7JrsDescriptorCollectionType_CollectionType.h"
#include "Mp7JrsDescriptorCollectionType_Descriptor_CollectionType.h"
#include "Mp7JrsDescriptorCollectionType_LocalType.h"
#include "Mp7JrsDescriptorModelType.h"
#include "Mp7JrsDescriptorModelType_Field_CollectionType.h"
#include "Mp7Jrsdim_LocalType.h"
#include "Mp7JrsDiscreteDistributionType.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_CollectionType.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_LocalType.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionType.h"
#include "Mp7JrsDiscreteUniformDistributionType.h"
#include "Mp7JrsDisseminationType.h"
#include "Mp7JrsDominantColorType.h"
#include "Mp7JrsDominantColorType_Value_CollectionType.h"
#include "Mp7JrsDominantColorType_Value_ColorVariance_CollectionType.h"
#include "Mp7JrsDominantColorType_Value_ColorVariance_LocalType.h"
#include "Mp7JrsDominantColorType_Value_Index_CollectionType.h"
#include "Mp7JrsDominantColorType_Value_Index_LocalType.h"
#include "Mp7JrsDominantColorType_Value_LocalType.h"
#include "Mp7JrsDoubleDiagonalMatrixType.h"
#include "Mp7JrsDoubleMatrixType.h"
#include "Mp7JrsDoublePullbackDefinitionType.h"
#include "Mp7JrsDoublePullbackDefinitionType_MorphismGraph_CollectionType.h"
#include "Mp7JrsDoublePullbackDefinitionType_RuleGraph_CollectionType.h"
#include "Mp7JrsDoublePushoutDefinitionType.h"
#include "Mp7JrsDoublePushoutDefinitionType_MorphismGraph_CollectionType.h"
#include "Mp7JrsdoubleVector.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsDType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsEdgeHistogramType.h"
#include "Mp7JrsEdgeHistogramType_BinCounts_CollectionType.h"
#include "Mp7JrsEdgeHistogramType_BinCounts_LocalType.h"
#include "Mp7JrsEditedMovingRegionType.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType.h"
#include "Mp7JrsEditedVideoType.h"
#include "Mp7JrsEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionType.h"
#include "Mp7JrsElectronicAddressType.h"
#include "Mp7JrsElectronicAddressType_Email_CollectionType.h"
#include "Mp7JrsElectronicAddressType_Fax_CollectionType.h"
#include "Mp7JrsElectronicAddressType_Telephone_CollectionType.h"
#include "Mp7JrsElectronicAddressType_Telephone_LocalType.h"
#include "Mp7JrsElectronicAddressType_Telephone_type_LocalType.h"
#include "Mp7JrsElectronicAddressType_Url_CollectionType.h"
#include "Mp7JrsErrorEventType.h"
#include "Mp7JrsErrorEventType_DetectionProcess_LocalType.h"
#include "Mp7JrsErrorEventType_Status_LocalType.h"
#include "Mp7JrsEventType.h"
#include "Mp7JrsEventType_CollectionType.h"
#include "Mp7JrsEventType_LocalType.h"
#include "Mp7JrsEventType_SemanticPlace_CollectionType.h"
#include "Mp7JrsEventType_SemanticTime_CollectionType.h"
#include "Mp7JrsExponentialDistributionType.h"
#include "Mp7JrsExtendedLanguageType.h"
#include "Mp7JrsExtendedLanguageType_type_LocalType.h"
#include "Mp7JrsExtentType.h"
#include "Mp7JrsFaceRecognitionType.h"
#include "Mp7JrsFaceRecognitionType_Feature_CollectionType.h"
#include "Mp7JrsFaceRecognitionType_Feature_LocalType.h"
#include "Mp7JrsFigureTrajectoryType.h"
#include "Mp7JrsFigureTrajectoryType_type_LocalType.h"
#include "Mp7JrsFigureTrajectoryType_Vertex_CollectionType.h"
#include "Mp7JrsFilter1DType.h"
#include "Mp7JrsFilter2DType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionType.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionType.h"
#include "Mp7JrsFilteringType.h"
#include "Mp7JrsFilterSeparableType.h"
#include "Mp7JrsFilterSeparableType_Filter1D_CollectionType.h"
#include "Mp7JrsFilterType.h"
#include "Mp7JrsFinancialType.h"
#include "Mp7JrsFinancialType_AccountItem_CollectionType.h"
#include "Mp7JrsFinancialType_AccountItem_LocalType.h"
#include "Mp7JrsFiniteStateModelType.h"
#include "Mp7JrsFloatDiagonalMatrixType.h"
#include "Mp7JrsFloatMatrixType.h"
#include "Mp7JrsfloatVector.h"
#include "Mp7JrsFocusOfExpansionType.h"
#include "Mp7JrsFractionalPresenceType.h"
#include "Mp7JrsFragmentReferenceType.h"
#include "Mp7JrsFragmentUpdateCommandType.h"
#include "Mp7JrsFragmentUpdateCommandType_LocalType.h"
#include "Mp7JrsFragmentUpdateCommandType_LocalType0.h"
#include "Mp7JrsFragmentUpdateContextType.h"
#include "Mp7JrsFragmentUpdateContextType_position_LocalType.h"
#include "Mp7JrsFragmentUpdateContextTypeBase.h"
#include "Mp7JrsFragmentUpdatePayloadType.h"
#include "Mp7JrsFragmentUpdateUnitType.h"
#include "Mp7JrsFrequencyTreeType.h"
#include "Mp7JrsFrequencyTreeType_CollectionType.h"
#include "Mp7JrsFrequencyTreeType_LocalType.h"
#include "Mp7JrsFrequencyViewType.h"
#include "Mp7JrsGammaDistributionType.h"
#include "Mp7JrsGaussianDistributionType.h"
#include "Mp7JrsGaussianMixtureModelType.h"
#include "Mp7JrsGaussianMixtureModelType_CollectionType.h"
#include "Mp7JrsGaussianMixtureModelType_LocalType.h"
#include "Mp7JrsGeneralizedGaussianDistributionType.h"
#include "Mp7JrsGeographicPointType.h"
#include "Mp7JrsGeographicPointType_latitude_LocalType.h"
#include "Mp7JrsGeographicPointType_longitude_LocalType.h"
#include "Mp7JrsGeometricDistributionType.h"
#include "Mp7JrsGlobalTransitionType.h"
#include "Mp7JrsGoFGoPColorType.h"
#include "Mp7JrsGoFGoPColorType_aggregation_LocalType.h"
#include "Mp7JrsGofGopFeatureType.h"
#include "Mp7JrsGofGopFeatureType_aggregation_LocalType.h"
#include "Mp7JrsGraphicalClassificationSchemeType.h"
#include "Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionType.h"
#include "Mp7JrsGraphicalRuleDefinitionType.h"
#include "Mp7JrsGraphicalTermDefinitionType.h"
#include "Mp7JrsGraphType.h"
#include "Mp7JrsGraphType_CollectionType.h"
#include "Mp7JrsGraphType_LocalType.h"
#include "Mp7JrsGraphType_Node_LocalType.h"
#include "Mp7JrsGridLayoutType.h"
#include "Mp7JrsGridLayoutType_Descriptor_CollectionType.h"
#include "Mp7JrsGridLayoutType_descriptorMask_LocalType.h"
#include "Mp7JrsHandWritingRecogInformationType.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionType.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalType.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalType.h"
#include "Mp7JrsHandWritingRecogInformationType_Recognizer_LocalType.h"
#include "Mp7JrsHandWritingRecogResultType.h"
#include "Mp7JrsHandWritingRecogResultType_Result_CollectionType.h"
#include "Mp7JrsHandWritingRecogResultType_Result_LocalType.h"
#include "Mp7JrsHarmonicInstrumentTimbreType.h"
#include "Mp7JrsHarmonicSpectralCentroidType.h"
#include "Mp7JrsHarmonicSpectralDeviationType.h"
#include "Mp7JrsHarmonicSpectralSpreadType.h"
#include "Mp7JrsHarmonicSpectralVariationType.h"
#include "Mp7JrsHeaderType.h"
#include "Mp7JrsHierarchicalSummaryType.h"
#include "Mp7JrsHierarchicalSummaryType_CollectionType.h"
#include "Mp7JrsHierarchicalSummaryType_components_CollectionType.h"
#include "Mp7JrsHierarchicalSummaryType_components_LocalType.h"
#include "Mp7JrsHierarchicalSummaryType_hierarchy_LocalType.h"
#include "Mp7JrsHierarchicalSummaryType_LocalType.h"
#include "Mp7JrsHistogramProbabilityType.h"
#include "Mp7JrsHomogeneousTextureType.h"
#include "Mp7JrsHyperGeometricDistributionType.h"
#include "Mp7JrsIlluminationInvariantColorType.h"
#include "Mp7JrsImageLocatorType.h"
#include "Mp7JrsImageLocatorType_BytePosition_LocalType.h"
#include "Mp7JrsImageTextType.h"
#include "Mp7JrsImageTextType_textType_LocalType.h"
#include "Mp7JrsImageTextType_textType_LocalType0.h"
#include "Mp7JrsImageTextType_textType_LocalType1.h"
#include "Mp7JrsImageTextType_textType_LocalType2.h"
#include "Mp7JrsImageType.h"
#include "Mp7JrsIncrDurationType.h"
#include "Mp7JrsInkContentType.h"
#include "Mp7JrsInkMediaInformationType.h"
#include "Mp7JrsInkMediaInformationType_Brush_CollectionType.h"
#include "Mp7JrsInkMediaInformationType_Brush_LocalType.h"
#include "Mp7JrsInkMediaInformationType_Handedness_LocalType.h"
#include "Mp7JrsInkMediaInformationType_InputDevice_LocalType.h"
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionType.h"
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_LocalType.h"
#include "Mp7JrsInkMediaInformationType_Param_CollectionType.h"
#include "Mp7JrsInkMediaInformationType_Param_LocalType.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType0.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType1.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType2.h"
#include "Mp7JrsInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionType.h"
#include "Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalType.h"
#include "Mp7JrsInkSegmentSpatialDecompositionType.h"
#include "Mp7JrsInkSegmentSpatialDecompositionType_CollectionType.h"
#include "Mp7JrsInkSegmentSpatialDecompositionType_LocalType.h"
#include "Mp7JrsInkSegmentTemporalDecompositionType.h"
#include "Mp7JrsInkSegmentTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsInkSegmentTemporalDecompositionType_LocalType.h"
#include "Mp7JrsInkSegmentType.h"
#include "Mp7JrsInkSegmentType_CollectionType.h"
#include "Mp7JrsInkSegmentType_CollectionType0.h"
#include "Mp7JrsInkSegmentType_CollectionType1.h"
#include "Mp7JrsInkSegmentType_LocalType.h"
#include "Mp7JrsInkSegmentType_LocalType0.h"
#include "Mp7JrsInkSegmentType_LocalType1.h"
#include "Mp7JrsInkSegmentType_type_LocalType.h"
#include "Mp7JrsInlineMediaType.h"
#include "Mp7JrsInlineTermDefinitionType.h"
#include "Mp7JrsInlineTermDefinitionType_Definition_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_LocalType.h"
#include "Mp7JrsInstrumentTimbreType.h"
#include "Mp7JrsIntegerDiagonalMatrixType.h"
#include "Mp7JrsIntegerMatrixType.h"
#include "Mp7JrsintegerVector.h"
#include "Mp7JrsInternalTransitionType.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType.h"
#include "Mp7JrsIntraCompositionShotType.h"
#include "Mp7JrsIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionType.h"
#include "Mp7JrsIrregularVisualTimeSeriesType.h"
#include "Mp7JrsIrregularVisualTimeSeriesType_CollectionType.h"
#include "Mp7JrsIrregularVisualTimeSeriesType_LocalType.h"
#include "Mp7JrsKeyType.h"
#include "Mp7JrsKeyType_KeyNote_LocalType.h"
#include "Mp7JrsKeywordAnnotationType.h"
#include "Mp7JrsKeywordAnnotationType_Keyword_CollectionType.h"
#include "Mp7JrsKeywordAnnotationType_Keyword_LocalType.h"
#include "Mp7JrsKeywordAnnotationType_Keyword_type_LocalType.h"
#include "Mp7JrsLexiconType.h"
#include "Mp7JrsLinguisticDocumentType.h"
#include "Mp7JrsLinguisticDocumentType_CollectionType.h"
#include "Mp7JrsLinguisticDocumentType_LocalType.h"
#include "Mp7JrsLinguisticEntityType.h"
#include "Mp7JrsLinguisticEntityType_edit_LocalType.h"
#include "Mp7JrsLinguisticEntityType_length_LocalType.h"
#include "Mp7JrsLinguisticEntityType_MediaLocator_CollectionType.h"
#include "Mp7JrsLinguisticEntityType_Relation_CollectionType.h"
#include "Mp7JrsLinguisticEntityType_start_LocalType.h"
#include "Mp7JrsLinguisticType.h"
#include "Mp7JrslistOfPositiveIntegerForDim.h"
#include "Mp7JrsLogAttackTimeType.h"
#include "Mp7JrsLogicalUnitLocatorType.h"
#include "Mp7JrsLogicalUnitLocatorType_CollectionType.h"
#include "Mp7JrsLogicalUnitLocatorType_LocalType.h"
#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionType.h"
#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType.h"
#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0.h"
#include "Mp7JrsLogicalUnitLocatorType_ReferenceUnit_CollectionType.h"
#include "Mp7JrsLogicalUnitLocatorType_ReferenceUnit_LocalType.h"
#include "Mp7JrsLogicalUnitLocatorType_ReferenceUnit_LocalType0.h"
#include "Mp7JrsLognormalDistributionType.h"
#include "Mp7JrsMaskType.h"
#include "Mp7JrsMatchingHintType.h"
#include "Mp7JrsMatchingHintType_Hint_CollectionType.h"
#include "Mp7JrsMatchingHintType_Hint_LocalType.h"
#include "Mp7JrsMediaAgentType.h"
#include "Mp7JrsMediaDescriptionType.h"
#include "Mp7JrsMediaDescriptionType_MediaInformation_CollectionType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsMediaFormatType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType0.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType1.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2.h"
#include "Mp7JrsMediaFormatType_AudioCoding_LocalType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType.h"
#include "Mp7JrsMediaFormatType_BitRate_LocalType.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType0.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType1.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType2.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType0.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType1.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType2.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_LocalType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_LocalType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalType.h"
#include "Mp7JrsMediaIdentificationType.h"
#include "Mp7JrsMediaIdentificationType_AudioDomain_CollectionType.h"
#include "Mp7JrsMediaIdentificationType_ImageDomain_CollectionType.h"
#include "Mp7JrsMediaIdentificationType_VideoDomain_CollectionType.h"
#include "Mp7JrsMediaIncrDurationType.h"
#include "Mp7JrsMediaInformationType.h"
#include "Mp7JrsMediaInformationType_MediaProfile_CollectionType.h"
#include "Mp7JrsMediaInstanceType.h"
#include "Mp7JrsMediaLocatorType.h"
#include "Mp7JrsMediaProfileType.h"
#include "Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionType.h"
#include "Mp7JrsMediaProfileType_MediaInstance_CollectionType.h"
#include "Mp7JrsMediaQualityType.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionType.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_LocalType.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionType.h"
#include "Mp7JrsMediaQualityType_QualityRating_CollectionType.h"
#include "Mp7JrsMediaQualityType_QualityRating_LocalType.h"
#include "Mp7JrsMediaQualityType_QualityRating_type_LocalType.h"
#include "Mp7JrsMediaQualityType_RatingInformationLocator_CollectionType.h"
#include "Mp7JrsMediaRelIncrTimePointType.h"
#include "Mp7JrsMediaRelTimePointType.h"
#include "Mp7JrsMediaReviewType.h"
#include "Mp7JrsMediaReviewType_FreeTextReview_CollectionType.h"
#include "Mp7JrsMediaSourceSegmentDecompositionType.h"
#include "Mp7JrsMediaSpaceMaskType.h"
#include "Mp7JrsMediaSpaceMaskType_SubInterval_CollectionType.h"
#include "Mp7JrsMediaSpaceMaskType_SubInterval_LocalType.h"
#include "Mp7JrsmediaTimeOffsetType.h"
#include "Mp7JrsmediaTimePointType.h"
#include "Mp7JrsMediaTimeType.h"
#include "Mp7JrsMediaTranscodingHintsType.h"
#include "Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType.h"
#include "Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType.h"
#include "Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalType.h"
#include "Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType.h"
#include "Mp7JrsMelodyContourType.h"
#include "Mp7JrsMelodySequenceType.h"
#include "Mp7JrsMelodySequenceType_NoteArray_CollectionType.h"
#include "Mp7JrsMelodySequenceType_NoteArray_LocalType.h"
#include "Mp7JrsMelodySequenceType_NoteArray_Note_CollectionType.h"
#include "Mp7JrsMelodySequenceType_NoteArray_Note_LocalType.h"
#include "Mp7JrsMelodySequenceType_StartingNote_LocalType.h"
#include "Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType.h"
#include "Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType.h"
#include "Mp7JrsMelodyType.h"
#include "Mp7JrsMelodyType_MelodySequence_CollectionType.h"
#include "Mp7JrsMeterType.h"
#include "Mp7JrsMeterType_Denominator_LocalType.h"
#include "Mp7JrsMeterType_Numerator_LocalType.h"
#include "Mp7JrsmimeType.h"
#include "Mp7JrsMinusOneToOneMatrixType.h"
#include "Mp7JrsminusOneToOneType.h"
#include "Mp7JrsminusOneToOneVector.h"
#include "Mp7JrsminusOneToOneVector_LocalType.h"
#include "Mp7JrsMixedCollectionType.h"
#include "Mp7JrsMixedCollectionType_CollectionType.h"
#include "Mp7JrsMixedCollectionType_CollectionType0.h"
#include "Mp7JrsMixedCollectionType_CollectionType1.h"
#include "Mp7JrsMixedCollectionType_CollectionType2.h"
#include "Mp7JrsMixedCollectionType_Descriptor_CollectionType.h"
#include "Mp7JrsMixedCollectionType_LocalType.h"
#include "Mp7JrsMixedCollectionType_LocalType0.h"
#include "Mp7JrsMixedCollectionType_LocalType1.h"
#include "Mp7JrsMixedCollectionType_LocalType2.h"
#include "Mp7JrsMixtureAmountOfMotionType.h"
#include "Mp7JrsMixtureCameraMotionSegmentType.h"
#include "Mp7JrsModelDescriptionType.h"
#include "Mp7JrsModelDescriptionType_Model_CollectionType.h"
#include "Mp7JrsModelStateType.h"
#include "Mp7JrsModelType.h"
#include "Mp7JrsMorphismGraphType.h"
#include "Mp7JrsMosaicType.h"
#include "Mp7JrsMosaicType_WarpingParam_CollectionType.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalType.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalType0.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType0.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType1.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType2.h"
#include "Mp7JrsMotionActivityType.h"
#include "Mp7JrsMotionActivityType_Intensity_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_CollectionType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_CollectionType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_CollectionType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_CollectionType.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalType.h"
#include "Mp7JrsMotionActivityType_TemporalParams_CollectionType.h"
#include "Mp7JrsMotionActivityType_TemporalParams_LocalType.h"
#include "Mp7JrsMotionTrajectoryType.h"
#include "Mp7JrsMotionTrajectoryType_CoordDef_LocalType.h"
#include "Mp7JrsMotionTrajectoryType_CoordDef_Repr_LocalType.h"
#include "Mp7JrsMotionTrajectoryType_CoordDef_units_LocalType.h"
#include "Mp7JrsMotionTrajectoryType_CoordRef_LocalType.h"
#include "Mp7JrsMovingRegionFeatureType.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionType.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionType_CollectionType.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsMovingRegionSpatialDecompositionType.h"
#include "Mp7JrsMovingRegionSpatialDecompositionType_CollectionType.h"
#include "Mp7JrsMovingRegionSpatialDecompositionType_LocalType.h"
#include "Mp7JrsMovingRegionSpatioTemporalDecompositionType.h"
#include "Mp7JrsMovingRegionSpatioTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsMovingRegionSpatioTemporalDecompositionType_LocalType.h"
#include "Mp7JrsMovingRegionTemporalDecompositionType.h"
#include "Mp7JrsMovingRegionTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsMovingRegionTemporalDecompositionType_LocalType.h"
#include "Mp7JrsMovingRegionType.h"
#include "Mp7JrsMovingRegionType_CollectionType.h"
#include "Mp7JrsMovingRegionType_CollectionType0.h"
#include "Mp7JrsMovingRegionType_LocalType.h"
#include "Mp7JrsMovingRegionType_LocalType0.h"
#include "Mp7JrsMpeg7_Description_CollectionType.h"
#include "Mp7JrsMpeg7_LocalType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsMpeg7Type.h"
#include "Mp7JrsMultimediaCollectionType.h"
#include "Mp7JrsMultimediaCollectionType_Collection_CollectionType.h"
#include "Mp7JrsMultimediaCollectionType_StructuredCollection_CollectionType.h"
#include "Mp7JrsMultimediaContentType.h"
#include "Mp7JrsMultimediaSegmentMediaSourceDecompositionType.h"
#include "Mp7JrsMultimediaSegmentMediaSourceDecompositionType_CollectionType.h"
#include "Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsMultimediaSegmentType.h"
#include "Mp7JrsMultimediaSegmentType_MediaSourceDecomposition_CollectionType.h"
#include "Mp7JrsMultimediaType.h"
#include "Mp7JrsMultipleViewType.h"
#include "Mp7JrsMultipleViewType_CollectionType.h"
#include "Mp7JrsMultipleViewType_LocalType.h"
#include "Mp7JrsMultiResolutionPyramidType.h"
#include "Mp7JrsNameComponentType.h"
#include "Mp7JrsNonDependencyStructurePhraseType.h"
#include "Mp7JrsNonDependencyStructurePhraseType_CollectionType.h"
#include "Mp7JrsNonDependencyStructurePhraseType_LocalType.h"
#include "Mp7JrsNonDependencyStructurePhraseType_synthesis_LocalType.h"
#include "Mp7JrsNonMixtureAmountOfMotionType.h"
#include "Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType.h"
#include "Mp7JrsNonMixtureCameraMotionSegmentType.h"
#include "Mp7JrsnonNegativeReal.h"
#include "Mp7JrsObjectType.h"
#include "Mp7JrsObjectType_CollectionType.h"
#include "Mp7JrsObjectType_LocalType.h"
#include "Mp7JrsOrderedGroupDataSetMaskType.h"
#include "Mp7JrsOrderedGroupDataSetMaskType_SubInterval_CollectionType.h"
#include "Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalType.h"
#include "Mp7JrsOrderingKeyType.h"
#include "Mp7JrsOrderingKeyType_direction_LocalType.h"
#include "Mp7JrsOrderingKeyType_Field_CollectionType.h"
#include "Mp7JrsOrderingKeyType_Field_LocalType.h"
#include "Mp7JrsOrderingKeyType_Selector_LocalType.h"
#include "Mp7JrsOrganizationType.h"
#include "Mp7JrsOrganizationType_CollectionType.h"
#include "Mp7JrsOrganizationType_LocalType.h"
#include "Mp7JrsOrganizationType_Name_CollectionType.h"
#include "Mp7JrsOrganizationType_Name_LocalType.h"
#include "Mp7JrsOrganizationType_Name_type_LocalType.h"
#include "Mp7JrsOrganizationType_NameTerm_CollectionType.h"
#include "Mp7JrsOrganizationType_NameTerm_LocalType.h"
#include "Mp7JrsOrganizationType_NameTerm_type_LocalType.h"
#include "Mp7JrsPackageType.h"
#include "Mp7JrsPackageType_CollectionType.h"
#include "Mp7JrsPackageType_LocalType.h"
#include "Mp7JrsPackageType_Scheme_LocalType.h"
#include "Mp7JrspaddingType.h"
#include "Mp7JrspaddingType_LocalType.h"
#include "Mp7JrspaddingType_LocalType0.h"
#include "Mp7JrspaddingType_LocalType1.h"
#include "Mp7JrsParameterTrajectoryType.h"
#include "Mp7JrsParameterTrajectoryType_motionModel_LocalType.h"
#include "Mp7JrsParametricMotionType.h"
#include "Mp7JrsParametricMotionType_CoordDef_LocalType.h"
#include "Mp7JrsParametricMotionType_CoordRef_LocalType.h"
#include "Mp7JrsParametricMotionType_motionModel_LocalType.h"
#include "Mp7JrsParametricMotionType_Parameters_LocalType.h"
#include "Mp7JrsParentalGuidanceType.h"
#include "Mp7JrsParentalGuidanceType_Region_CollectionType.h"
#include "Mp7JrsPartitionType.h"
#include "Mp7JrsPartitionType_dim_LocalType.h"
#include "Mp7JrsPercussiveInstrumentTimbreType.h"
#include "Mp7JrsPersonGroupType.h"
#include "Mp7JrsPersonGroupType_CollectionType.h"
#include "Mp7JrsPersonGroupType_LocalType.h"
#include "Mp7JrsPersonGroupType_Name_CollectionType.h"
#include "Mp7JrsPersonGroupType_Name_LocalType.h"
#include "Mp7JrsPersonGroupType_Name_type_LocalType.h"
#include "Mp7JrsPersonGroupType_NameTerm_CollectionType.h"
#include "Mp7JrsPersonGroupType_NameTerm_LocalType.h"
#include "Mp7JrsPersonGroupType_NameTerm_type_LocalType.h"
#include "Mp7JrsPersonNameType.h"
#include "Mp7JrsPersonNameType_CollectionType.h"
#include "Mp7JrsPersonNameType_LocalType.h"
#include "Mp7JrsPersonNameType_type_LocalType.h"
#include "Mp7JrsPersonType.h"
#include "Mp7JrsPersonType_Affiliation_CollectionType.h"
#include "Mp7JrsPersonType_Affiliation_LocalType.h"
#include "Mp7JrsPersonType_Citizenship_CollectionType.h"
#include "Mp7JrsPersonType_CollectionType.h"
#include "Mp7JrsPersonType_ElectronicAddress_CollectionType.h"
#include "Mp7JrsPersonType_LocalType.h"
#include "Mp7JrsPhoneLexiconIndexType.h"
#include "Mp7JrsPhoneLexiconType.h"
#include "Mp7JrsPhoneLexiconType_Token_CollectionType.h"
#include "Mp7JrsphoneticAlphabetType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionType.h"
#include "Mp7JrsPhoneType.h"
#include "Mp7JrsPlaceType.h"
#include "Mp7JrsPlaceType_AdministrativeUnit_CollectionType.h"
#include "Mp7JrsPlaceType_AdministrativeUnit_LocalType.h"
#include "Mp7JrsPlaceType_AstronomicalBody_CollectionType.h"
#include "Mp7JrsPlaceType_ElectronicAddress_CollectionType.h"
#include "Mp7JrsPlaceType_GeographicPosition_LocalType.h"
#include "Mp7JrsPlaceType_Name_CollectionType.h"
#include "Mp7JrsPlaceType_NameTerm_CollectionType.h"
#include "Mp7JrsPlaceType_PlaceDescription_CollectionType.h"
#include "Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionType.h"
#include "Mp7JrsPlaceType_PostalAddress_LocalType.h"
#include "Mp7JrsPlaceType_Region_CollectionType.h"
#include "Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType.h"
#include "Mp7JrsPlaceType_StructuredPostalAddress_LocalType.h"
#include "Mp7JrsPointOfViewType.h"
#include "Mp7JrsPointOfViewType_Importance_CollectionType.h"
#include "Mp7JrsPointOfViewType_Importance_LocalType.h"
#include "Mp7JrsPoissonDistributionType.h"
#include "Mp7JrsPositionType.h"
#include "Mp7JrsPreferenceConditionType.h"
#include "Mp7JrsPreferenceConditionType_Time_CollectionType.h"
#include "Mp7JrsPreferenceConditionType_Time_LocalType.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType0.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType2.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsProbabilityClassificationModelType.h"
#include "Mp7JrsProbabilityClassificationModelType_ProbabilityModelClass_CollectionType.h"
#include "Mp7JrsProbabilityDistributionType.h"
#include "Mp7JrsProbabilityDistributionType_Cumulant_CollectionType.h"
#include "Mp7JrsProbabilityDistributionType_Cumulant_LocalType.h"
#include "Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalType.h"
#include "Mp7JrsProbabilityDistributionType_Moment_CollectionType.h"
#include "Mp7JrsProbabilityDistributionType_Moment_LocalType.h"
#include "Mp7JrsProbabilityDistributionType_Moment_Value_LocalType.h"
#include "Mp7JrsProbabilityMatrixType.h"
#include "Mp7JrsProbabilityModelClassType.h"
#include "Mp7JrsProbabilityModelClassType_CollectionType.h"
#include "Mp7JrsProbabilityModelClassType_LocalType.h"
#include "Mp7JrsProbabilityModelType.h"
#include "Mp7JrsprobabilityVector.h"
#include "Mp7JrsprobabilityVector_LocalType.h"
#include "Mp7JrsPullbackDefinitionType.h"
#include "Mp7JrsPushoutDefinitionType.h"
#include "Mp7JrsRatingType.h"
#include "Mp7JrsRatingType_RatingScheme_LocalType.h"
#include "Mp7JrsRatingType_RatingScheme_style_LocalType.h"
#include "Mp7JrsRecordingPreferencesType.h"
#include "Mp7JrsRecordingPreferencesType_RecordingRequest_CollectionType.h"
#include "Mp7JrsRecordingRequestType.h"
#include "Mp7JrsRecordingRequestType_RecordAssociatedData_LocalType.h"
#include "Mp7JrsRecordingRequestType_RecordAssociatedData_type_LocalType.h"
#include "Mp7JrsRecordingRequestType_RecordAssociatedData_type_LocalType0.h"
#include "Mp7JrsRecordingRequestType_RecordAssociatedData_type_LocalType1.h"
#include "Mp7JrsRecordingRequestType_RecordAssociatedData_type_LocalType2.h"
#include "Mp7JrsRecordingRequestType_RecordingLocationPreferences_CollectionType.h"
#include "Mp7JrsRecordingRequestType_RecordingPeriod_LocalType.h"
#include "Mp7JrsRecordingRequestType_RecordingSourceTypePreferences_CollectionType.h"
#include "Mp7JrsRecordingRequestType_RecordingSourceTypePreferences_LocalType.h"
#include "Mp7JrsRecordingRequestType_RecordingSourceTypePreferences_Summary_CollectionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsregionCode.h"
#include "Mp7JrsRegionLocatorType.h"
#include "Mp7JrsRegionLocatorType_Box_CollectionType.h"
#include "Mp7JrsRegionLocatorType_Box_LocalType.h"
#include "Mp7JrsRegionLocatorType_CoordRef_LocalType.h"
#include "Mp7JrsRegionLocatorType_Polygon_CollectionType.h"
#include "Mp7JrsRegionLocatorType_Polygon_LocalType.h"
#include "Mp7JrsRegionShapeType.h"
#include "Mp7JrsRegionShapeType_MagnitudeOfART_CollectionType.h"
#include "Mp7JrsRegionShapeType_MagnitudeOfART_LocalType.h"
#include "Mp7JrsRegularVisualTimeSeriesType.h"
#include "Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionType.h"
#include "Mp7JrsRelatedMaterialType.h"
#include "Mp7JrsRelationType.h"
#include "Mp7JrsRelativeDelayType.h"
#include "Mp7JrsRelIncrTimePointType.h"
#include "Mp7JrsRelTimePointType.h"
#include "Mp7JrsResolutionViewType.h"
#include "Mp7JrsRightsType.h"
#include "Mp7JrsRightsType_RightsID_CollectionType.h"
#include "Mp7JrsScalableColorType.h"
#include "Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType.h"
#include "Mp7JrsScalableColorType_numOfCoeff_LocalType.h"
#include "Mp7JrsScalableSeriesType.h"
#include "Mp7JrsScalableSeriesType_Scaling_CollectionType.h"
#include "Mp7JrsScalableSeriesType_Scaling_LocalType.h"
#include "Mp7JrsscaleType.h"
#include "Mp7JrsSceneGraphMaskType.h"
#include "Mp7JrsSceneGraphMaskType_CollectionType.h"
#include "Mp7JrsSceneGraphMaskType_LocalType.h"
#include "Mp7JrsSchemaReferenceType.h"
#include "Mp7JrsSegmentCollectionType.h"
#include "Mp7JrsSegmentCollectionType_CollectionType.h"
#include "Mp7JrsSegmentCollectionType_CollectionType0.h"
#include "Mp7JrsSegmentCollectionType_LocalType.h"
#include "Mp7JrsSegmentCollectionType_LocalType0.h"
#include "Mp7JrsSegmentDecompositionType.h"
#include "Mp7JrsSegmentType.h"
#include "Mp7JrsSegmentType_CollectionType.h"
#include "Mp7JrsSegmentType_LocalType.h"
#include "Mp7JrsSegmentType_MatchingHint_CollectionType.h"
#include "Mp7JrsSegmentType_PointOfView_CollectionType.h"
#include "Mp7JrsSegmentType_Relation_CollectionType.h"
#include "Mp7JrsSegmentType_TextAnnotation_CollectionType.h"
#include "Mp7JrsSegmentType_TextAnnotation_LocalType.h"
#include "Mp7JrsSegmentType_TextAnnotation_type_LocalType.h"
#include "Mp7JrsSemanticBagType.h"
#include "Mp7JrsSemanticBagType_CollectionType.h"
#include "Mp7JrsSemanticBagType_Graph_CollectionType.h"
#include "Mp7JrsSemanticBagType_LocalType.h"
#include "Mp7JrsSemanticBaseType.h"
#include "Mp7JrsSemanticBaseType_Label_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_LocalType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType0.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType1.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType2.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType.h"
#include "Mp7JrsSemanticBaseType_Property_CollectionType.h"
#include "Mp7JrsSemanticBaseType_Relation_CollectionType.h"
#include "Mp7JrsSemanticDescriptionType.h"
#include "Mp7JrsSemanticDescriptionType_ConceptCollection_CollectionType.h"
#include "Mp7JrsSemanticDescriptionType_Semantics_CollectionType.h"
#include "Mp7JrsSemanticPlaceType.h"
#include "Mp7JrsSemanticPlaceType_SemanticPlaceInterval_CollectionType.h"
#include "Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalType.h"
#include "Mp7JrsSemanticStateType.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_CollectionType.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_CollectionType0.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalType.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalType0.h"
#include "Mp7JrsSemanticTimeType.h"
#include "Mp7JrsSemanticTimeType_SemanticTimeInterval_CollectionType.h"
#include "Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalType.h"
#include "Mp7JrsSemanticType.h"
#include "Mp7JrsSentencesType.h"
#include "Mp7JrsSentencesType_CollectionType.h"
#include "Mp7JrsSentencesType_LocalType.h"
#include "Mp7JrsSequentialSummaryType.h"
#include "Mp7JrsSequentialSummaryType_AudioSummaryComponent_CollectionType.h"
#include "Mp7JrsSequentialSummaryType_components_CollectionType.h"
#include "Mp7JrsSequentialSummaryType_components_LocalType.h"
#include "Mp7JrsSequentialSummaryType_TextualSummaryComponent_CollectionType.h"
#include "Mp7JrsSequentialSummaryType_VisualSummaryComponent_CollectionType.h"
#include "Mp7JrsSeriesOfScalarBinaryType.h"
#include "Mp7JrsSeriesOfScalarType.h"
#include "Mp7JrsSeriesOfVectorBinaryType.h"
#include "Mp7JrsSeriesOfVectorType.h"
#include "Mp7JrsShape3DType.h"
#include "Mp7JrsShape3DType_Spectrum_CollectionType.h"
#include "Mp7JrsShape3DType_Spectrum_LocalType.h"
#include "Mp7JrsShapeVariationType.h"
#include "Mp7JrsShapeVariationType_DynamicShapeVariation_CollectionType.h"
#include "Mp7JrsShapeVariationType_DynamicShapeVariation_LocalType.h"
#include "Mp7JrsShapeVariationType_StaticShapeVariation_CollectionType.h"
#include "Mp7JrsShapeVariationType_StaticShapeVariation_LocalType.h"
#include "Mp7JrsShapeVariationType_StatisticalVariation_CollectionType.h"
#include "Mp7JrsShapeVariationType_StatisticalVariation_LocalType.h"
#include "Mp7JrsShotEditingTemporalDecompositionType.h"
#include "Mp7JrsShotEditingTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsShotEditingTemporalDecompositionType_LocalType.h"
#include "Mp7JrsShotType.h"
#include "Mp7JrsShotType_AnalyticEditingTemporalDecomposition_CollectionType.h"
#include "Mp7JrsSignalPlaneFractionType.h"
#include "Mp7JrsSignalPlaneOriginType.h"
#include "Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType.h"
#include "Mp7JrsSignalPlaneOriginType_xOrigin_LocalType.h"
#include "Mp7JrsSignalPlaneOriginType_yOrigin_LocalType.h"
#include "Mp7JrsSignalPlaneOriginType_zOrigin_LocalType.h"
#include "Mp7JrsSignalPlaneSampleType.h"
#include "Mp7JrsSignalPlaneType.h"
#include "Mp7JrsSignalPlaneType_dim_LocalType.h"
#include "Mp7JrsSignalType.h"
#include "Mp7JrsSilenceHeaderType.h"
#include "Mp7JrsSilenceType.h"
#include "Mp7JrsSoundClassificationModelType.h"
#include "Mp7JrsSoundClassificationModelType_SoundModel_CollectionType.h"
#include "Mp7JrsSoundModelStateHistogramType.h"
#include "Mp7JrsSoundModelStateHistogramType_CollectionType.h"
#include "Mp7JrsSoundModelStateHistogramType_LocalType.h"
#include "Mp7JrsSoundModelStatePathType.h"
#include "Mp7JrsSoundModelType.h"
#include "Mp7JrsSourcePreferencesType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationDate_CollectionType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationDate_LocalType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationFormat_CollectionType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationFormat_LocalType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationLocation_CollectionType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationLocation_LocalType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationSource_CollectionType.h"
#include "Mp7JrsSourcePreferencesType_DisseminationSource_LocalType.h"
#include "Mp7JrsSourcePreferencesType_Disseminator_CollectionType.h"
#include "Mp7JrsSourcePreferencesType_Disseminator_LocalType.h"
#include "Mp7JrsSourcePreferencesType_MediaFormat_CollectionType.h"
#include "Mp7JrsSourcePreferencesType_MediaFormat_LocalType.h"
#include "Mp7JrsSpaceFrequencyGraphType.h"
#include "Mp7JrsSpaceFrequencyGraphType_CollectionType.h"
#include "Mp7JrsSpaceFrequencyGraphType_CollectionType0.h"
#include "Mp7JrsSpaceFrequencyGraphType_LocalType.h"
#include "Mp7JrsSpaceFrequencyGraphType_LocalType0.h"
#include "Mp7JrsSpaceFrequencyViewType.h"
#include "Mp7JrsSpaceFrequencyViewType_order_LocalType.h"
#include "Mp7JrsSpaceResolutionViewType.h"
#include "Mp7JrsSpaceResolutionViewType_order_LocalType.h"
#include "Mp7JrsSpaceTreeType.h"
#include "Mp7JrsSpaceTreeType_CollectionType.h"
#include "Mp7JrsSpaceTreeType_LocalType.h"
#include "Mp7JrsSpaceViewType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType.h"
#include "Mp7JrsSpatialMaskType.h"
#include "Mp7JrsSpatialMaskType_SubRegion_CollectionType.h"
#include "Mp7JrsSpatialSegmentDecompositionType.h"
#include "Mp7JrsSpatioTemporalLocatorType.h"
#include "Mp7JrsSpatioTemporalLocatorType_CollectionType.h"
#include "Mp7JrsSpatioTemporalLocatorType_CoordRef_LocalType.h"
#include "Mp7JrsSpatioTemporalLocatorType_LocalType.h"
#include "Mp7JrsSpatioTemporalMaskType.h"
#include "Mp7JrsSpatioTemporalMaskType_SubRegion_CollectionType.h"
#include "Mp7JrsSpatioTemporalSegmentDecompositionType.h"
#include "Mp7JrsSpeakerInfoType.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_LocalType.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionType.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionType.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionType.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalType.h"
#include "Mp7JrsSpeakerInfoType_provenance_LocalType.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_LocalType.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionType.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionType.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionType.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_LocalType.h"
#include "Mp7JrsSpectralCentroidType.h"
#include "Mp7JrsSpokenContentHeaderType.h"
#include "Mp7JrsSpokenContentHeaderType_CollectionType.h"
#include "Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionType.h"
#include "Mp7JrsSpokenContentHeaderType_LocalType.h"
#include "Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionType.h"
#include "Mp7JrsSpokenContentIndexEntryType.h"
#include "Mp7JrsSpokenContentLatticeType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_audio_LocalType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_CollectionType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_LocalType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_CollectionType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_LocalType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalType.h"
#include "Mp7JrsSpokenContentLinkType.h"
#include "Mp7JrsStateTransitionModelType.h"
#include "Mp7JrsStateTransitionModelType_State_CollectionType.h"
#include "Mp7JrsStillRegion3DSpatialDecompositionType.h"
#include "Mp7JrsStillRegion3DSpatialDecompositionType_CollectionType.h"
#include "Mp7JrsStillRegion3DSpatialDecompositionType_LocalType.h"
#include "Mp7JrsStillRegion3DType.h"
#include "Mp7JrsStillRegion3DType_CollectionType.h"
#include "Mp7JrsStillRegion3DType_LocalType.h"
#include "Mp7JrsStillRegion3DType_SpatialDecomposition_CollectionType.h"
#include "Mp7JrsStillRegionFeatureType.h"
#include "Mp7JrsStillRegionSpatialDecompositionType.h"
#include "Mp7JrsStillRegionSpatialDecompositionType_CollectionType.h"
#include "Mp7JrsStillRegionSpatialDecompositionType_LocalType.h"
#include "Mp7JrsStillRegionType.h"
#include "Mp7JrsStillRegionType_CollectionType.h"
#include "Mp7JrsStillRegionType_LocalType.h"
#include "Mp7JrsStillRegionType_SpatialDecomposition_CollectionType.h"
#include "Mp7JrsStreamLocatorType.h"
#include "Mp7JrsStreamMaskType.h"
#include "Mp7JrsStreamMaskType_StreamSection_CollectionType.h"
#include "Mp7JrsStreamSectionType.h"
#include "Mp7JrsStructuredAnnotationType.h"
#include "Mp7JrsStructuredAnnotationType_How_CollectionType.h"
#include "Mp7JrsStructuredAnnotationType_WhatAction_CollectionType.h"
#include "Mp7JrsStructuredAnnotationType_WhatObject_CollectionType.h"
#include "Mp7JrsStructuredAnnotationType_When_CollectionType.h"
#include "Mp7JrsStructuredAnnotationType_Where_CollectionType.h"
#include "Mp7JrsStructuredAnnotationType_Who_CollectionType.h"
#include "Mp7JrsStructuredAnnotationType_Why_CollectionType.h"
#include "Mp7JrsStructuredCollectionType.h"
#include "Mp7JrsStructuredCollectionType_CollectionType.h"
#include "Mp7JrsStructuredCollectionType_CollectionType0.h"
#include "Mp7JrsStructuredCollectionType_CollectionType1.h"
#include "Mp7JrsStructuredCollectionType_CollectionType2.h"
#include "Mp7JrsStructuredCollectionType_LocalType.h"
#include "Mp7JrsStructuredCollectionType_LocalType0.h"
#include "Mp7JrsStructuredCollectionType_LocalType1.h"
#include "Mp7JrsStructuredCollectionType_LocalType2.h"
#include "Mp7JrsStructuredCollectionType_Relationships_CollectionType.h"
#include "Mp7JrsSubjectClassificationSchemeType.h"
#include "Mp7JrsSubjectClassificationSchemeType_Term_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Classification_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_LocalType.h"
#include "Mp7JrsSubjectTermDefinitionType_Note_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Note_LocalType.h"
#include "Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Term_LocalType.h"
#include "Mp7JrsSummarizationType.h"
#include "Mp7JrsSummarizationType_Summary_CollectionType.h"
#include "Mp7JrssummaryComponentType.h"
#include "Mp7JrssummaryComponentType_LocalType.h"
#include "Mp7JrssummaryComponentType_LocalType0.h"
#include "Mp7JrssummaryComponentType_LocalType1.h"
#include "Mp7JrsSummaryDescriptionType.h"
#include "Mp7JrsSummaryDescriptionType_Summarization_CollectionType.h"
#include "Mp7JrsSummaryPreferencesType.h"
#include "Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionType.h"
#include "Mp7JrsSummaryPreferencesType_SummaryTheme_LocalType.h"
#include "Mp7JrsSummaryPreferencesType_SummaryType_CollectionType.h"
#include "Mp7JrsSummaryPreferencesType_SummaryType_LocalType.h"
#include "Mp7JrsSummarySegmentGroupType.h"
#include "Mp7JrsSummarySegmentGroupType_Caption_CollectionType.h"
#include "Mp7JrsSummarySegmentGroupType_CollectionType.h"
#include "Mp7JrsSummarySegmentGroupType_CollectionType0.h"
#include "Mp7JrsSummarySegmentGroupType_LocalType.h"
#include "Mp7JrsSummarySegmentGroupType_LocalType0.h"
#include "Mp7JrsSummarySegmentGroupType_Name_CollectionType.h"
#include "Mp7JrsSummarySegmentType.h"
#include "Mp7JrsSummarySegmentType_KeyFrame_CollectionType.h"
#include "Mp7JrsSummarySegmentType_KeySound_CollectionType.h"
#include "Mp7JrsSummarySegmentType_Name_CollectionType.h"
#include "Mp7JrsSummaryThemeListType.h"
#include "Mp7JrsSummaryThemeListType_SummaryTheme_CollectionType.h"
#include "Mp7JrsSummaryThemeListType_SummaryTheme_LocalType.h"
#include "Mp7JrsSummaryType.h"
#include "Mp7JrsSummaryType_Name_CollectionType.h"
#include "Mp7JrsSyntacticConstituentType.h"
#include "Mp7JrsSyntacticConstituentType_CollectionType.h"
#include "Mp7JrsSyntacticConstituentType_LocalType.h"
#include "Mp7JrssynthesisType.h"
#include "Mp7JrsTemporalCentroidType.h"
#include "Mp7JrsTemporalInterpolationType.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_LocalType.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalType.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionType.h"
#include "Mp7JrsTemporalInterpolationType_WholeInterval_LocalType.h"
#include "Mp7JrsTemporalMaskType.h"
#include "Mp7JrsTemporalMaskType_SubInterval_CollectionType.h"
#include "Mp7JrsTemporalSegmentDecompositionType.h"
#include "Mp7JrsTemporalSegmentLocatorType.h"
#include "Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalType.h"
#include "Mp7JrstermAliasReferenceType.h"
#include "Mp7JrsTermDefinitionBaseType.h"
#include "Mp7JrsTermDefinitionBaseType_Definition_CollectionType.h"
#include "Mp7JrsTermDefinitionBaseType_Name_CollectionType.h"
#include "Mp7JrsTermDefinitionBaseType_Name_LocalType.h"
#include "Mp7JrsTermDefinitionType.h"
#include "Mp7JrsTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsTermDefinitionType_Term_LocalType.h"
#include "Mp7JrstermNoteQualifierType.h"
#include "Mp7JrstermNoteQualifierType_LocalType.h"
#include "Mp7JrstermNoteQualifierType_LocalType0.h"
#include "Mp7JrstermNoteQualifierType_LocalType1.h"
#include "Mp7JrstermReferenceListType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrstermRelationQualifierType.h"
#include "Mp7JrstermRelationQualifierType_LocalType.h"
#include "Mp7JrstermRelationQualifierType_LocalType0.h"
#include "Mp7JrstermRelationQualifierType_LocalType1.h"
#include "Mp7JrstermURIReferenceType.h"
#include "Mp7JrsTermUseType.h"
#include "Mp7JrsTextAnnotationType.h"
#include "Mp7JrsTextAnnotationType_CollectionType.h"
#include "Mp7JrsTextAnnotationType_LocalType.h"
#include "Mp7JrsTextDecompositionType.h"
#include "Mp7JrsTextDecompositionType_CollectionType.h"
#include "Mp7JrsTextDecompositionType_LocalType.h"
#include "Mp7JrsTextSegmentType.h"
#include "Mp7JrsTextSegmentType_TextDecomposition_CollectionType.h"
#include "Mp7JrsTextType.h"
#include "Mp7JrsTextualBaseType.h"
#include "Mp7JrsTextualBaseType_phoneticTranscription_CollectionType.h"
#include "Mp7JrsTextualSummaryComponentType.h"
#include "Mp7JrsTextualSummaryComponentType_FreeText_CollectionType.h"
#include "Mp7JrsTextualType.h"
#include "Mp7JrsTextureBrowsingType.h"
#include "Mp7JrsTextureBrowsingType_CollectionType.h"
#include "Mp7JrsTextureBrowsingType_Direction_LocalType.h"
#include "Mp7JrsTextureBrowsingType_LocalType.h"
#include "Mp7JrsTextureBrowsingType_Regularity_LocalType.h"
#include "Mp7JrsTextureBrowsingType_Scale_LocalType.h"
#include "Mp7JrstextureListType.h"
#include "Mp7JrstextureListType_CollectionType.h"
#include "Mp7JrstimeOffsetType.h"
#include "Mp7JrstimePointType.h"
#include "Mp7JrsTimeType.h"
#include "Mp7JrsTitleMediaType.h"
#include "Mp7JrsTitleType.h"
#include "Mp7JrsTitleType_type_LocalType.h"
#include "Mp7JrsTitleType_type_LocalType0.h"
#include "Mp7JrsTitleType_type_LocalType1.h"
#include "Mp7JrsTitleType_type_LocalType2.h"
#include "Mp7JrsTransmissionTechnologyType.h"
#include "Mp7JrsUniqueIDType.h"
#include "Mp7JrsUniqueIDType_encoding_LocalType.h"
#include "Mp7JrsunitType.h"
#include "Mp7Jrsunsigned1.h"
#include "Mp7Jrsunsigned10.h"
#include "Mp7Jrsunsigned11.h"
#include "Mp7Jrsunsigned12.h"
#include "Mp7Jrsunsigned13.h"
#include "Mp7Jrsunsigned14.h"
#include "Mp7Jrsunsigned15.h"
#include "Mp7Jrsunsigned16.h"
#include "Mp7Jrsunsigned17.h"
#include "Mp7Jrsunsigned18.h"
#include "Mp7Jrsunsigned19.h"
#include "Mp7Jrsunsigned2.h"
#include "Mp7Jrsunsigned20.h"
#include "Mp7Jrsunsigned21.h"
#include "Mp7Jrsunsigned22.h"
#include "Mp7Jrsunsigned23.h"
#include "Mp7Jrsunsigned24.h"
#include "Mp7Jrsunsigned25.h"
#include "Mp7Jrsunsigned26.h"
#include "Mp7Jrsunsigned27.h"
#include "Mp7Jrsunsigned28.h"
#include "Mp7Jrsunsigned29.h"
#include "Mp7Jrsunsigned3.h"
#include "Mp7Jrsunsigned30.h"
#include "Mp7Jrsunsigned31.h"
#include "Mp7Jrsunsigned32.h"
#include "Mp7Jrsunsigned4.h"
#include "Mp7Jrsunsigned5.h"
#include "Mp7Jrsunsigned6.h"
#include "Mp7Jrsunsigned7.h"
#include "Mp7Jrsunsigned8.h"
#include "Mp7Jrsunsigned9.h"
#include "Mp7JrsURIFragmentReferenceType.h"
#include "Mp7JrsUsageDescriptionType.h"
#include "Mp7JrsUsageDescriptionType_UsageInformation_CollectionType.h"
#include "Mp7JrsUsageHistoryType.h"
#include "Mp7JrsUsageHistoryType_UserActionHistory_CollectionType.h"
#include "Mp7JrsUsageInformationType.h"
#include "Mp7JrsUsageInformationType_Availability_CollectionType.h"
#include "Mp7JrsUsageInformationType_UsageRecord_CollectionType.h"
#include "Mp7JrsUsageRecordType.h"
#include "Mp7JrsUserActionHistoryType.h"
#include "Mp7JrsUserActionHistoryType_ObservationPeriod_CollectionType.h"
#include "Mp7JrsUserActionHistoryType_UserActionList_CollectionType.h"
#include "Mp7JrsUserActionListType.h"
#include "Mp7JrsUserActionListType_UserAction_CollectionType.h"
#include "Mp7JrsUserActionType.h"
#include "Mp7JrsUserActionType_ActionDataItem_CollectionType.h"
#include "Mp7JrsUserActionType_ActionTime_LocalType.h"
#include "Mp7JrsuserChoiceType.h"
#include "Mp7JrsUserDescriptionType.h"
#include "Mp7JrsUserDescriptionType_UsageHistory_CollectionType.h"
#include "Mp7JrsUserDescriptionType_UserPreferences_CollectionType.h"
#include "Mp7JrsUserIdentifierType.h"
#include "Mp7JrsUserPreferencesType.h"
#include "Mp7JrsUserPreferencesType_BrowsingPreferences_CollectionType.h"
#include "Mp7JrsUserPreferencesType_FilteringAndSearchPreferences_CollectionType.h"
#include "Mp7JrsUserPreferencesType_RecordingPreferences_CollectionType.h"
#include "Mp7JrsVariationDescriptionType.h"
#include "Mp7JrsVariationDescriptionType_Variation_CollectionType.h"
#include "Mp7JrsVariationDescriptionType_VariationSet_CollectionType.h"
#include "Mp7JrsVariationSetType.h"
#include "Mp7JrsVariationSetType_Variation_CollectionType.h"
#include "Mp7JrsVariationType.h"
#include "Mp7JrsVariationType_VariationRelationship_CollectionType.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType0.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType1.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType2.h"
#include "Mp7JrsVideoSegmentFeatureType.h"
#include "Mp7JrsVideoSegmentFeatureType_RepresentativeFeature_CollectionType.h"
#include "Mp7JrsVideoSegmentFeatureType_TemporalTransition_CollectionType.h"
#include "Mp7JrsVideoSegmentMediaSourceDecompositionType.h"
#include "Mp7JrsVideoSegmentMediaSourceDecompositionType_CollectionType.h"
#include "Mp7JrsVideoSegmentMediaSourceDecompositionType_LocalType.h"
#include "Mp7JrsVideoSegmentSpatialDecompositionType.h"
#include "Mp7JrsVideoSegmentSpatialDecompositionType_CollectionType.h"
#include "Mp7JrsVideoSegmentSpatialDecompositionType_LocalType.h"
#include "Mp7JrsVideoSegmentSpatioTemporalDecompositionType.h"
#include "Mp7JrsVideoSegmentSpatioTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsVideoSegmentSpatioTemporalDecompositionType_LocalType.h"
#include "Mp7JrsVideoSegmentTemporalDecompositionType.h"
#include "Mp7JrsVideoSegmentTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsVideoSegmentTemporalDecompositionType_LocalType.h"
#include "Mp7JrsVideoSegmentType.h"
#include "Mp7JrsVideoSegmentType_CollectionType.h"
#include "Mp7JrsVideoSegmentType_CollectionType0.h"
#include "Mp7JrsVideoSegmentType_LocalType.h"
#include "Mp7JrsVideoSegmentType_LocalType0.h"
#include "Mp7JrsVideoSegmentType_Mosaic_CollectionType.h"
#include "Mp7JrsVideoTextType.h"
#include "Mp7JrsVideoTextType_textType_LocalType.h"
#include "Mp7JrsVideoTextType_textType_LocalType0.h"
#include "Mp7JrsVideoTextType_textType_LocalType1.h"
#include "Mp7JrsVideoTextType_textType_LocalType2.h"
#include "Mp7JrsVideoType.h"
#include "Mp7JrsVideoViewGraphType.h"
#include "Mp7JrsVideoViewGraphType_CollectionType.h"
#include "Mp7JrsVideoViewGraphType_CollectionType0.h"
#include "Mp7JrsVideoViewGraphType_LocalType.h"
#include "Mp7JrsVideoViewGraphType_LocalType0.h"
#include "Mp7JrsViewDecompositionType.h"
#include "Mp7JrsViewDescriptionType.h"
#include "Mp7JrsViewDescriptionType_View_CollectionType.h"
#include "Mp7JrsViewDescriptionType_ViewDecomposition_CollectionType.h"
#include "Mp7JrsViewDescriptionType_ViewSet_CollectionType.h"
#include "Mp7JrsViewSetType.h"
#include "Mp7JrsViewSetType_CollectionType.h"
#include "Mp7JrsViewSetType_LocalType.h"
#include "Mp7JrsViewSetType_setProperty_LocalType.h"
#include "Mp7JrsViewSetType_setProperty_LocalType0.h"
#include "Mp7JrsViewSetType_setProperty_LocalType1.h"
#include "Mp7JrsViewSetType_setProperty_LocalType2.h"
#include "Mp7JrsViewType.h"
#include "Mp7JrsVisualDSType.h"
#include "Mp7JrsVisualDType.h"
#include "Mp7JrsVisualSummaryComponentType.h"
#include "Mp7JrsVisualTimeSeriesType.h"
#include "Mp7JrsWordFormType.h"
#include "Mp7JrsWordFormType_terms_CollectionType.h"
#include "Mp7JrsWordFormType_type_CollectionType.h"
#include "Mp7JrsWordFormType_type_LocalType.h"
#include "Mp7JrsWordFormType_type_LocalType0.h"
#include "Mp7JrsWordFormType_type_LocalType1.h"
#include "Mp7JrsWordFormType_type_LocalType2.h"
#include "Mp7JrsWordLexiconIndexType.h"
#include "Mp7JrsWordLexiconType.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType0.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType1.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType2.h"
#include "Mp7JrsWordLexiconType_Token_LocalType.h"
#include "Mp7JrsWordLexiconType_Token_representation_LocalType.h"
#include "Mp7JrsWordType.h"
#include "Mp7JrsxPathAbsoluteSelectorType.h"
#include "Mp7JrsxPathFieldType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsxPathSelectorType.h"
#include "Mp7JrsxPathType.h"
#include "Mp7JrszeroToOneType.h"

#endif // MP7JRSEVERYTHING_INCLUDED_H
