/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _955MP7JRSFRAGMENTUPDATECONTEXTTYPE_H
#define _955MP7JRSFRAGMENTUPDATECONTEXTTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsFragmentUpdateContextTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsFragmentUpdateContextType_ExtInclude.h


#include "Mp7JrsFragmentUpdateContextType_position_LocalType.h"
#include "Mp7JrsFragmentUpdateContextTypeBase.h"
class IMp7JrsFragmentUpdateContextType;
typedef Mp7JrsPtr< IMp7JrsFragmentUpdateContextType> Mp7JrsFragmentUpdateContextPtr;

/** 
 * Generated interface IMp7JrsFragmentUpdateContextType for class Mp7JrsFragmentUpdateContextType<br>
 * Located at: mpeg7-v2.xsd, line 105<br>
 * Classified: Class<br>
 * Derived from: FragmentUpdateContextTypeBase (Pattern)<br>
 */
class MP7JRS_EXPORT IMp7JrsFragmentUpdateContextType 
 :
		public IMp7JrsFragmentUpdateContextTypeBase
{
public:
	// TODO: make these protected?
	IMp7JrsFragmentUpdateContextType();
	virtual ~IMp7JrsFragmentUpdateContextType();
	/**
	 * Get position attribute.
	 * @return Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration
	 */
	virtual Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration Getposition() const = 0;

	/**
	 * Get position attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existposition() const = 0;

	/**
	 * Set position attribute.
	 * @param item Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration
	 */
	virtual void Setposition(Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate position attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateposition() = 0;

	/**
	 * Get Content element.
<br>
	 * (Inherited from Mp7JrsFragmentUpdateContextTypeBase)
	 * @return XMLCh *
	 */
	virtual XMLCh * GetContent() const = 0;

	/**
	 * Set Content element.
<br>
	 * (Inherited from Mp7JrsFragmentUpdateContextTypeBase)
	 * @param item XMLCh *
	 */
	// Mandatory			
	virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Gets or creates Mp7JrsNodePtr child elements of FragmentUpdateContextType.
	 * Currently just supports rudimentary XPath expressions as FragmentUpdateContextType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

	
// no includefile for extension defined 
// file Mp7JrsFragmentUpdateContextType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsFragmentUpdateContextType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsFragmentUpdateContextType<br>
 * Located at: mpeg7-v2.xsd, line 105<br>
 * Classified: Class<br>
 * Derived from: FragmentUpdateContextTypeBase (Pattern)<br>
 * Defined in mpeg7-v2.xsd, line 105.<br>
 */
class MP7JRS_EXPORT Mp7JrsFragmentUpdateContextType :
		public IMp7JrsFragmentUpdateContextType
{
	friend class Mp7JrsFragmentUpdateContextTypeFactory; // constructs objects

public:
	/*
	 * Retrieves the base class of Mp7JrsFragmentUpdateContextType
	 
	 * @return Mp7JrsPtr< Mp7JrsFragmentUpdateContextTypeBase >
	 */
	virtual Mp7JrsPtr< Mp7JrsFragmentUpdateContextTypeBase > GetBase() const;
	/*
	 * Get position attribute.
	 * @return Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration
	 */
	virtual Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration Getposition() const;

	/*
	 * Get position attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existposition() const;

	/*
	 * Set position attribute.
	 * @param item Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration
	 */
	virtual void Setposition(Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate position attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateposition();

	/*
	 * Get Content element.
<br>
	 * (Inherited from Mp7JrsFragmentUpdateContextTypeBase)
	 * @return XMLCh *
	 */
	virtual XMLCh * GetContent() const;

	/*
	 * Set Content element.
<br>
	 * (Inherited from Mp7JrsFragmentUpdateContextTypeBase)
	 * @param item XMLCh *
	 */
	// Mandatory			
	virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Gets or creates Mp7JrsNodePtr child elements of FragmentUpdateContextType.
	 * Currently just supports rudimentary XPath expressions as FragmentUpdateContextType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

	

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool ContentFromString(const XMLCh * const txt);

	/* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
	 * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
	 */
	virtual XMLCh * ContentToString() const;


	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsFragmentUpdateContextType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsFragmentUpdateContextType();

protected:
	Mp7JrsFragmentUpdateContextType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration m_position;
	bool m_position_Exist;
	Mp7JrsFragmentUpdateContextType_position_LocalType::Enumeration m_position_Default;

	// Base Pattern
	Mp7JrsPtr< Mp7JrsFragmentUpdateContextTypeBase > m_Base;


// no includefile for extension defined 
// file Mp7JrsFragmentUpdateContextType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _955MP7JRSFRAGMENTUPDATECONTEXTTYPE_H

