/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1267MP7JRSMEDIAFORMATTYPE_AUDIOCODING_AUDIOCHANNELS_LOCALTYPE_H
#define _1267MP7JRSMEDIAFORMATTYPE_AUDIOCODING_AUDIOCHANNELS_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType_ExtInclude.h


class IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType> Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr;

/** 
 * Generated interface IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType for class Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 5134<br>
 * Classified: Class<br>
 * Derived from: nonNegativeInteger (Value)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType 
 :
		public Mp7JrsNode
{
public:
	// TODO: make these protected?
	IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType();
	virtual ~IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType();
	/**
	 * Sets the content of Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType	 * @param item unsigned
	 */
	virtual void SetContent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Retrieves the content of Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType 
	 * @return unsigned
	 */
	virtual unsigned GetContent() const = 0;

	/**
	 * Get front attribute.
	 * @return unsigned
	 */
	virtual unsigned Getfront() const = 0;

	/**
	 * Get front attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existfront() const = 0;

	/**
	 * Set front attribute.
	 * @param item unsigned
	 */
	virtual void Setfront(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate front attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatefront() = 0;

	/**
	 * Get side attribute.
	 * @return unsigned
	 */
	virtual unsigned Getside() const = 0;

	/**
	 * Get side attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existside() const = 0;

	/**
	 * Set side attribute.
	 * @param item unsigned
	 */
	virtual void Setside(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate side attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateside() = 0;

	/**
	 * Get rear attribute.
	 * @return unsigned
	 */
	virtual unsigned Getrear() const = 0;

	/**
	 * Get rear attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existrear() const = 0;

	/**
	 * Set rear attribute.
	 * @param item unsigned
	 */
	virtual void Setrear(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate rear attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidaterear() = 0;

	/**
	 * Get lfe attribute.
	 * @return unsigned
	 */
	virtual unsigned Getlfe() const = 0;

	/**
	 * Get lfe attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existlfe() const = 0;

	/**
	 * Set lfe attribute.
	 * @param item unsigned
	 */
	virtual void Setlfe(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate lfe attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatelfe() = 0;

	/**
	 * Get track attribute.
	 * @return unsigned
	 */
	virtual unsigned Gettrack() const = 0;

	/**
	 * Get track attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existtrack() const = 0;

	/**
	 * Set track attribute.
	 * @param item unsigned
	 */
	virtual void Settrack(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate track attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatetrack() = 0;

	/**
	 * Gets or creates Mp7JrsNodePtr child elements of MediaFormatType_AudioCoding_AudioChannels_LocalType.
	 * Currently just supports rudimentary XPath expressions as MediaFormatType_AudioCoding_AudioChannels_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

	
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 5134<br>
 * Classified: Class<br>
 * Derived from: nonNegativeInteger (Value)<br>
 * Defined in mpeg7-v2.xsd, line 5134.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType :
		public IMp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType
{
	friend class Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalTypeFactory; // constructs objects

public:
	/*
	 * Sets the content of Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType	 * @param item unsigned
	 */
	virtual void SetContent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Retrieves the content of Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType 
	 * @return unsigned
	 */
	virtual unsigned GetContent() const;

	/*
	 * Get front attribute.
	 * @return unsigned
	 */
	virtual unsigned Getfront() const;

	/*
	 * Get front attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existfront() const;

	/*
	 * Set front attribute.
	 * @param item unsigned
	 */
	virtual void Setfront(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate front attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatefront();

	/*
	 * Get side attribute.
	 * @return unsigned
	 */
	virtual unsigned Getside() const;

	/*
	 * Get side attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existside() const;

	/*
	 * Set side attribute.
	 * @param item unsigned
	 */
	virtual void Setside(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate side attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateside();

	/*
	 * Get rear attribute.
	 * @return unsigned
	 */
	virtual unsigned Getrear() const;

	/*
	 * Get rear attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existrear() const;

	/*
	 * Set rear attribute.
	 * @param item unsigned
	 */
	virtual void Setrear(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate rear attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidaterear();

	/*
	 * Get lfe attribute.
	 * @return unsigned
	 */
	virtual unsigned Getlfe() const;

	/*
	 * Get lfe attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existlfe() const;

	/*
	 * Set lfe attribute.
	 * @param item unsigned
	 */
	virtual void Setlfe(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate lfe attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatelfe();

	/*
	 * Get track attribute.
	 * @return unsigned
	 */
	virtual unsigned Gettrack() const;

	/*
	 * Get track attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existtrack() const;

	/*
	 * Set track attribute.
	 * @param item unsigned
	 */
	virtual void Settrack(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate track attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatetrack();

	/*
	 * Gets or creates Mp7JrsNodePtr child elements of MediaFormatType_AudioCoding_AudioChannels_LocalType.
	 * Currently just supports rudimentary XPath expressions as MediaFormatType_AudioCoding_AudioChannels_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

	

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool ContentFromString(const XMLCh * const txt);

	/* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
	 * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
	 */
	virtual XMLCh * ContentToString() const;


	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType();

protected:
	Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	unsigned m_front;
	bool m_front_Exist;
	unsigned m_side;
	bool m_side_Exist;
	unsigned m_rear;
	bool m_rear_Exist;
	unsigned m_lfe;
	bool m_lfe_Exist;
	unsigned m_track;
	bool m_track_Exist;

	// Base Value
	unsigned m_Base;


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1267MP7JRSMEDIAFORMATTYPE_AUDIOCODING_AUDIOCHANNELS_LOCALTYPE_H

