/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _1291MP7JRSMEDIAFORMATTYPE_VISUALCODING_FORMAT_COLORDOMAIN_LOCALTYPE_H
#define _1291MP7JRSMEDIAFORMATTYPE_VISUALCODING_FORMAT_COLORDOMAIN_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 5081<br>
 * Enumerations: <br>
 * binary (mapped to XML binary) <br>
 * color (mapped to XML color) <br>
 * graylevel (mapped to XML graylevel) <br>
 * colorized (mapped to XML colorized) <br>
 */
class MP7JRS_EXPORT Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType
{
public:
	/** Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		binary, // Mapped to binary
		color, // Mapped to color
		graylevel, // Mapped to graylevel
		colorized, // Mapped to colorized
	};
	

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType::Enumeration item);
	static Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType_ExtPropDef.h



};
#endif // _1291MP7JRSMEDIAFORMATTYPE_VISUALCODING_FORMAT_COLORDOMAIN_LOCALTYPE_H
