/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1411MP7JRSMINUSONETOONEMATRIXTYPE_H
#define _1411MP7JRSMINUSONETOONEMATRIXTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMinusOneToOneMatrixTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMinusOneToOneMatrixType_ExtInclude.h


#include "Mp7JrsminusOneToOneVector.h"
class IMp7Jrsdim_LocalType;
class IMp7JrsMinusOneToOneMatrixType;
class IMp7JrsminusOneToOneVector;
typedef Mp7JrsPtr< IMp7Jrsdim_LocalType > Mp7Jrsdim_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsMinusOneToOneMatrixType> Mp7JrsMinusOneToOneMatrixPtr;
typedef Mp7JrsPtr< IMp7JrsminusOneToOneVector > Mp7JrsminusOneToOneVectorPtr;

/** 
 * Generated interface IMp7JrsMinusOneToOneMatrixType for class Mp7JrsMinusOneToOneMatrixType<br>
 * Located at: mpeg7-v2.xsd, line 3450<br>
 * Classified: Class<br>
 * Derived from: minusOneToOneVector (Collection)<br>
 */
class MP7JRS_EXPORT IMp7JrsMinusOneToOneMatrixType 
 :
		public IMp7JrsminusOneToOneVector
{
public:
	// TODO: make these protected?
	IMp7JrsMinusOneToOneMatrixType();
	virtual ~IMp7JrsMinusOneToOneMatrixType();
	/**
	 * Retrieves the base collection of Mp7JrsMinusOneToOneMatrixType
	 
	 * @return Mp7JrsPtr< Mp7JrsminusOneToOneVector >
	 */
	virtual Mp7JrsPtr< Mp7JrsminusOneToOneVector > GetBaseCollection() const = 0;


	/**
	 * Initializes the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param maxElems Number of elements for which memory is initially allocated.
	 */
	virtual void Initialize(unsigned int maxElems) = 0;


	/**
	 * Adds a new element to the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toAdd Element to be added. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 */
	virtual void addElement(const Mp7JrsNodePtr &toAdd, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Sets the element at the given position in the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toSet New value of the element. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @param setAt Position of the element which shall be set.
	 */
	virtual void setElementAt(const Mp7JrsNodePtr &toSet, unsigned int setAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Inserts the element at the given position in the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toInsert Element to be inserted. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @param insertAt Position where the element will be inserted.
	 */
	virtual void insertElementAt(const Mp7JrsNodePtr &toInsert, unsigned int insertAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Removes all elements from the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 */
	virtual void removeAllElements(Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Removes the specified element from the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param removeAt Position of the element to be removed. 
	 */
	virtual void removeElementAt(unsigned int removeAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;



	/**
	 * Check whether the collection contains the given element.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toCheck Element to be checked for. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @return True if the element is in the collection, false otherwise.
	 */
	virtual bool containsElement(const Mp7JrsNodePtr &toCheck) = 0;


	/**
	 * Get the current capacity of the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @return The number of elements for which memory has been allocated.
	 */
	virtual unsigned int curCapacity() const = 0;


	/**
	 * Gets a constant pointer to the element at the given position.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param Position of the element to be retrieved.
	 * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7JrsminusOneToOneVector_LocalType.
	 */
	virtual const Mp7JrsNodePtr elementAt(unsigned int getAt) const = 0;


	/**
	 * Gets a pointer to the element at the given position.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param Position of the element to be retrieved.
	 * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7JrsminusOneToOneVector_LocalType.
	 */
	virtual Mp7JrsNodePtr elementAt(unsigned int getAt) = 0;


	/**
	 * Gets an enumeration of all contained elements of the specified type.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param The class id of the wanted elements.
	 * @return A (possibly empty) enumeration of all contained elements of type id.
	 */
	virtual Mp7JrsNodeEnum GetElementsOfType(unsigned int id) const = 0;

		
	/**
	 * Gets an enumeration of all contained elements.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @return A (possibly empty) enumeration of all contained elements.
	 */
	virtual Mp7JrsNodeEnum GetElements() const = 0;



	/**
	 * Get the size of the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @return The current number of elements in the collection.
	 */
	virtual unsigned int size() const = 0;


	/**
	 * Allocate additional memory for the speciifed number of elements.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param length Number of elements to allocate memory for.
	 */
	virtual void ensureExtraCapacity(unsigned int length) = 0;


	// JRS: addition to Xerces collection
	/**
	 * Get the position of the specified element. 
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toCheck Element to be found in the collection. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @return The position of the specified element or -1 if the element has not been found.
	 */
	virtual int elementIndexOf(const Mp7JrsNodePtr &toCheck) const = 0;


	/**
	 * Get dim attribute.
	 * @return Mp7Jrsdim_LocalPtr
	 */
	virtual Mp7Jrsdim_LocalPtr Getdim() const = 0;

	/**
	 * Set dim attribute.
	 * @param item const Mp7Jrsdim_LocalPtr &
	 */
	// Mandatory
	virtual void Setdim(const Mp7Jrsdim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Gets or creates Mp7JrsNodePtr child elements of MinusOneToOneMatrixType.
	 * Currently just supports rudimentary XPath expressions as MinusOneToOneMatrixType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

	
// no includefile for extension defined 
// file Mp7JrsMinusOneToOneMatrixType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMinusOneToOneMatrixType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMinusOneToOneMatrixType<br>
 * Located at: mpeg7-v2.xsd, line 3450<br>
 * Classified: Class<br>
 * Derived from: minusOneToOneVector (Collection)<br>
 * Defined in mpeg7-v2.xsd, line 3450.<br>
 */
class MP7JRS_EXPORT Mp7JrsMinusOneToOneMatrixType :
		public IMp7JrsMinusOneToOneMatrixType
{
	friend class Mp7JrsMinusOneToOneMatrixTypeFactory; // constructs objects

public:
	/*
	 * Retrieves the base class of Mp7JrsMinusOneToOneMatrixType
	 
	 * @return Mp7JrsPtr< Mp7JrsminusOneToOneVector >
	 */
	virtual Mp7JrsPtr< Mp7JrsminusOneToOneVector > GetBase() const;
	/*
	 * Retrieves the base collection of Mp7JrsMinusOneToOneMatrixType
	 
	 * @return Mp7JrsPtr< Mp7JrsminusOneToOneVector >
	 */
	virtual Mp7JrsPtr< Mp7JrsminusOneToOneVector > GetBaseCollection() const;


	/*
	 * Initializes the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param maxElems Number of elements for which memory is initially allocated.
	 */
	virtual void Initialize(unsigned int maxElems);


	/*
	 * Adds a new element to the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toAdd Element to be added. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 */
	virtual void addElement(const Mp7JrsNodePtr &toAdd, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Sets the element at the given position in the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toSet New value of the element. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @param setAt Position of the element which shall be set.
	 */
	virtual void setElementAt(const Mp7JrsNodePtr &toSet, unsigned int setAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Inserts the element at the given position in the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toInsert Element to be inserted. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @param insertAt Position where the element will be inserted.
	 */
	virtual void insertElementAt(const Mp7JrsNodePtr &toInsert, unsigned int insertAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Removes all elements from the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 */
	virtual void removeAllElements(Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Removes the specified element from the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param removeAt Position of the element to be removed. 
	 */
	virtual void removeElementAt(unsigned int removeAt, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);



	/*
	 * Check whether the collection contains the given element.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toCheck Element to be checked for. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @return True if the element is in the collection, false otherwise.
	 */
	virtual bool containsElement(const Mp7JrsNodePtr &toCheck);


	/*
	 * Get the current capacity of the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @return The number of elements for which memory has been allocated.
	 */
	virtual unsigned int curCapacity() const;


	/*
	 * Gets a constant pointer to the element at the given position.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param Position of the element to be retrieved.
	 * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7JrsminusOneToOneVector_LocalType.
	 */
	virtual const Mp7JrsNodePtr elementAt(unsigned int getAt) const;


	/*
	 * Gets a pointer to the element at the given position.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param Position of the element to be retrieved.
	 * @return A pointer to the given element or a null pointer if there is no element at the specified position. Default element type: Mp7JrsminusOneToOneVector_LocalType.
	 */
	virtual Mp7JrsNodePtr elementAt(unsigned int getAt);


	/*
	 * Gets an enumeration of all contained elements of the specified type.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param The class id of the wanted elements.
	 * @return A (possibly empty) enumeration of all contained elements of type id.
	 */
	virtual Mp7JrsNodeEnum GetElementsOfType(unsigned int id) const;

		
	/*
	 * Gets an enumeration of all contained elements.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @return A (possibly empty) enumeration of all contained elements.
	 */
	virtual Mp7JrsNodeEnum GetElements() const;



	/*
	 * Get the size of the collection.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @return The current number of elements in the collection.
	 */
	virtual unsigned int size() const;


	/*
	 * Allocate additional memory for the speciifed number of elements.
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param length Number of elements to allocate memory for.
	 */
	virtual void ensureExtraCapacity(unsigned int length);


	// JRS: addition to Xerces collection
	/*
	 * Get the position of the specified element. 
	 * (Inherited from Mp7JrsminusOneToOneVector)
	 * @param toCheck Element to be found in the collection. Default element type: Mp7JrsminusOneToOneVector_LocalType
	 * @return The position of the specified element or -1 if the element has not been found.
	 */
	virtual int elementIndexOf(const Mp7JrsNodePtr &toCheck) const;


	/*
	 * Get dim attribute.
	 * @return Mp7Jrsdim_LocalPtr
	 */
	virtual Mp7Jrsdim_LocalPtr Getdim() const;

	/*
	 * Set dim attribute.
	 * @param item const Mp7Jrsdim_LocalPtr &
	 */
	// Mandatory
	virtual void Setdim(const Mp7Jrsdim_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Gets or creates Mp7JrsNodePtr child elements of MinusOneToOneMatrixType.
	 * Currently just supports rudimentary XPath expressions as MinusOneToOneMatrixType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

	

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool ContentFromString(const XMLCh * const txt);

	/* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
	 * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
	 */
	virtual XMLCh * ContentToString() const;


	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsMinusOneToOneMatrixType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsMinusOneToOneMatrixType();

protected:
	Mp7JrsMinusOneToOneMatrixType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	Mp7Jrsdim_LocalPtr m_dim;

	// Base Collection
	Mp7JrsPtr< Mp7JrsminusOneToOneVector > m_Base;


// no includefile for extension defined 
// file Mp7JrsMinusOneToOneMatrixType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1411MP7JRSMINUSONETOONEMATRIXTYPE_H

