/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1457MP7JRSMOSAICTYPE_WARPINGPARAM_LOCALTYPE_H
#define _1457MP7JRSMOSAICTYPE_WARPINGPARAM_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType_ExtInclude.h


class IMp7JrsfloatVector;
class IMp7JrsMediaRelIncrTimePointType;
class IMp7JrsMediaRelTimePointType;
class IMp7JrsmediaTimePointType;
class IMp7JrsMosaicType_WarpingParam_LocalType;
typedef Mp7JrsPtr< IMp7JrsfloatVector > Mp7JrsfloatVectorPtr;
typedef Mp7JrsPtr< IMp7JrsMediaRelIncrTimePointType > Mp7JrsMediaRelIncrTimePointPtr;
typedef Mp7JrsPtr< IMp7JrsMediaRelTimePointType > Mp7JrsMediaRelTimePointPtr;
typedef Mp7JrsPtr< IMp7JrsmediaTimePointType > Mp7JrsmediaTimePointPtr;
typedef Mp7JrsPtr< IMp7JrsMosaicType_WarpingParam_LocalType> Mp7JrsMosaicType_WarpingParam_LocalPtr;

/** 
 * Generated interface IMp7JrsMosaicType_WarpingParam_LocalType for class Mp7JrsMosaicType_WarpingParam_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsMosaicType_WarpingParam_LocalType 
 :
		public Mp7JrsNode
{
public:
	// TODO: make these protected?
	IMp7JrsMosaicType_WarpingParam_LocalType();
	virtual ~IMp7JrsMosaicType_WarpingParam_LocalType();
		/** @name Sequence

		 */
		//@{
		/** @name Choice

		 */
		//@{
	/**
	 * Get MediaTimePoint element.
	 * @return Mp7JrsmediaTimePointPtr
	 */
	virtual Mp7JrsmediaTimePointPtr GetMediaTimePoint() const = 0;

	/**
	 * Set MediaTimePoint element.
	 * @param item const Mp7JrsmediaTimePointPtr &
	 */
	// Mandatory			
	virtual void SetMediaTimePoint(const Mp7JrsmediaTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Get MediaRelTimePoint element.
	 * @return Mp7JrsMediaRelTimePointPtr
	 */
	virtual Mp7JrsMediaRelTimePointPtr GetMediaRelTimePoint() const = 0;

	/**
	 * Set MediaRelTimePoint element.
	 * @param item const Mp7JrsMediaRelTimePointPtr &
	 */
	// Mandatory			
	virtual void SetMediaRelTimePoint(const Mp7JrsMediaRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Get MediaRelIncrTimePoint element.
	 * @return Mp7JrsMediaRelIncrTimePointPtr
	 */
	virtual Mp7JrsMediaRelIncrTimePointPtr GetMediaRelIncrTimePoint() const = 0;

	/**
	 * Set MediaRelIncrTimePoint element.
	 * @param item const Mp7JrsMediaRelIncrTimePointPtr &
	 */
	// Mandatory			
	virtual void SetMediaRelIncrTimePoint(const Mp7JrsMediaRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

		//@}
	/**
	 * Get MotionParam element.
	 * @return Mp7JrsfloatVectorPtr
	 */
	virtual Mp7JrsfloatVectorPtr GetMotionParam() const = 0;

	/**
	 * Set MotionParam element.
	 * @param item const Mp7JrsfloatVectorPtr &
	 */
	// Mandatory collection
	virtual void SetMotionParam(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

		//@}
// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMosaicType_WarpingParam_LocalType<br>
 * Defined in mpeg7-v2.xsd, line 6071.<br>
 */
class MP7JRS_EXPORT Mp7JrsMosaicType_WarpingParam_LocalType :
		public IMp7JrsMosaicType_WarpingParam_LocalType
{
	friend class Mp7JrsMosaicType_WarpingParam_LocalTypeFactory; // constructs objects

public:
		/* @name Sequence

		 */
		//@{
		/* @name Choice

		 */
		//@{
	/*
	 * Get MediaTimePoint element.
	 * @return Mp7JrsmediaTimePointPtr
	 */
	virtual Mp7JrsmediaTimePointPtr GetMediaTimePoint() const;

	/*
	 * Set MediaTimePoint element.
	 * @param item const Mp7JrsmediaTimePointPtr &
	 */
	// Mandatory			
	virtual void SetMediaTimePoint(const Mp7JrsmediaTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Get MediaRelTimePoint element.
	 * @return Mp7JrsMediaRelTimePointPtr
	 */
	virtual Mp7JrsMediaRelTimePointPtr GetMediaRelTimePoint() const;

	/*
	 * Set MediaRelTimePoint element.
	 * @param item const Mp7JrsMediaRelTimePointPtr &
	 */
	// Mandatory			
	virtual void SetMediaRelTimePoint(const Mp7JrsMediaRelTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Get MediaRelIncrTimePoint element.
	 * @return Mp7JrsMediaRelIncrTimePointPtr
	 */
	virtual Mp7JrsMediaRelIncrTimePointPtr GetMediaRelIncrTimePoint() const;

	/*
	 * Set MediaRelIncrTimePoint element.
	 * @param item const Mp7JrsMediaRelIncrTimePointPtr &
	 */
	// Mandatory			
	virtual void SetMediaRelIncrTimePoint(const Mp7JrsMediaRelIncrTimePointPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

		//@}
	/*
	 * Get MotionParam element.
	 * @return Mp7JrsfloatVectorPtr
	 */
	virtual Mp7JrsfloatVectorPtr GetMotionParam() const;

	/*
	 * Set MotionParam element.
	 * @param item const Mp7JrsfloatVectorPtr &
	 */
	// Mandatory collection
	virtual void SetMotionParam(const Mp7JrsfloatVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

		//@}

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsMosaicType_WarpingParam_LocalType();

protected:
	Mp7JrsMosaicType_WarpingParam_LocalType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
	Mp7JrsmediaTimePointPtr m_MediaTimePoint;
	Mp7JrsMediaRelTimePointPtr m_MediaRelTimePoint;
	Mp7JrsMediaRelIncrTimePointPtr m_MediaRelIncrTimePoint;
// End DefinionChoice
	Mp7JrsfloatVectorPtr m_MotionParam;

// no includefile for extension defined 
// file Mp7JrsMosaicType_WarpingParam_LocalType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1457MP7JRSMOSAICTYPE_WARPINGPARAM_LOCALTYPE_H

