/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _739MP7JRSDEPENDENCYOPERATORTYPE_H
#define _739MP7JRSDEPENDENCYOPERATORTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsdependencyOperatorType<br>
 * Located at: mpeg7-v2.xsd, line 4047<br>
 * Enumerations: <br>
 * subject (mapped to XML subject) <br>
 * object (mapped to XML object) <br>
 * indirectObject (mapped to XML indirectObject) <br>
 * predicate (mapped to XML predicate) <br>
 * expletive (mapped to XML expletive) <br>
 * nonRestrictive (mapped to XML nonRestrictive) <br>
 */
class MP7JRS_EXPORT Mp7JrsdependencyOperatorType
{
public:
	/** Mp7JrsdependencyOperatorType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		subject, // Mapped to subject
		object, // Mapped to object
		indirectObject, // Mapped to indirectObject
		predicate, // Mapped to predicate
		expletive, // Mapped to expletive
		nonRestrictive, // Mapped to nonRestrictive
	};
	

// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsdependencyOperatorType::Enumeration item);
	static Mp7JrsdependencyOperatorType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsdependencyOperatorType_ExtPropDef.h



};
#endif // _739MP7JRSDEPENDENCYOPERATORTYPE_H
