/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


#ifndef _1368MP7JRSMEDIATIMEPOINTTYPEFACTORY_H
#define _1368MP7JRSMEDIATIMEPOINTTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsmediaTimePointTypeFactory<br>
 * for class Mp7JrsmediaTimePointType:<br>
 * Located at: mpeg7-v2.xsd, line 3698<br>
 * Regular expression: <br>
 * (\-?\d+(\-\d{2}(\-\d{2})?)?)?(T\d{2}(:\d{2}(:\d{2}(:\d+)?)?)?)?(F\d+)?<br>
 */

class MP7JRS_EXPORT Mp7JrsmediaTimePointTypeFactory :
	public Mp7JrsFactory
{
public:
	Mp7JrsmediaTimePointTypeFactory();
	virtual ~Mp7JrsmediaTimePointTypeFactory();

	virtual const char * GetTypeName() const;
	virtual Mp7JrsNodePtr CreateObject();
};

#endif // _1368MP7JRSMEDIATIMEPOINTTYPEFACTORY_H
