/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1819MP7JRSPROBABILITYVECTOR_LOCALTYPE_H
#define _1819MP7JRSPROBABILITYVECTOR_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsprobabilityVector_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsprobabilityVector_LocalType_ExtInclude.h


class IMp7JrsprobabilityVector_LocalType;
typedef Mp7JrsPtr< IMp7JrsprobabilityVector_LocalType> Mp7JrsprobabilityVector_LocalPtr;

/** 
 * Generated interface IMp7JrsprobabilityVector_LocalType for class Mp7JrsprobabilityVector_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 3463<br>
 * Derived from: float (Value)<br>
 */
class MP7JRS_EXPORT IMp7JrsprobabilityVector_LocalType 
 :
		public Mp7JrsNode
{
public:
	// TODO: make these protected?
	IMp7JrsprobabilityVector_LocalType();
	virtual ~IMp7JrsprobabilityVector_LocalType();
	/**
	 * Sets the content of Mp7JrsprobabilityVector_LocalType	 * @param item float
	 */
	virtual void SetContent(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Retrieves the content of Mp7JrsprobabilityVector_LocalType 
	 * @return float
	 */
	virtual float GetContent() const = 0;

// no includefile for extension defined 
// file Mp7JrsprobabilityVector_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsprobabilityVector_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsprobabilityVector_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 3463<br>
 * Derived from: float (Value)<br>
 * Defined in mpeg7-v2.xsd, line 3463.<br>
 */
class MP7JRS_EXPORT Mp7JrsprobabilityVector_LocalType :
		public IMp7JrsprobabilityVector_LocalType
{
	friend class Mp7JrsprobabilityVector_LocalTypeFactory; // constructs objects

public:
	/*
	 * Sets the content of Mp7JrsprobabilityVector_LocalType	 * @param item float
	 */
	virtual void SetContent(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Retrieves the content of Mp7JrsprobabilityVector_LocalType 
	 * @return float
	 */
	virtual float GetContent() const;


	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool ContentFromString(const XMLCh * const txt);

	/* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
	 * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
	 */
	virtual XMLCh * ContentToString() const;


	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsprobabilityVector_LocalType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsprobabilityVector_LocalType();

protected:
	Mp7JrsprobabilityVector_LocalType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

	// Base Value
	float m_Base;


// no includefile for extension defined 
// file Mp7JrsprobabilityVector_LocalType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1819MP7JRSPROBABILITYVECTOR_LOCALTYPE_H

