 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtImplInclude.h



#include "Mp7JrsSpatioTemporalSegmentDecompositionType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType.h" // Choice collection EditedMovingRegion
#include "Mp7JrsEditedMovingRegionType.h" // Choice collection element EditedMovingRegion
#include "Mp7JrsReferenceType.h" // Choice collection element EditedMovingRegionRef

#include <assert.h>
IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType()
{

// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtPropInit.h

}

IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::~IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType()
{
// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtPropCleanup.h

}

Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::~Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType()
{
	Cleanup();
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Init()
{
	// Init base
	m_Base = CreateSpatioTemporalSegmentDecompositionType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType = Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtMyPropInit.h

}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType);
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AnalyticEditedVideoSegmentSpatioTemporalDecompositionTypePtr, since we
	// might need GetBase(), which isn't defined in IAnalyticEditedVideoSegmentSpatioTemporalDecompositionType
	const Mp7JrsPtr< Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsSpatioTemporalSegmentDecompositionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType);
		this->SetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsSpatioTemporalSegmentDecompositionType > Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetBase() const
{
	return m_Base;
}

Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType() const
{
		return m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType;
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType(const Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType().");
	}
	if (m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType);
		m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType) m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Getcriteria() const
{
	return GetBase()->GetBase()->Getcriteria();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Existcriteria() const
{
	return GetBase()->GetBase()->Existcriteria();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setcriteria(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setcriteria().");
	}
	GetBase()->GetBase()->Setcriteria(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Invalidatecriteria()
{
	GetBase()->GetBase()->Invalidatecriteria();
}
bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Getoverlap() const
{
	return GetBase()->GetBase()->Getoverlap();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Existoverlap() const
{
	return GetBase()->GetBase()->Existoverlap();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setoverlap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setoverlap().");
	}
	GetBase()->GetBase()->Setoverlap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Invalidateoverlap()
{
	GetBase()->GetBase()->Invalidateoverlap();
}
bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Getgap() const
{
	return GetBase()->GetBase()->Getgap();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Existgap() const
{
	return GetBase()->GetBase()->Existgap();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setgap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setgap().");
	}
	GetBase()->GetBase()->Setgap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Invalidategap()
{
	GetBase()->GetBase()->Invalidategap();
}
XMLCh * Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Getid() const
{
	return GetBase()->GetBase()->GetBase()->Getid();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Existid() const
{
	return GetBase()->GetBase()->GetBase()->Existid();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Setid().");
	}
	GetBase()->GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Invalidateid()
{
	GetBase()->GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GettimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::ExisttimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SettimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::InvalidatetimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GettimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SettimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetHeader() const
{
	return GetBase()->GetBase()->GetBase()->GetHeader();
}

void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::SetHeader().");
	}
	GetBase()->GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 8 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("EditedMovingRegion")) == 0)
	{
		// EditedMovingRegion is contained in itemtype AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType
		// in choice collection AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType
		
		context->Found = true;
		Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr coll = GetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType;
				SetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetEditedMovingRegion()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr item = CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:EditedMovingRegionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsEditedMovingRegionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetEditedMovingRegion(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetEditedMovingRegion()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("EditedMovingRegionRef")) == 0)
	{
		// EditedMovingRegionRef is contained in itemtype AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType
		// in choice collection AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType
		
		context->Found = true;
		Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr coll = GetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType;
				SetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetEditedMovingRegionRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr item = CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetEditedMovingRegionRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetEditedMovingRegionRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for AnalyticEditedVideoSegmentSpatioTemporalDecompositionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "AnalyticEditedVideoSegmentSpatioTemporalDecompositionType");
	}
	return result;
}

XMLCh * Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("AnalyticEditedVideoSegmentSpatioTemporalDecompositionType"));
	// Element serialization:
	if (m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType != Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_AnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsSpatioTemporalSegmentDecompositionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		// Deserialise Choice Collection
		if((parent != NULL) && (
			// urn:mpeg:mpeg7:schema:2004:EditedMovingRegion
			Mp7JrsUtil::HasNodeName(parent, X("EditedMovingRegion"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:EditedMovingRegion")) == 0)
				||
			// urn:mpeg:mpeg7:schema:2004:EditedMovingRegionRef
			Mp7JrsUtil::HasNodeName(parent, X("EditedMovingRegionRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:EditedMovingRegionRef")) == 0)
				))
		{
			// Deserialize factory type
			Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr tmp = CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  // Choice Collection
  if(
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("EditedMovingRegion"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("EditedMovingRegion")) == 0)
	||
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("EditedMovingRegionRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("EditedMovingRegionRef")) == 0)
	)
  {
	Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionPtr tmp = CreateAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionType;
	this->SetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_ExtMethodImpl.h


