 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtImplInclude.h



#include "Mp7JrsAudioDSType.h"
#include "Mp7JrsPersonType.h"
#include "Mp7JrsCreationToolType.h"
#include "Mp7JrsBackgroundNoiseLevelType.h"
#include "Mp7JrsRelativeDelayType.h"
#include "Mp7JrsBalanceType.h"
#include "Mp7JrsDcOffsetType.h"
#include "Mp7JrsCrossChannelCorrelationType.h"
#include "Mp7JrsBandwidthType.h"
#include "Mp7JrsTransmissionTechnologyType.h"
#include "Mp7JrsAudioSignalQualityType_ErrorEventList_LocalType.h"
#include "Mp7JrsintegerVector.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsAudioSignalQualityType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header

#include <assert.h>
IMp7JrsAudioSignalQualityType::IMp7JrsAudioSignalQualityType()
{

// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtPropInit.h

}

IMp7JrsAudioSignalQualityType::~IMp7JrsAudioSignalQualityType()
{
// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtPropCleanup.h

}

Mp7JrsAudioSignalQualityType::Mp7JrsAudioSignalQualityType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAudioSignalQualityType::~Mp7JrsAudioSignalQualityType()
{
	Cleanup();
}

void Mp7JrsAudioSignalQualityType::Init()
{
	// Init base
	m_Base = CreateAudioDSType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_IsOriginalMono = false; // Value
	m_IsOriginalMono_Exist = false;
	m_BroadcastReady = false; // Value
	m_BroadcastReady_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Operator = Mp7JrsPersonPtr(); // Class
	m_Operator_Exist = false;
	m_UsedTool = Mp7JrsCreationToolPtr(); // Class
	m_UsedTool_Exist = false;
	m_BackgroundNoiseLevel = Mp7JrsBackgroundNoiseLevelPtr(); // Class
	m_RelativeDelay = Mp7JrsRelativeDelayPtr(); // Class
	m_Balance = Mp7JrsBalancePtr(); // Class
	m_DcOffset = Mp7JrsDcOffsetPtr(); // Class
	m_CrossChannelCorrelation = Mp7JrsCrossChannelCorrelationPtr(); // Class
	m_Bandwidth = Mp7JrsBandwidthPtr(); // Class
	m_TransmissionTechnology = Mp7JrsTransmissionTechnologyPtr(); // Class
	m_TransmissionTechnology_Exist = false;
	m_ErrorEventList = Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr(); // Class
	m_ErrorEventList_Exist = false;


// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtMyPropInit.h

}

void Mp7JrsAudioSignalQualityType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_Operator);
	// Mp7JrsFactory::DeleteObject(m_UsedTool);
	// Mp7JrsFactory::DeleteObject(m_BackgroundNoiseLevel);
	// Mp7JrsFactory::DeleteObject(m_RelativeDelay);
	// Mp7JrsFactory::DeleteObject(m_Balance);
	// Mp7JrsFactory::DeleteObject(m_DcOffset);
	// Mp7JrsFactory::DeleteObject(m_CrossChannelCorrelation);
	// Mp7JrsFactory::DeleteObject(m_Bandwidth);
	// Mp7JrsFactory::DeleteObject(m_TransmissionTechnology);
	// Mp7JrsFactory::DeleteObject(m_ErrorEventList);
}

void Mp7JrsAudioSignalQualityType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AudioSignalQualityTypePtr, since we
	// might need GetBase(), which isn't defined in IAudioSignalQualityType
	const Mp7JrsPtr< Mp7JrsAudioSignalQualityType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsAudioDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsAudioSignalQualityType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	if (tmp->ExistIsOriginalMono())
	{
		this->SetIsOriginalMono(tmp->GetIsOriginalMono());
	}
	else
	{
		InvalidateIsOriginalMono();
	}
	}
	{
	if (tmp->ExistBroadcastReady())
	{
		this->SetBroadcastReady(tmp->GetBroadcastReady());
	}
	else
	{
		InvalidateBroadcastReady();
	}
	}
	if (tmp->IsValidOperator())
	{
		// Mp7JrsFactory::DeleteObject(m_Operator);
		this->SetOperator(Mp7JrsFactory::CloneObject(tmp->GetOperator()));
	}
	else
	{
		InvalidateOperator();
	}
	if (tmp->IsValidUsedTool())
	{
		// Mp7JrsFactory::DeleteObject(m_UsedTool);
		this->SetUsedTool(Mp7JrsFactory::CloneObject(tmp->GetUsedTool()));
	}
	else
	{
		InvalidateUsedTool();
	}
		// Mp7JrsFactory::DeleteObject(m_BackgroundNoiseLevel);
		this->SetBackgroundNoiseLevel(Mp7JrsFactory::CloneObject(tmp->GetBackgroundNoiseLevel()));
		// Mp7JrsFactory::DeleteObject(m_RelativeDelay);
		this->SetRelativeDelay(Mp7JrsFactory::CloneObject(tmp->GetRelativeDelay()));
		// Mp7JrsFactory::DeleteObject(m_Balance);
		this->SetBalance(Mp7JrsFactory::CloneObject(tmp->GetBalance()));
		// Mp7JrsFactory::DeleteObject(m_DcOffset);
		this->SetDcOffset(Mp7JrsFactory::CloneObject(tmp->GetDcOffset()));
		// Mp7JrsFactory::DeleteObject(m_CrossChannelCorrelation);
		this->SetCrossChannelCorrelation(Mp7JrsFactory::CloneObject(tmp->GetCrossChannelCorrelation()));
		// Mp7JrsFactory::DeleteObject(m_Bandwidth);
		this->SetBandwidth(Mp7JrsFactory::CloneObject(tmp->GetBandwidth()));
	if (tmp->IsValidTransmissionTechnology())
	{
		// Mp7JrsFactory::DeleteObject(m_TransmissionTechnology);
		this->SetTransmissionTechnology(Mp7JrsFactory::CloneObject(tmp->GetTransmissionTechnology()));
	}
	else
	{
		InvalidateTransmissionTechnology();
	}
	if (tmp->IsValidErrorEventList())
	{
		// Mp7JrsFactory::DeleteObject(m_ErrorEventList);
		this->SetErrorEventList(Mp7JrsFactory::CloneObject(tmp->GetErrorEventList()));
	}
	else
	{
		InvalidateErrorEventList();
	}
}

Mp7JrsNodePtr Mp7JrsAudioSignalQualityType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsAudioSignalQualityType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsAudioDSType > Mp7JrsAudioSignalQualityType::GetBase() const
{
	return m_Base;
}

bool Mp7JrsAudioSignalQualityType::GetIsOriginalMono() const
{
	return m_IsOriginalMono;
}

bool Mp7JrsAudioSignalQualityType::ExistIsOriginalMono() const
{
	return m_IsOriginalMono_Exist;
}
void Mp7JrsAudioSignalQualityType::SetIsOriginalMono(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetIsOriginalMono().");
	}
	m_IsOriginalMono = item;
	m_IsOriginalMono_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidateIsOriginalMono()
{
	m_IsOriginalMono_Exist = false;
}
bool Mp7JrsAudioSignalQualityType::GetBroadcastReady() const
{
	return m_BroadcastReady;
}

bool Mp7JrsAudioSignalQualityType::ExistBroadcastReady() const
{
	return m_BroadcastReady_Exist;
}
void Mp7JrsAudioSignalQualityType::SetBroadcastReady(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetBroadcastReady().");
	}
	m_BroadcastReady = item;
	m_BroadcastReady_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidateBroadcastReady()
{
	m_BroadcastReady_Exist = false;
}
Mp7JrsPersonPtr Mp7JrsAudioSignalQualityType::GetOperator() const
{
		return m_Operator;
}

// Element is optional
bool Mp7JrsAudioSignalQualityType::IsValidOperator() const
{
	return m_Operator_Exist;
}

Mp7JrsCreationToolPtr Mp7JrsAudioSignalQualityType::GetUsedTool() const
{
		return m_UsedTool;
}

// Element is optional
bool Mp7JrsAudioSignalQualityType::IsValidUsedTool() const
{
	return m_UsedTool_Exist;
}

Mp7JrsBackgroundNoiseLevelPtr Mp7JrsAudioSignalQualityType::GetBackgroundNoiseLevel() const
{
		return m_BackgroundNoiseLevel;
}

Mp7JrsRelativeDelayPtr Mp7JrsAudioSignalQualityType::GetRelativeDelay() const
{
		return m_RelativeDelay;
}

Mp7JrsBalancePtr Mp7JrsAudioSignalQualityType::GetBalance() const
{
		return m_Balance;
}

Mp7JrsDcOffsetPtr Mp7JrsAudioSignalQualityType::GetDcOffset() const
{
		return m_DcOffset;
}

Mp7JrsCrossChannelCorrelationPtr Mp7JrsAudioSignalQualityType::GetCrossChannelCorrelation() const
{
		return m_CrossChannelCorrelation;
}

Mp7JrsBandwidthPtr Mp7JrsAudioSignalQualityType::GetBandwidth() const
{
		return m_Bandwidth;
}

Mp7JrsTransmissionTechnologyPtr Mp7JrsAudioSignalQualityType::GetTransmissionTechnology() const
{
		return m_TransmissionTechnology;
}

// Element is optional
bool Mp7JrsAudioSignalQualityType::IsValidTransmissionTechnology() const
{
	return m_TransmissionTechnology_Exist;
}

Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr Mp7JrsAudioSignalQualityType::GetErrorEventList() const
{
		return m_ErrorEventList;
}

// Element is optional
bool Mp7JrsAudioSignalQualityType::IsValidErrorEventList() const
{
	return m_ErrorEventList_Exist;
}

void Mp7JrsAudioSignalQualityType::SetOperator(const Mp7JrsPersonPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetOperator().");
	}
	if (m_Operator != item || m_Operator_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Operator);
		m_Operator = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Operator) m_Operator->SetParent(m_myself.getPointer());
		if (m_Operator && m_Operator->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PersonType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Operator->UseTypeAttribute = true;
		}
		m_Operator_Exist = true;
		if(m_Operator != Mp7JrsPersonPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Operator->SetContentName(XMLString::transcode("Operator"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidateOperator()
{
	m_Operator_Exist = false;
}
void Mp7JrsAudioSignalQualityType::SetUsedTool(const Mp7JrsCreationToolPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetUsedTool().");
	}
	if (m_UsedTool != item || m_UsedTool_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_UsedTool);
		m_UsedTool = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_UsedTool) m_UsedTool->SetParent(m_myself.getPointer());
		if (m_UsedTool && m_UsedTool->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationToolType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_UsedTool->UseTypeAttribute = true;
		}
		m_UsedTool_Exist = true;
		if(m_UsedTool != Mp7JrsCreationToolPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_UsedTool->SetContentName(XMLString::transcode("UsedTool"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidateUsedTool()
{
	m_UsedTool_Exist = false;
}
void Mp7JrsAudioSignalQualityType::SetBackgroundNoiseLevel(const Mp7JrsBackgroundNoiseLevelPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetBackgroundNoiseLevel().");
	}
	if (m_BackgroundNoiseLevel != item)
	{
		// Mp7JrsFactory::DeleteObject(m_BackgroundNoiseLevel);
		m_BackgroundNoiseLevel = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_BackgroundNoiseLevel) m_BackgroundNoiseLevel->SetParent(m_myself.getPointer());
		if (m_BackgroundNoiseLevel && m_BackgroundNoiseLevel->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:BackgroundNoiseLevelType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_BackgroundNoiseLevel->UseTypeAttribute = true;
		}
		if(m_BackgroundNoiseLevel != Mp7JrsBackgroundNoiseLevelPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_BackgroundNoiseLevel->SetContentName(XMLString::transcode("BackgroundNoiseLevel"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::SetRelativeDelay(const Mp7JrsRelativeDelayPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetRelativeDelay().");
	}
	if (m_RelativeDelay != item)
	{
		// Mp7JrsFactory::DeleteObject(m_RelativeDelay);
		m_RelativeDelay = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_RelativeDelay) m_RelativeDelay->SetParent(m_myself.getPointer());
		if (m_RelativeDelay && m_RelativeDelay->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:RelativeDelayType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_RelativeDelay->UseTypeAttribute = true;
		}
		if(m_RelativeDelay != Mp7JrsRelativeDelayPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_RelativeDelay->SetContentName(XMLString::transcode("RelativeDelay"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::SetBalance(const Mp7JrsBalancePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetBalance().");
	}
	if (m_Balance != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Balance);
		m_Balance = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Balance) m_Balance->SetParent(m_myself.getPointer());
		if (m_Balance && m_Balance->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:BalanceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Balance->UseTypeAttribute = true;
		}
		if(m_Balance != Mp7JrsBalancePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Balance->SetContentName(XMLString::transcode("Balance"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::SetDcOffset(const Mp7JrsDcOffsetPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetDcOffset().");
	}
	if (m_DcOffset != item)
	{
		// Mp7JrsFactory::DeleteObject(m_DcOffset);
		m_DcOffset = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_DcOffset) m_DcOffset->SetParent(m_myself.getPointer());
		if (m_DcOffset && m_DcOffset->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DcOffsetType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_DcOffset->UseTypeAttribute = true;
		}
		if(m_DcOffset != Mp7JrsDcOffsetPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_DcOffset->SetContentName(XMLString::transcode("DcOffset"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::SetCrossChannelCorrelation(const Mp7JrsCrossChannelCorrelationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetCrossChannelCorrelation().");
	}
	if (m_CrossChannelCorrelation != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CrossChannelCorrelation);
		m_CrossChannelCorrelation = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CrossChannelCorrelation) m_CrossChannelCorrelation->SetParent(m_myself.getPointer());
		if (m_CrossChannelCorrelation && m_CrossChannelCorrelation->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CrossChannelCorrelationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CrossChannelCorrelation->UseTypeAttribute = true;
		}
		if(m_CrossChannelCorrelation != Mp7JrsCrossChannelCorrelationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CrossChannelCorrelation->SetContentName(XMLString::transcode("CrossChannelCorrelation"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::SetBandwidth(const Mp7JrsBandwidthPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetBandwidth().");
	}
	if (m_Bandwidth != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Bandwidth);
		m_Bandwidth = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Bandwidth) m_Bandwidth->SetParent(m_myself.getPointer());
		if (m_Bandwidth && m_Bandwidth->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:BandwidthType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Bandwidth->UseTypeAttribute = true;
		}
		if(m_Bandwidth != Mp7JrsBandwidthPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Bandwidth->SetContentName(XMLString::transcode("Bandwidth"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::SetTransmissionTechnology(const Mp7JrsTransmissionTechnologyPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetTransmissionTechnology().");
	}
	if (m_TransmissionTechnology != item || m_TransmissionTechnology_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_TransmissionTechnology);
		m_TransmissionTechnology = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TransmissionTechnology) m_TransmissionTechnology->SetParent(m_myself.getPointer());
		if (m_TransmissionTechnology && m_TransmissionTechnology->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TransmissionTechnologyType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TransmissionTechnology->UseTypeAttribute = true;
		}
		m_TransmissionTechnology_Exist = true;
		if(m_TransmissionTechnology != Mp7JrsTransmissionTechnologyPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TransmissionTechnology->SetContentName(XMLString::transcode("TransmissionTechnology"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidateTransmissionTechnology()
{
	m_TransmissionTechnology_Exist = false;
}
void Mp7JrsAudioSignalQualityType::SetErrorEventList(const Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetErrorEventList().");
	}
	if (m_ErrorEventList != item || m_ErrorEventList_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_ErrorEventList);
		m_ErrorEventList = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ErrorEventList) m_ErrorEventList->SetParent(m_myself.getPointer());
		if (m_ErrorEventList && m_ErrorEventList->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AudioSignalQualityType_ErrorEventList_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ErrorEventList->UseTypeAttribute = true;
		}
		m_ErrorEventList_Exist = true;
		if(m_ErrorEventList != Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ErrorEventList->SetContentName(XMLString::transcode("ErrorEventList"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidateErrorEventList()
{
	m_ErrorEventList_Exist = false;
}
Mp7JrsintegerVectorPtr Mp7JrsAudioSignalQualityType::Getchannels() const
{
	return GetBase()->Getchannels();
}

bool Mp7JrsAudioSignalQualityType::Existchannels() const
{
	return GetBase()->Existchannels();
}
void Mp7JrsAudioSignalQualityType::Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::Setchannels().");
	}
	GetBase()->Setchannels(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::Invalidatechannels()
{
	GetBase()->Invalidatechannels();
}
XMLCh * Mp7JrsAudioSignalQualityType::Getid() const
{
	return GetBase()->GetBase()->Getid();
}

bool Mp7JrsAudioSignalQualityType::Existid() const
{
	return GetBase()->GetBase()->Existid();
}
void Mp7JrsAudioSignalQualityType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::Setid().");
	}
	GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::Invalidateid()
{
	GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsAudioSignalQualityType::GettimeBase() const
{
	return GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsAudioSignalQualityType::ExisttimeBase() const
{
	return GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsAudioSignalQualityType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SettimeBase().");
	}
	GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidatetimeBase()
{
	GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsAudioSignalQualityType::GettimeUnit() const
{
	return GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsAudioSignalQualityType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsAudioSignalQualityType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SettimeUnit().");
	}
	GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsAudioSignalQualityType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsAudioSignalQualityType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsAudioSignalQualityType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsAudioSignalQualityType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsAudioSignalQualityType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsAudioSignalQualityType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAudioSignalQualityType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsAudioSignalQualityType::GetHeader() const
{
	return GetBase()->GetBase()->GetHeader();
}

void Mp7JrsAudioSignalQualityType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAudioSignalQualityType::SetHeader().");
	}
	GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsAudioSignalQualityType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  2, 8 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 2
//- N; id,  T:http://www.w3.org/2001/XMLSchema:ID, C:String 
//- N; timeBase,  T:urn:mpeg:mpeg7:schema:2004:xPathRefType, C:Pattern 
//- N; timeUnit,  T:urn:mpeg:mpeg7:schema:2004:durationType, C:Pattern 
//- N; mediaTimeBase,  T:urn:mpeg:mpeg7:schema:2004:xPathRefType, C:Pattern 
//- N; mediaTimeUnit,  T:urn:mpeg:mpeg7:schema:2004:mediaDurationType, C:Pattern 
//- N; channels,  T:urn:mpeg:mpeg7:schema:2004:integerVector, C:Collection 
//- N; IsOriginalMono,  T:http://www.w3.org/2001/XMLSchema:boolean, C:Value 
//- N; BroadcastReady,  T:http://www.w3.org/2001/XMLSchema:boolean, C:Value 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("IsOriginalMono")) == 0)
	{
		// IsOriginalMono is simple attribute boolean
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "bool");
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("BroadcastReady")) == 0)
	{
		// BroadcastReady is simple attribute boolean
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "bool");
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Operator")) == 0)
	{
		// Operator is simple element PersonType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetOperator()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PersonType")))) != empty)
			{
				// Is type allowed
				Mp7JrsPersonPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetOperator(p, client);
					if((p = GetOperator()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("UsedTool")) == 0)
	{
		// UsedTool is simple element CreationToolType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetUsedTool()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CreationToolType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCreationToolPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetUsedTool(p, client);
					if((p = GetUsedTool()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("BackgroundNoiseLevel")) == 0)
	{
		// BackgroundNoiseLevel is simple element BackgroundNoiseLevelType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetBackgroundNoiseLevel()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:BackgroundNoiseLevelType")))) != empty)
			{
				// Is type allowed
				Mp7JrsBackgroundNoiseLevelPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetBackgroundNoiseLevel(p, client);
					if((p = GetBackgroundNoiseLevel()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("RelativeDelay")) == 0)
	{
		// RelativeDelay is simple element RelativeDelayType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetRelativeDelay()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:RelativeDelayType")))) != empty)
			{
				// Is type allowed
				Mp7JrsRelativeDelayPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetRelativeDelay(p, client);
					if((p = GetRelativeDelay()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Balance")) == 0)
	{
		// Balance is simple element BalanceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetBalance()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:BalanceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsBalancePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetBalance(p, client);
					if((p = GetBalance()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("DcOffset")) == 0)
	{
		// DcOffset is simple element DcOffsetType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetDcOffset()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DcOffsetType")))) != empty)
			{
				// Is type allowed
				Mp7JrsDcOffsetPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetDcOffset(p, client);
					if((p = GetDcOffset()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CrossChannelCorrelation")) == 0)
	{
		// CrossChannelCorrelation is simple element CrossChannelCorrelationType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetCrossChannelCorrelation()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CrossChannelCorrelationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCrossChannelCorrelationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetCrossChannelCorrelation(p, client);
					if((p = GetCrossChannelCorrelation()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Bandwidth")) == 0)
	{
		// Bandwidth is simple element BandwidthType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetBandwidth()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:BandwidthType")))) != empty)
			{
				// Is type allowed
				Mp7JrsBandwidthPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetBandwidth(p, client);
					if((p = GetBandwidth()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TransmissionTechnology")) == 0)
	{
		// TransmissionTechnology is simple element TransmissionTechnologyType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetTransmissionTechnology()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TransmissionTechnologyType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTransmissionTechnologyPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetTransmissionTechnology(p, client);
					if((p = GetTransmissionTechnology()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ErrorEventList")) == 0)
	{
		// ErrorEventList is simple element AudioSignalQualityType_ErrorEventList_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetErrorEventList()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AudioSignalQualityType_ErrorEventList_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetErrorEventList(p, client);
					if((p = GetErrorEventList()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for AudioSignalQualityType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "AudioSignalQualityType");
	}
	return result;
}

XMLCh * Mp7JrsAudioSignalQualityType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsAudioSignalQualityType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsAudioSignalQualityType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("AudioSignalQualityType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_IsOriginalMono_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_IsOriginalMono);
		element->setAttributeNS(X(""), X("IsOriginalMono"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Attribute Serialization:
		

	// Optional attriute
	if(m_BroadcastReady_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_BroadcastReady);
		element->setAttributeNS(X(""), X("BroadcastReady"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_Operator != Mp7JrsPersonPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Operator->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Operator"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Operator->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_UsedTool != Mp7JrsCreationToolPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_UsedTool->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("UsedTool"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_UsedTool->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_BackgroundNoiseLevel != Mp7JrsBackgroundNoiseLevelPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_BackgroundNoiseLevel->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("BackgroundNoiseLevel"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_BackgroundNoiseLevel->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_RelativeDelay != Mp7JrsRelativeDelayPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_RelativeDelay->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("RelativeDelay"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_RelativeDelay->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Balance != Mp7JrsBalancePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Balance->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Balance"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Balance->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_DcOffset != Mp7JrsDcOffsetPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_DcOffset->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("DcOffset"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_DcOffset->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CrossChannelCorrelation != Mp7JrsCrossChannelCorrelationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CrossChannelCorrelation->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CrossChannelCorrelation"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CrossChannelCorrelation->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Bandwidth != Mp7JrsBandwidthPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Bandwidth->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Bandwidth"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Bandwidth->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_TransmissionTechnology != Mp7JrsTransmissionTechnologyPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TransmissionTechnology->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TransmissionTechnology"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TransmissionTechnology->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ErrorEventList != Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ErrorEventList->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ErrorEventList"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ErrorEventList->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsAudioSignalQualityType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("IsOriginalMono")))
	{
		// deserialize value type
		this->SetIsOriginalMono(Mp7JrsConvert::TextToBool(parent->getAttribute(X("IsOriginalMono"))));
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("BroadcastReady")))
	{
		// deserialize value type
		this->SetBroadcastReady(Mp7JrsConvert::TextToBool(parent->getAttribute(X("BroadcastReady"))));
		* current = parent;
	}

	// Extensionbase is Mp7JrsAudioDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Operator"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Operator")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreatePersonType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetOperator(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("UsedTool"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("UsedTool")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateCreationToolType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetUsedTool(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("BackgroundNoiseLevel"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("BackgroundNoiseLevel")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateBackgroundNoiseLevelType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetBackgroundNoiseLevel(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("RelativeDelay"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("RelativeDelay")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateRelativeDelayType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetRelativeDelay(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Balance"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Balance")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateBalanceType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetBalance(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("DcOffset"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("DcOffset")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateDcOffsetType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetDcOffset(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CrossChannelCorrelation"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CrossChannelCorrelation")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateCrossChannelCorrelationType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetCrossChannelCorrelation(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Bandwidth"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Bandwidth")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateBandwidthType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetBandwidth(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TransmissionTechnology"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TransmissionTechnology")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateTransmissionTechnologyType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetTransmissionTechnology(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ErrorEventList"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ErrorEventList")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateAudioSignalQualityType_ErrorEventList_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetErrorEventList(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAudioSignalQualityType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  if (XMLString::compareString(elementname, X("Operator")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreatePersonType;
	}
	this->SetOperator(child);
  }
  if (XMLString::compareString(elementname, X("UsedTool")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateCreationToolType;
	}
	this->SetUsedTool(child);
  }
  if (XMLString::compareString(elementname, X("BackgroundNoiseLevel")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateBackgroundNoiseLevelType;
	}
	this->SetBackgroundNoiseLevel(child);
  }
  if (XMLString::compareString(elementname, X("RelativeDelay")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateRelativeDelayType;
	}
	this->SetRelativeDelay(child);
  }
  if (XMLString::compareString(elementname, X("Balance")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateBalanceType;
	}
	this->SetBalance(child);
  }
  if (XMLString::compareString(elementname, X("DcOffset")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateDcOffsetType;
	}
	this->SetDcOffset(child);
  }
  if (XMLString::compareString(elementname, X("CrossChannelCorrelation")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateCrossChannelCorrelationType;
	}
	this->SetCrossChannelCorrelation(child);
  }
  if (XMLString::compareString(elementname, X("Bandwidth")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateBandwidthType;
	}
	this->SetBandwidth(child);
  }
  if (XMLString::compareString(elementname, X("TransmissionTechnology")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateTransmissionTechnologyType;
	}
	this->SetTransmissionTechnology(child);
  }
  if (XMLString::compareString(elementname, X("ErrorEventList")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateAudioSignalQualityType_ErrorEventList_LocalType;
	}
	this->SetErrorEventList(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAudioSignalQualityType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetOperator() != Mp7JrsNodePtr())
		result.Insert(GetOperator());
	if (GetUsedTool() != Mp7JrsNodePtr())
		result.Insert(GetUsedTool());
	if (GetBackgroundNoiseLevel() != Mp7JrsNodePtr())
		result.Insert(GetBackgroundNoiseLevel());
	if (GetRelativeDelay() != Mp7JrsNodePtr())
		result.Insert(GetRelativeDelay());
	if (GetBalance() != Mp7JrsNodePtr())
		result.Insert(GetBalance());
	if (GetDcOffset() != Mp7JrsNodePtr())
		result.Insert(GetDcOffset());
	if (GetCrossChannelCorrelation() != Mp7JrsNodePtr())
		result.Insert(GetCrossChannelCorrelation());
	if (GetBandwidth() != Mp7JrsNodePtr())
		result.Insert(GetBandwidth());
	if (GetTransmissionTechnology() != Mp7JrsNodePtr())
		result.Insert(GetTransmissionTechnology());
	if (GetErrorEventList() != Mp7JrsNodePtr())
		result.Insert(GetErrorEventList());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtMethodImpl.h


