 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtImplInclude.h



#include "Mp7JrsClassificationType_SignLanguage_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsClassificationType_SignLanguage_LocalType::IMp7JrsClassificationType_SignLanguage_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtPropInit.h

}

IMp7JrsClassificationType_SignLanguage_LocalType::~IMp7JrsClassificationType_SignLanguage_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtPropCleanup.h

}

Mp7JrsClassificationType_SignLanguage_LocalType::Mp7JrsClassificationType_SignLanguage_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationType_SignLanguage_LocalType::~Mp7JrsClassificationType_SignLanguage_LocalType()
{
	Cleanup();
}

void Mp7JrsClassificationType_SignLanguage_LocalType::Init()
{
	// Init base
	m_Base = XMLString::transcode("");

	// Init attributes
	m_primary = false; // Value
	m_primary_Exist = false;
	m_translation = false; // Value
	m_translation_Exist = false;



// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtMyPropInit.h

}

void Mp7JrsClassificationType_SignLanguage_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_Base);
}

void Mp7JrsClassificationType_SignLanguage_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationType_SignLanguage_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationType_SignLanguage_LocalType
	const Mp7JrsPtr< Mp7JrsClassificationType_SignLanguage_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	XMLString::release(&m_Base);
	m_Base = XMLString::replicate(tmp->GetContent());
	{
	if (tmp->Existprimary())
	{
		this->Setprimary(tmp->Getprimary());
	}
	else
	{
		Invalidateprimary();
	}
	}
	{
	if (tmp->Existtranslation())
	{
		this->Settranslation(tmp->Gettranslation());
	}
	else
	{
		Invalidatetranslation();
	}
	}
}

Mp7JrsNodePtr Mp7JrsClassificationType_SignLanguage_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsClassificationType_SignLanguage_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


void Mp7JrsClassificationType_SignLanguage_LocalType::SetContent(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_SignLanguage_LocalType::SetContent().");
	}
	if (m_Base != item)
	{
		XMLString::release(&m_Base);
		m_Base = item;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsClassificationType_SignLanguage_LocalType::GetContent() const
{
	return m_Base;
}
bool Mp7JrsClassificationType_SignLanguage_LocalType::Getprimary() const
{
	return m_primary;
}

bool Mp7JrsClassificationType_SignLanguage_LocalType::Existprimary() const
{
	return m_primary_Exist;
}
void Mp7JrsClassificationType_SignLanguage_LocalType::Setprimary(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_SignLanguage_LocalType::Setprimary().");
	}
	m_primary = item;
	m_primary_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_SignLanguage_LocalType::Invalidateprimary()
{
	m_primary_Exist = false;
}
bool Mp7JrsClassificationType_SignLanguage_LocalType::Gettranslation() const
{
	return m_translation;
}

bool Mp7JrsClassificationType_SignLanguage_LocalType::Existtranslation() const
{
	return m_translation_Exist;
}
void Mp7JrsClassificationType_SignLanguage_LocalType::Settranslation(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_SignLanguage_LocalType::Settranslation().");
	}
	m_translation = item;
	m_translation_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_SignLanguage_LocalType::Invalidatetranslation()
{
	m_translation_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsClassificationType_SignLanguage_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  2, 2 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 2
//- N; primary,  T:http://www.w3.org/2001/XMLSchema:boolean, C:Value 
//- N; translation,  T:http://www.w3.org/2001/XMLSchema:boolean, C:Value 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("primary")) == 0)
	{
		// primary is simple attribute boolean
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "bool");
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("translation")) == 0)
	{
		// translation is simple attribute boolean
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "bool");
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ClassificationType_SignLanguage_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ClassificationType_SignLanguage_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsClassificationType_SignLanguage_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsClassificationType_SignLanguage_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsClassificationType_SignLanguage_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsClassificationType_SignLanguage_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsClassificationType_SignLanguage_LocalType::ContentToString() const
{
	// Mp7JrsClassificationType_SignLanguage_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsClassificationType_SignLanguage_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	element->appendChild(doc->createTextNode(m_Base));

	assert(element);
// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationType_SignLanguage_LocalType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_primary_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_primary);
		element->setAttributeNS(X(""), X("primary"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Attribute Serialization:
		

	// Optional attriute
	if(m_translation_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_translation);
		element->setAttributeNS(X(""), X("translation"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsClassificationType_SignLanguage_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("primary")))
	{
		// deserialize value type
		this->Setprimary(Mp7JrsConvert::TextToBool(parent->getAttribute(X("primary"))));
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("translation")))
	{
		// deserialize value type
		this->Settranslation(Mp7JrsConvert::TextToBool(parent->getAttribute(X("translation"))));
		* current = parent;
	}

	XMLCh * tmp = Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent));
	if(tmp != NULL)
	{
		XMLString::release(&m_Base);
		m_Base = tmp;
		found = true;
	}
// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationType_SignLanguage_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationType_SignLanguage_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationType_SignLanguage_LocalType_ExtMethodImpl.h


