 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtImplInclude.h



#include "Mp7JrsClassificationType_Target_Market_CollectionType.h"
#include "Mp7JrsClassificationType_Target_Age_LocalType.h"
#include "Mp7JrsClassificationType_Target_Region_CollectionType.h"
#include "Mp7JrsClassificationType_Target_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsControlledTermUseType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Market
#include "Mp7JrsregionCode.h" // Element collection urn:mpeg:mpeg7:schema:2004:Region

#include <assert.h>
IMp7JrsClassificationType_Target_LocalType::IMp7JrsClassificationType_Target_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtPropInit.h

}

IMp7JrsClassificationType_Target_LocalType::~IMp7JrsClassificationType_Target_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtPropCleanup.h

}

Mp7JrsClassificationType_Target_LocalType::Mp7JrsClassificationType_Target_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsClassificationType_Target_LocalType::~Mp7JrsClassificationType_Target_LocalType()
{
	Cleanup();
}

void Mp7JrsClassificationType_Target_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Market = Mp7JrsClassificationType_Target_Market_CollectionPtr(); // Collection
	m_Age = Mp7JrsClassificationType_Target_Age_LocalPtr(); // Class
	m_Age_Exist = false;
	m_Region = Mp7JrsClassificationType_Target_Region_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtMyPropInit.h

}

void Mp7JrsClassificationType_Target_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Market);
	// Mp7JrsFactory::DeleteObject(m_Age);
	// Mp7JrsFactory::DeleteObject(m_Region);
}

void Mp7JrsClassificationType_Target_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ClassificationType_Target_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IClassificationType_Target_LocalType
	const Mp7JrsPtr< Mp7JrsClassificationType_Target_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Market);
		this->SetMarket(Mp7JrsFactory::CloneObject(tmp->GetMarket()));
	if (tmp->IsValidAge())
	{
		// Mp7JrsFactory::DeleteObject(m_Age);
		this->SetAge(Mp7JrsFactory::CloneObject(tmp->GetAge()));
	}
	else
	{
		InvalidateAge();
	}
		// Mp7JrsFactory::DeleteObject(m_Region);
		this->SetRegion(Mp7JrsFactory::CloneObject(tmp->GetRegion()));
}

Mp7JrsNodePtr Mp7JrsClassificationType_Target_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsClassificationType_Target_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsClassificationType_Target_Market_CollectionPtr Mp7JrsClassificationType_Target_LocalType::GetMarket() const
{
		return m_Market;
}

Mp7JrsClassificationType_Target_Age_LocalPtr Mp7JrsClassificationType_Target_LocalType::GetAge() const
{
		return m_Age;
}

// Element is optional
bool Mp7JrsClassificationType_Target_LocalType::IsValidAge() const
{
	return m_Age_Exist;
}

Mp7JrsClassificationType_Target_Region_CollectionPtr Mp7JrsClassificationType_Target_LocalType::GetRegion() const
{
		return m_Region;
}

void Mp7JrsClassificationType_Target_LocalType::SetMarket(const Mp7JrsClassificationType_Target_Market_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_Target_LocalType::SetMarket().");
	}
	if (m_Market != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Market);
		m_Market = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Market) m_Market->SetParent(m_myself.getPointer());
		if(m_Market != Mp7JrsClassificationType_Target_Market_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Market->SetContentName(XMLString::transcode("Market"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_Target_LocalType::SetAge(const Mp7JrsClassificationType_Target_Age_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_Target_LocalType::SetAge().");
	}
	if (m_Age != item || m_Age_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Age);
		m_Age = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Age) m_Age->SetParent(m_myself.getPointer());
		if (m_Age && m_Age->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_Target_Age_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Age->UseTypeAttribute = true;
		}
		m_Age_Exist = true;
		if(m_Age != Mp7JrsClassificationType_Target_Age_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Age->SetContentName(XMLString::transcode("Age"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsClassificationType_Target_LocalType::InvalidateAge()
{
	m_Age_Exist = false;
}
void Mp7JrsClassificationType_Target_LocalType::SetRegion(const Mp7JrsClassificationType_Target_Region_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsClassificationType_Target_LocalType::SetRegion().");
	}
	if (m_Region != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Region);
		m_Region = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Region) m_Region->SetParent(m_myself.getPointer());
		if(m_Region != Mp7JrsClassificationType_Target_Region_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Region->SetContentName(XMLString::transcode("Region"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsClassificationType_Target_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Market")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Market is item of type ControlledTermUseType
		// in element collection ClassificationType_Target_Market_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_Target_Market_CollectionPtr coll = GetMarket();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_Target_Market_CollectionType;
				SetMarket(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsControlledTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Age")) == 0)
	{
		// Age is simple element ClassificationType_Target_Age_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetAge()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClassificationType_Target_Age_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClassificationType_Target_Age_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetAge(p, client);
					if((p = GetAge()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Region")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Region is item of type regionCode
		// in element collection ClassificationType_Target_Region_CollectionType
		
		context->Found = true;
		Mp7JrsClassificationType_Target_Region_CollectionPtr coll = GetRegion();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateClassificationType_Target_Region_CollectionType;
				SetRegion(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:regionCode")))) != empty)
			{
				// Is type allowed
				Mp7JrsregionCodePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ClassificationType_Target_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ClassificationType_Target_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsClassificationType_Target_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsClassificationType_Target_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsClassificationType_Target_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ClassificationType_Target_LocalType"));
	// Element serialization:
	if (m_Market != Mp7JrsClassificationType_Target_Market_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Market->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	// Class
	
	if (m_Age != Mp7JrsClassificationType_Target_Age_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Age->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Age"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Age->Serialize(doc, element, &elem);
	}
	if (m_Region != Mp7JrsClassificationType_Target_Region_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Region->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsClassificationType_Target_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
		
		// Element Collection
		if((parent != NULL) && 
		Mp7JrsUtil::HasNodeName(parent, X("Market"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD		(XMLString::compareString(parent->getNodeName(), X("Market")) == 0))
		{
			// Deserialize factory type
			Mp7JrsClassificationType_Target_Market_CollectionPtr tmp = CreateClassificationType_Target_Market_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetMarket(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Age"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Age")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateClassificationType_Target_Age_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetAge(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		
		// Element Collection
		if((parent != NULL) && 
		Mp7JrsUtil::HasNodeName(parent, X("Region"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD		(XMLString::compareString(parent->getNodeName(), X("Region")) == 0))
		{
			// Deserialize factory type
			Mp7JrsClassificationType_Target_Region_CollectionPtr tmp = CreateClassificationType_Target_Region_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetRegion(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsClassificationType_Target_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Market")) == 0))
  {
	Mp7JrsClassificationType_Target_Market_CollectionPtr tmp = CreateClassificationType_Target_Market_CollectionType;
	this->SetMarket(tmp);
	child = tmp;
  }
  if (XMLString::compareString(elementname, X("Age")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateClassificationType_Target_Age_LocalType;
	}
	this->SetAge(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Region")) == 0))
  {
	Mp7JrsClassificationType_Target_Region_CollectionPtr tmp = CreateClassificationType_Target_Region_CollectionType;
	this->SetRegion(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsClassificationType_Target_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMarket() != Mp7JrsNodePtr())
		result.Insert(GetMarket());
	if (GetAge() != Mp7JrsNodePtr())
		result.Insert(GetAge());
	if (GetRegion() != Mp7JrsNodePtr())
		result.Insert(GetRegion());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsClassificationType_Target_LocalType_ExtMethodImpl.h


