 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_ExtImplInclude.h



#include "Mp7JrsColorQuantizationType_CollectionType.h"
#include "Mp7JrsColorQuantizationType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsColorQuantizationType_LocalType.h" // Sequence collection NumOfBins
#include "Mp7Jrsunsigned12.h" // Sequence collection element NumOfBins

#include <assert.h>
IMp7JrsColorQuantizationType::IMp7JrsColorQuantizationType()
{

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_ExtPropInit.h

}

IMp7JrsColorQuantizationType::~IMp7JrsColorQuantizationType()
{
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_ExtPropCleanup.h

}

Mp7JrsColorQuantizationType::Mp7JrsColorQuantizationType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsColorQuantizationType::~Mp7JrsColorQuantizationType()
{
	Cleanup();
}

void Mp7JrsColorQuantizationType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_ColorQuantizationType_LocalType = Mp7JrsColorQuantizationType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_ExtMyPropInit.h

}

void Mp7JrsColorQuantizationType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_ColorQuantizationType_LocalType);
}

void Mp7JrsColorQuantizationType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ColorQuantizationTypePtr, since we
	// might need GetBase(), which isn't defined in IColorQuantizationType
	const Mp7JrsPtr< Mp7JrsColorQuantizationType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_ColorQuantizationType_LocalType);
		this->SetColorQuantizationType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetColorQuantizationType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsColorQuantizationType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsColorQuantizationType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsColorQuantizationType_CollectionPtr Mp7JrsColorQuantizationType::GetColorQuantizationType_LocalType() const
{
		return m_ColorQuantizationType_LocalType;
}

void Mp7JrsColorQuantizationType::SetColorQuantizationType_LocalType(const Mp7JrsColorQuantizationType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorQuantizationType::SetColorQuantizationType_LocalType().");
	}
	if (m_ColorQuantizationType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ColorQuantizationType_LocalType);
		m_ColorQuantizationType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ColorQuantizationType_LocalType) m_ColorQuantizationType_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsColorQuantizationType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("NumOfBins")) == 0)
	{
		// NumOfBins is contained in itemtype ColorQuantizationType_LocalType
		// in sequence collection ColorQuantizationType_CollectionType

		context->Found = true;
		Mp7JrsColorQuantizationType_CollectionPtr coll = GetColorQuantizationType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateColorQuantizationType_CollectionType;
				SetColorQuantizationType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 3))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsColorQuantizationType_LocalPtr)coll->elementAt(i))->GetNumOfBins()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsColorQuantizationType_LocalPtr item = CreateColorQuantizationType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsColorQuantizationType_LocalPtr)coll->elementAt(j))->SetNumOfBins(
						((Mp7JrsColorQuantizationType_LocalPtr)coll->elementAt(j+1))->GetNumOfBins());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsColorQuantizationType_LocalPtr)coll->elementAt(j))->SetNumOfBins(
						((Mp7JrsColorQuantizationType_LocalPtr)coll->elementAt(j-1))->GetNumOfBins());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned12")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned12Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsColorQuantizationType_LocalPtr)coll->elementAt(i))->SetNumOfBins(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsColorQuantizationType_LocalPtr)coll->elementAt(i))->GetNumOfBins()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ColorQuantizationType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ColorQuantizationType");
	}
	return result;
}

XMLCh * Mp7JrsColorQuantizationType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsColorQuantizationType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsColorQuantizationType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ColorQuantizationType"));
	// Element serialization:
	if (m_ColorQuantizationType_LocalType != Mp7JrsColorQuantizationType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_ColorQuantizationType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsColorQuantizationType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
		// Sequence Collection
		if((parent != NULL) && (
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Component")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("Component"), X("urn:mpeg:mpeg7:schema:2004")))
				||
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:NumOfBins")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("NumOfBins"), X("urn:mpeg:mpeg7:schema:2004")))
				))
		{
			// Deserialize factory type
			Mp7JrsColorQuantizationType_CollectionPtr tmp = CreateColorQuantizationType_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetColorQuantizationType_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsColorQuantizationType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
	// local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
	Mp7JrsColorQuantizationType_CollectionPtr tmp = CreateColorQuantizationType_CollectionType;
	this->SetColorQuantizationType_LocalType(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsColorQuantizationType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetColorQuantizationType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetColorQuantizationType_LocalType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_ExtMethodImpl.h


