
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_Component_LocalType_ExtImplInclude.h


#include "Mp7JrsColorQuantizationType_Component_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_Component_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsColorQuantizationType_Component_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsColorQuantizationType_Component_LocalType::ToText(Mp7JrsColorQuantizationType_Component_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/R:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("R");
			break;
		case /*Enumeration::*/G:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("G");
			break;
		case /*Enumeration::*/B:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("B");
			break;
		case /*Enumeration::*/Y:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Y");
			break;
		case /*Enumeration::*/Cb:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Cb");
			break;
		case /*Enumeration::*/Cr:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Cr");
			break;
		case /*Enumeration::*/H:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("H");
			break;
		case /*Enumeration::*/S:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("S");
			break;
		case /*Enumeration::*/V:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("V");
			break;
		case /*Enumeration::*/Max:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Max");
			break;
		case /*Enumeration::*/Min:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Min");
			break;
		case /*Enumeration::*/Diff:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Diff");
			break;
		case /*Enumeration::*/Sum:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Sum");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsColorQuantizationType_Component_LocalType::Enumeration Mp7JrsColorQuantizationType_Component_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsColorQuantizationType_Component_LocalType::Enumeration result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "R") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/R;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "G") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/G;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "B") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/B;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Y") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/Y;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Cb") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/Cb;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Cr") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/Cr;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "H") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/H;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "S") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/S;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "V") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/V;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Max") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/Max;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Min") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/Min;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Diff") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/Diff;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Sum") == 0)
	{
		result = Mp7JrsColorQuantizationType_Component_LocalType::/*Enumeration::*/Sum;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
