 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtImplInclude.h



#include "Mp7JrstermAliasReferenceType.h"
#include "Mp7JrstermURIReferenceType.h"
#include "Mp7JrsDependencyStructurePhraseType_operator_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsDependencyStructurePhraseType_operator_LocalType::IMp7JrsDependencyStructurePhraseType_operator_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtPropInit.h

}

IMp7JrsDependencyStructurePhraseType_operator_LocalType::~IMp7JrsDependencyStructurePhraseType_operator_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtPropCleanup.h

}

Mp7JrsDependencyStructurePhraseType_operator_LocalType::Mp7JrsDependencyStructurePhraseType_operator_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsDependencyStructurePhraseType_operator_LocalType::~Mp7JrsDependencyStructurePhraseType_operator_LocalType()
{
	Cleanup();
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_dependencyOperatorType = Mp7JrsdependencyOperatorType::UninitializedEnumeration; // Enumeration
	m_termAliasReferenceType = Mp7JrstermAliasReferencePtr(); // Pattern
	m_termURIReferenceType = Mp7JrstermURIReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtMyPropInit.h

}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_termAliasReferenceType);
	// Mp7JrsFactory::DeleteObject(m_termURIReferenceType);
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use DependencyStructurePhraseType_operator_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IDependencyStructurePhraseType_operator_LocalType
	const Mp7JrsPtr< Mp7JrsDependencyStructurePhraseType_operator_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if(tmp->GetdependencyOperatorType() != Mp7JrsdependencyOperatorType::UninitializedEnumeration)
	{
		this->SetdependencyOperatorType(tmp->GetdependencyOperatorType());
		return;
	}
	if(tmp->GettermAliasReferenceType() != Mp7JrstermAliasReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		this->SettermAliasReferenceType(Mp7JrsFactory::CloneObject(tmp->GettermAliasReferenceType()));
		return;
	}
	if(tmp->GettermURIReferenceType() != Mp7JrstermURIReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		this->SettermURIReferenceType(Mp7JrsFactory::CloneObject(tmp->GettermURIReferenceType()));
		return; 
	}
	}
}

Mp7JrsNodePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsdependencyOperatorType::Enumeration Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetdependencyOperatorType() const
{
		return m_dependencyOperatorType;
}

Mp7JrstermAliasReferencePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GettermAliasReferenceType() const
{
		return m_termAliasReferenceType;
}

Mp7JrstermURIReferencePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GettermURIReferenceType() const
{
		return m_termURIReferenceType;
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::SetdependencyOperatorType(Mp7JrsdependencyOperatorType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDependencyStructurePhraseType_operator_LocalType::SetdependencyOperatorType().");
	}
	if (m_dependencyOperatorType != item)
	{
		// nothing to free here, hopefully
		m_dependencyOperatorType = item;
	// Mp7JrsFactory::DeleteObject(m_termAliasReferenceType);
	m_termAliasReferenceType = Mp7JrstermAliasReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_termURIReferenceType);
	m_termURIReferenceType = Mp7JrstermURIReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::SettermAliasReferenceType(const Mp7JrstermAliasReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDependencyStructurePhraseType_operator_LocalType::SettermAliasReferenceType().");
	}
	if (m_termAliasReferenceType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_termAliasReferenceType);
		m_termAliasReferenceType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_termAliasReferenceType) m_termAliasReferenceType->SetParent(m_myself.getPointer());
		if (m_termAliasReferenceType && m_termAliasReferenceType->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termAliasReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_termAliasReferenceType->UseTypeAttribute = true;
		}
		if(m_termAliasReferenceType != Mp7JrstermAliasReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_termAliasReferenceType->SetContentName(XMLString::transcode("termAliasReferenceType"));
		}
	
	m_dependencyOperatorType = Mp7JrsdependencyOperatorType::UninitializedEnumeration;
	// Mp7JrsFactory::DeleteObject(m_termURIReferenceType);
	m_termURIReferenceType = Mp7JrstermURIReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::SettermURIReferenceType(const Mp7JrstermURIReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDependencyStructurePhraseType_operator_LocalType::SettermURIReferenceType().");
	}
	if (m_termURIReferenceType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_termURIReferenceType);
		m_termURIReferenceType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_termURIReferenceType) m_termURIReferenceType->SetParent(m_myself.getPointer());
		if (m_termURIReferenceType && m_termURIReferenceType->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termURIReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_termURIReferenceType->UseTypeAttribute = true;
		}
		if(m_termURIReferenceType != Mp7JrstermURIReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_termURIReferenceType->SetContentName(XMLString::transcode("termURIReferenceType"));
		}
	
	m_dependencyOperatorType = Mp7JrsdependencyOperatorType::UninitializedEnumeration;
	// Mp7JrsFactory::DeleteObject(m_termAliasReferenceType);
	m_termAliasReferenceType = Mp7JrstermAliasReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("termAliasReferenceType")) == 0)
	{
		// termAliasReferenceType is simple element termAliasReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GettermAliasReferenceType()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termAliasReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrstermAliasReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SettermAliasReferenceType(p, client);
					if((p = GettermAliasReferenceType()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("termURIReferenceType")) == 0)
	{
		// termURIReferenceType is simple element termURIReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GettermURIReferenceType()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termURIReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrstermURIReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SettermURIReferenceType(p, client);
					if((p = GettermURIReferenceType()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for DependencyStructurePhraseType_operator_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "DependencyStructurePhraseType_operator_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsDependencyStructurePhraseType_operator_LocalType::ToText() const
{
	if(m_dependencyOperatorType != Mp7JrsdependencyOperatorType::UninitializedEnumeration)
	{
		return Mp7JrsdependencyOperatorType::ToText(m_dependencyOperatorType);
	}
	if(m_termAliasReferenceType != Mp7JrstermAliasReferencePtr())
	{
		return m_termAliasReferenceType->ToText();
	}
	if(m_termURIReferenceType != Mp7JrstermURIReferencePtr())
	{
		return m_termURIReferenceType->ToText();
	}
	return XMLString::transcode("");
}


bool Mp7JrsDependencyStructurePhraseType_operator_LocalType::Parse(const XMLCh * const txt)
{
	// Parse stu enumeration
	{
		Mp7JrsdependencyOperatorType::Enumeration tmp = Mp7JrsdependencyOperatorType::Parse(txt);
		if(tmp != Mp7JrsdependencyOperatorType::UninitializedEnumeration)
		{
			this->SetdependencyOperatorType(tmp);
			return true;
		}
	}
	// Parse stu pattern type
	{
		Mp7JrstermAliasReferencePtr tmp = CreatetermAliasReferenceType;
		if(tmp->Parse(txt))
		{
			this->SettermAliasReferenceType(tmp);
			return true;
		}
		Mp7JrsFactory::DeleteObject(tmp);
	}
	// Parse stu factory type
	{
		Mp7JrstermURIReferencePtr tmp = CreatetermURIReferenceType;
		if(tmp->Parse(txt))
		{
			this->SettermURIReferenceType(tmp);
			return true;
		}
		Mp7JrsFactory::DeleteObject(tmp);
	}
	return false;
}

bool Mp7JrsDependencyStructurePhraseType_operator_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsDependencyStructurePhraseType_operator_LocalType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsDependencyStructurePhraseType_operator_LocalType::ContentToString() const
{
	// Mp7JrsDependencyStructurePhraseType_operator_LocalType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("DependencyStructurePhraseType_operator_LocalType"));
	// Element serialization:
	if(m_dependencyOperatorType != Mp7JrsdependencyOperatorType::UninitializedEnumeration) // Enumeration
	{
		XMLCh * tmp = Mp7JrsdependencyOperatorType::ToText(m_dependencyOperatorType);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("dependencyOperatorType"), false);
		XMLString::release(&tmp);
	}
	if(m_termAliasReferenceType != Mp7JrstermAliasReferencePtr()) // Pattern FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Pattern
		// CON contentname already set in element setter -- not needed here
//		XMLCh * contentname = XMLString::transcode("termAliasReferenceType");
//		m_termAliasReferenceType->SetContentName(contentname);
		m_termAliasReferenceType->UseTypeAttribute = this->UseTypeAttribute;
		m_termAliasReferenceType->Serialize(doc, element);
	}
	// Class
	
	if (m_termURIReferenceType != Mp7JrstermURIReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_termURIReferenceType->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("termURIReferenceType"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_termURIReferenceType->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsDependencyStructurePhraseType_operator_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
		// Deserialize enumeration element
	if(Mp7JrsUtil::HasNodeName(parent, X("dependencyOperatorType"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("dependencyOperatorType")) == 0))
		{
			Mp7JrsdependencyOperatorType::Enumeration tmp = Mp7JrsdependencyOperatorType::Parse(Mp7JrsUtil::GetElementText(parent));
			if(tmp == Mp7JrsdependencyOperatorType::UninitializedEnumeration)
			{
					return false;
			}
			this->SetdependencyOperatorType(tmp);
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize pattern element
	if(Mp7JrsUtil::HasNodeName(parent, X("termAliasReferenceType"), X("urn:mpeg:mpeg7:schema:2004")))
//			if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("termAliasReferenceType")) == 0))
		{
			Mp7JrstermAliasReferencePtr tmp = CreatetermAliasReferenceType;
			tmp->Deserialize(doc, parent, current);
			this->SettermAliasReferenceType(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("termURIReferenceType"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("termURIReferenceType")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreatetermURIReferenceType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SettermURIReferenceType(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("termAliasReferenceType")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreatetermAliasReferenceType;
	}
	this->SettermAliasReferenceType(child);
  }
  if (XMLString::compareString(elementname, X("termURIReferenceType")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreatetermURIReferenceType;
	}
	this->SettermURIReferenceType(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GettermAliasReferenceType() != Mp7JrsNodePtr())
		result.Insert(GettermAliasReferenceType());
	if (GettermURIReferenceType() != Mp7JrsNodePtr())
		result.Insert(GettermURIReferenceType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtMethodImpl.h


