 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtImplInclude.h



#include "Mp7JrsShotType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsGlobalTransitionType.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtPropInit.h

}

IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::~IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtPropCleanup.h

}

Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::~Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType()
{
	Cleanup();
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Shot = Mp7JrsShotPtr(); // Class
	m_ShotRef = Mp7JrsReferencePtr(); // Class
	m_GlobalTransition = Mp7JrsGlobalTransitionPtr(); // Class
	m_GlobalTransitionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Shot);
	// Mp7JrsFactory::DeleteObject(m_ShotRef);
	// Mp7JrsFactory::DeleteObject(m_GlobalTransition);
	// Mp7JrsFactory::DeleteObject(m_GlobalTransitionRef);
}

void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use EditedVideoEditingTemporalDecompositionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IEditedVideoEditingTemporalDecompositionType_LocalType
	const Mp7JrsPtr< Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Shot);
		this->SetShot(Mp7JrsFactory::CloneObject(tmp->GetShot()));
		// Mp7JrsFactory::DeleteObject(m_ShotRef);
		this->SetShotRef(Mp7JrsFactory::CloneObject(tmp->GetShotRef()));
		// Mp7JrsFactory::DeleteObject(m_GlobalTransition);
		this->SetGlobalTransition(Mp7JrsFactory::CloneObject(tmp->GetGlobalTransition()));
		// Mp7JrsFactory::DeleteObject(m_GlobalTransitionRef);
		this->SetGlobalTransitionRef(Mp7JrsFactory::CloneObject(tmp->GetGlobalTransitionRef()));
}

Mp7JrsNodePtr Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsShotPtr Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetShot() const
{
		return m_Shot;
}

Mp7JrsReferencePtr Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetShotRef() const
{
		return m_ShotRef;
}

Mp7JrsGlobalTransitionPtr Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetGlobalTransition() const
{
		return m_GlobalTransition;
}

Mp7JrsReferencePtr Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetGlobalTransitionRef() const
{
		return m_GlobalTransitionRef;
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* choice */
// implementing setter for choice 
/* element */
void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetShot(const Mp7JrsShotPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetShot().");
	}
	if (m_Shot != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Shot);
		m_Shot = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Shot) m_Shot->SetParent(m_myself.getPointer());
		if (m_Shot && m_Shot->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ShotType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Shot->UseTypeAttribute = true;
		}
		if(m_Shot != Mp7JrsShotPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Shot->SetContentName(XMLString::transcode("Shot"));
		}
	// Mp7JrsFactory::DeleteObject(m_ShotRef);
	m_ShotRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_GlobalTransition);
	m_GlobalTransition = Mp7JrsGlobalTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_GlobalTransitionRef);
	m_GlobalTransitionRef = Mp7JrsReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetShotRef().");
	}
	if (m_ShotRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ShotRef);
		m_ShotRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ShotRef) m_ShotRef->SetParent(m_myself.getPointer());
		if (m_ShotRef && m_ShotRef->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ShotRef->UseTypeAttribute = true;
		}
		if(m_ShotRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ShotRef->SetContentName(XMLString::transcode("ShotRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_Shot);
	m_Shot = Mp7JrsShotPtr();
	// Mp7JrsFactory::DeleteObject(m_GlobalTransition);
	m_GlobalTransition = Mp7JrsGlobalTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_GlobalTransitionRef);
	m_GlobalTransitionRef = Mp7JrsReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* choice */
// implementing setter for choice 
/* element */
void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetGlobalTransition(const Mp7JrsGlobalTransitionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetGlobalTransition().");
	}
	if (m_GlobalTransition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_GlobalTransition);
		m_GlobalTransition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_GlobalTransition) m_GlobalTransition->SetParent(m_myself.getPointer());
		if (m_GlobalTransition && m_GlobalTransition->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:GlobalTransitionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_GlobalTransition->UseTypeAttribute = true;
		}
		if(m_GlobalTransition != Mp7JrsGlobalTransitionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_GlobalTransition->SetContentName(XMLString::transcode("GlobalTransition"));
		}
	// Mp7JrsFactory::DeleteObject(m_GlobalTransitionRef);
	m_GlobalTransitionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_Shot);
	m_Shot = Mp7JrsShotPtr();
	// Mp7JrsFactory::DeleteObject(m_ShotRef);
	m_ShotRef = Mp7JrsReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetGlobalTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::SetGlobalTransitionRef().");
	}
	if (m_GlobalTransitionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_GlobalTransitionRef);
		m_GlobalTransitionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_GlobalTransitionRef) m_GlobalTransitionRef->SetParent(m_myself.getPointer());
		if (m_GlobalTransitionRef && m_GlobalTransitionRef->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_GlobalTransitionRef->UseTypeAttribute = true;
		}
		if(m_GlobalTransitionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_GlobalTransitionRef->SetContentName(XMLString::transcode("GlobalTransitionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_GlobalTransition);
	m_GlobalTransition = Mp7JrsGlobalTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_Shot);
	m_Shot = Mp7JrsShotPtr();
	// Mp7JrsFactory::DeleteObject(m_ShotRef);
	m_ShotRef = Mp7JrsReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: EditedVideoEditingTemporalDecompositionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("EditedVideoEditingTemporalDecompositionType_LocalType"));
	// Element serialization:
	// Class
	
	if (m_Shot != Mp7JrsShotPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Shot->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Shot"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Shot->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ShotRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ShotRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ShotRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ShotRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_GlobalTransition != Mp7JrsGlobalTransitionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_GlobalTransition->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("GlobalTransition"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_GlobalTransition->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_GlobalTransitionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_GlobalTransitionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("GlobalTransitionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_GlobalTransitionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
	{
	do // Deserialize choice just one time!
	{
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Shot"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Shot")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateShotType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetShot(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ShotRef"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ShotRef")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateReferenceType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetShotRef(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
	} while(false);
	do // Deserialize choice just one time!
	{
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("GlobalTransition"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("GlobalTransition")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateGlobalTransitionType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetGlobalTransition(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("GlobalTransitionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("GlobalTransitionRef")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateReferenceType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetGlobalTransitionRef(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
	} while(false);
	} while(false);
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Shot")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateShotType;
	}
	this->SetShot(child);
  }
  if (XMLString::compareString(elementname, X("ShotRef")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateReferenceType;
	}
	this->SetShotRef(child);
  }
  if (XMLString::compareString(elementname, X("GlobalTransition")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateGlobalTransitionType;
	}
	this->SetGlobalTransition(child);
  }
  if (XMLString::compareString(elementname, X("GlobalTransitionRef")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateReferenceType;
	}
	this->SetGlobalTransitionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetShot() != Mp7JrsNodePtr())
		result.Insert(GetShot());
	if (GetShotRef() != Mp7JrsNodePtr())
		result.Insert(GetShotRef());
	if (GetGlobalTransition() != Mp7JrsNodePtr())
		result.Insert(GetGlobalTransition());
	if (GetGlobalTransitionRef() != Mp7JrsNodePtr())
		result.Insert(GetGlobalTransitionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtMethodImpl.h


