
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsFragmentUpdateCommandType_LocalType_ExtImplInclude.h


#include "Mp7JrsFragmentUpdateCommandType_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsFragmentUpdateCommandType_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsFragmentUpdateCommandType_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsFragmentUpdateCommandType_LocalType::ToText(Mp7JrsFragmentUpdateCommandType_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/addNode:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("addNode");
			break;
		case /*Enumeration::*/deleteNode:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("deleteNode");
			break;
		case /*Enumeration::*/replaceNode:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("replaceNode");
			break;
		case /*Enumeration::*/reset:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("reset");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsFragmentUpdateCommandType_LocalType::Enumeration Mp7JrsFragmentUpdateCommandType_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsFragmentUpdateCommandType_LocalType::Enumeration result = Mp7JrsFragmentUpdateCommandType_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "addNode") == 0)
	{
		result = Mp7JrsFragmentUpdateCommandType_LocalType::/*Enumeration::*/addNode;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "deleteNode") == 0)
	{
		result = Mp7JrsFragmentUpdateCommandType_LocalType::/*Enumeration::*/deleteNode;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "replaceNode") == 0)
	{
		result = Mp7JrsFragmentUpdateCommandType_LocalType::/*Enumeration::*/replaceNode;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "reset") == 0)
	{
		result = Mp7JrsFragmentUpdateCommandType_LocalType::/*Enumeration::*/reset;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
