 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtImplInclude.h



#include "Mp7JrsTemporalSegmentDecompositionType.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType.h" // Sequence collection IntraCompositionShot
#include "Mp7JrsIntraCompositionShotType.h" // Sequence collection element IntraCompositionShot
#include "Mp7JrsReferenceType.h" // Sequence collection element IntraCompositionShotRef
#include "Mp7JrsInternalTransitionType.h" // Sequence collection element InternalTransition

#include <assert.h>
IMp7JrsIntraCompositionShotEditingTemporalDecompositionType::IMp7JrsIntraCompositionShotEditingTemporalDecompositionType()
{

// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtPropInit.h

}

IMp7JrsIntraCompositionShotEditingTemporalDecompositionType::~IMp7JrsIntraCompositionShotEditingTemporalDecompositionType()
{
// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtPropCleanup.h

}

Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Mp7JrsIntraCompositionShotEditingTemporalDecompositionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::~Mp7JrsIntraCompositionShotEditingTemporalDecompositionType()
{
	Cleanup();
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Init()
{
	// Init base
	m_Base = CreateTemporalSegmentDecompositionType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_IntraCompositionShotEditingTemporalDecompositionType_LocalType = Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtMyPropInit.h

}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotEditingTemporalDecompositionType_LocalType);
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use IntraCompositionShotEditingTemporalDecompositionTypePtr, since we
	// might need GetBase(), which isn't defined in IIntraCompositionShotEditingTemporalDecompositionType
	const Mp7JrsPtr< Mp7JrsIntraCompositionShotEditingTemporalDecompositionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsTemporalSegmentDecompositionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsIntraCompositionShotEditingTemporalDecompositionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotEditingTemporalDecompositionType_LocalType);
		this->SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetIntraCompositionShotEditingTemporalDecompositionType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsTemporalSegmentDecompositionType > Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetBase() const
{
	return m_Base;
}

Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetIntraCompositionShotEditingTemporalDecompositionType_LocalType() const
{
		return m_IntraCompositionShotEditingTemporalDecompositionType_LocalType;
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(const Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetIntraCompositionShotEditingTemporalDecompositionType_LocalType().");
	}
	if (m_IntraCompositionShotEditingTemporalDecompositionType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotEditingTemporalDecompositionType_LocalType);
		m_IntraCompositionShotEditingTemporalDecompositionType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_IntraCompositionShotEditingTemporalDecompositionType_LocalType) m_IntraCompositionShotEditingTemporalDecompositionType_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Getcriteria() const
{
	return GetBase()->GetBase()->Getcriteria();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Existcriteria() const
{
	return GetBase()->GetBase()->Existcriteria();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setcriteria(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setcriteria().");
	}
	GetBase()->GetBase()->Setcriteria(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Invalidatecriteria()
{
	GetBase()->GetBase()->Invalidatecriteria();
}
bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Getoverlap() const
{
	return GetBase()->GetBase()->Getoverlap();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Existoverlap() const
{
	return GetBase()->GetBase()->Existoverlap();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setoverlap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setoverlap().");
	}
	GetBase()->GetBase()->Setoverlap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Invalidateoverlap()
{
	GetBase()->GetBase()->Invalidateoverlap();
}
bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Getgap() const
{
	return GetBase()->GetBase()->Getgap();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Existgap() const
{
	return GetBase()->GetBase()->Existgap();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setgap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setgap().");
	}
	GetBase()->GetBase()->Setgap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Invalidategap()
{
	GetBase()->GetBase()->Invalidategap();
}
XMLCh * Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Getid() const
{
	return GetBase()->GetBase()->GetBase()->Getid();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Existid() const
{
	return GetBase()->GetBase()->GetBase()->Existid();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Setid().");
	}
	GetBase()->GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Invalidateid()
{
	GetBase()->GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GettimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::ExisttimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SettimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::InvalidatetimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GettimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SettimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetHeader() const
{
	return GetBase()->GetBase()->GetBase()->GetHeader();
}

void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::SetHeader().");
	}
	GetBase()->GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 8 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("IntraCompositionShot")) == 0)
	{
		// IntraCompositionShot is contained in itemtype IntraCompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection IntraCompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetIntraCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShot()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateIntraCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShot(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetIntraCompositionShot());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShot(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetIntraCompositionShot());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:IntraCompositionShotType")))) != empty)
			{
				// Is type allowed
				Mp7JrsIntraCompositionShotPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetIntraCompositionShot(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShot()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("IntraCompositionShotRef")) == 0)
	{
		// IntraCompositionShotRef is contained in itemtype IntraCompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection IntraCompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetIntraCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShotRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateIntraCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShotRef(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetIntraCompositionShotRef());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShotRef(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetIntraCompositionShotRef());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetIntraCompositionShotRef(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShotRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("InternalTransition")) == 0)
	{
		// InternalTransition is contained in itemtype IntraCompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection IntraCompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetIntraCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransition()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateIntraCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransition(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetInternalTransition());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransition(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetInternalTransition());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InternalTransitionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsInternalTransitionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetInternalTransition(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransition()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("InternalTransitionRef")) == 0)
	{
		// InternalTransitionRef is contained in itemtype IntraCompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection IntraCompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetIntraCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransitionRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateIntraCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransitionRef(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetInternalTransitionRef());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransitionRef(
						((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetInternalTransitionRef());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetInternalTransitionRef(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransitionRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for IntraCompositionShotEditingTemporalDecompositionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "IntraCompositionShotEditingTemporalDecompositionType");
	}
	return result;
}

XMLCh * Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("IntraCompositionShotEditingTemporalDecompositionType"));
	// Element serialization:
	if (m_IntraCompositionShotEditingTemporalDecompositionType_LocalType != Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_IntraCompositionShotEditingTemporalDecompositionType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsTemporalSegmentDecompositionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		// Sequence Collection
		if((parent != NULL) && (
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:IntraCompositionShot")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("IntraCompositionShot"), X("urn:mpeg:mpeg7:schema:2004")))
				||
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:IntraCompositionShotRef")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("IntraCompositionShotRef"), X("urn:mpeg:mpeg7:schema:2004")))
				||
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:InternalTransition")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("InternalTransition"), X("urn:mpeg:mpeg7:schema:2004")))
				||
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:InternalTransitionRef")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("InternalTransitionRef"), X("urn:mpeg:mpeg7:schema:2004")))
				))
		{
			// Deserialize factory type
			Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr tmp = CreateIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  // Non-Choice Collection
	// local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
	Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionPtr tmp = CreateIntraCompositionShotEditingTemporalDecompositionType_CollectionType;
	this->SetIntraCompositionShotEditingTemporalDecompositionType_LocalType(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsIntraCompositionShotEditingTemporalDecompositionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetIntraCompositionShotEditingTemporalDecompositionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetIntraCompositionShotEditingTemporalDecompositionType_LocalType());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_ExtMethodImpl.h


