 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtImplInclude.h



#include "Mp7JrsKeyType_KeyNote_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsKeyType_KeyNote_LocalType::IMp7JrsKeyType_KeyNote_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtPropInit.h

}

IMp7JrsKeyType_KeyNote_LocalType::~IMp7JrsKeyType_KeyNote_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtPropCleanup.h

}

Mp7JrsKeyType_KeyNote_LocalType::Mp7JrsKeyType_KeyNote_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsKeyType_KeyNote_LocalType::~Mp7JrsKeyType_KeyNote_LocalType()
{
	Cleanup();
}

void Mp7JrsKeyType_KeyNote_LocalType::Init()
{
	// Init base
	m_Base = Mp7JrsdegreeNoteType::UninitializedEnumeration;

	// Init attributes
	m_display = NULL; // String
	m_display_Exist = false;



// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtMyPropInit.h

}

void Mp7JrsKeyType_KeyNote_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_display); // String
}

void Mp7JrsKeyType_KeyNote_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use KeyType_KeyNote_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IKeyType_KeyNote_LocalType
	const Mp7JrsPtr< Mp7JrsKeyType_KeyNote_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	m_Base = tmp->GetContent();
	{
	XMLString::release(&m_display); // String
	if (tmp->Existdisplay())
	{
		this->Setdisplay(XMLString::replicate(tmp->Getdisplay()));
	}
	else
	{
		Invalidatedisplay();
	}
	}
}

Mp7JrsNodePtr Mp7JrsKeyType_KeyNote_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsKeyType_KeyNote_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


void Mp7JrsKeyType_KeyNote_LocalType::SetContent(Mp7JrsdegreeNoteType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsKeyType_KeyNote_LocalType::SetContent().");
	}
	if (m_Base != item)
	{
		m_Base = item;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsdegreeNoteType::Enumeration Mp7JrsKeyType_KeyNote_LocalType::GetContent() const
{
	return m_Base;
}
XMLCh * Mp7JrsKeyType_KeyNote_LocalType::Getdisplay() const
{
	return m_display;
}

bool Mp7JrsKeyType_KeyNote_LocalType::Existdisplay() const
{
	return m_display_Exist;
}
void Mp7JrsKeyType_KeyNote_LocalType::Setdisplay(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsKeyType_KeyNote_LocalType::Setdisplay().");
	}
	m_display = item;
	m_display_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsKeyType_KeyNote_LocalType::Invalidatedisplay()
{
	m_display_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsKeyType_KeyNote_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  1, 1 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 1
//- N; display,  T:http://www.w3.org/2001/XMLSchema:string, C:String 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("display")) == 0)
	{
		// display is simple attribute string
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "XMLCh *");
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for KeyType_KeyNote_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "KeyType_KeyNote_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsKeyType_KeyNote_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsKeyType_KeyNote_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsKeyType_KeyNote_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsKeyType_KeyNote_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsKeyType_KeyNote_LocalType::ContentToString() const
{
	// Mp7JrsKeyType_KeyNote_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsKeyType_KeyNote_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	{
		XMLCh * tmp = Mp7JrsdegreeNoteType::ToText(m_Base);
		element->appendChild(doc->createTextNode(tmp));
		XMLString::release(&tmp);
	}

	assert(element);
// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("KeyType_KeyNote_LocalType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_display_Exist)
	{
	// String
	if(m_display != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("display"), m_display);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsKeyType_KeyNote_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("display")))
	{
		// Deserialize string type
		this->Setdisplay(Mp7JrsConvert::TextToString(parent->getAttribute(X("display"))));
		* current = parent;
	}

  Mp7JrsdegreeNoteType::Enumeration tmp = Mp7JrsdegreeNoteType::Parse(Mp7JrsUtil::GetElementText(parent));
  if(tmp != Mp7JrsdegreeNoteType::UninitializedEnumeration)
  {
		m_Base = tmp;
		found = true;
  }
// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsKeyType_KeyNote_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsKeyType_KeyNote_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsKeyType_KeyNote_LocalType_ExtMethodImpl.h


