 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_ExtImplInclude.h



#include "Mp7JrsMediaLocatorType.h"
#include "Mp7JrsLogicalUnitLocatorType_CollectionType.h"
#include "Mp7JrsInlineMediaType.h"
#include "Mp7JrsLogicalUnitLocatorType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsLogicalUnitLocatorType_LocalType.h" // Choice collection LogicalUnit
#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0.h" // Choice collection element LogicalUnit
#include "Mp7JrsLogicalUnitLocatorType_ReferenceUnit_LocalType0.h" // Choice collection element ReferenceUnit

#include <assert.h>
IMp7JrsLogicalUnitLocatorType::IMp7JrsLogicalUnitLocatorType()
{

// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_ExtPropInit.h

}

IMp7JrsLogicalUnitLocatorType::~IMp7JrsLogicalUnitLocatorType()
{
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_ExtPropCleanup.h

}

Mp7JrsLogicalUnitLocatorType::Mp7JrsLogicalUnitLocatorType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsLogicalUnitLocatorType::~Mp7JrsLogicalUnitLocatorType()
{
	Cleanup();
}

void Mp7JrsLogicalUnitLocatorType::Init()
{
	// Init base
	m_Base = CreateMediaLocatorType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_LogicalUnitLocatorType_LocalType = Mp7JrsLogicalUnitLocatorType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_ExtMyPropInit.h

}

void Mp7JrsLogicalUnitLocatorType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_LogicalUnitLocatorType_LocalType);
}

void Mp7JrsLogicalUnitLocatorType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use LogicalUnitLocatorTypePtr, since we
	// might need GetBase(), which isn't defined in ILogicalUnitLocatorType
	const Mp7JrsPtr< Mp7JrsLogicalUnitLocatorType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsMediaLocatorPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsLogicalUnitLocatorType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_LogicalUnitLocatorType_LocalType);
		this->SetLogicalUnitLocatorType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetLogicalUnitLocatorType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsMediaLocatorType > Mp7JrsLogicalUnitLocatorType::GetBase() const
{
	return m_Base;
}

Mp7JrsLogicalUnitLocatorType_CollectionPtr Mp7JrsLogicalUnitLocatorType::GetLogicalUnitLocatorType_LocalType() const
{
		return m_LogicalUnitLocatorType_LocalType;
}

void Mp7JrsLogicalUnitLocatorType::SetLogicalUnitLocatorType_LocalType(const Mp7JrsLogicalUnitLocatorType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType::SetLogicalUnitLocatorType_LocalType().");
	}
	if (m_LogicalUnitLocatorType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_LogicalUnitLocatorType_LocalType);
		m_LogicalUnitLocatorType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_LogicalUnitLocatorType_LocalType) m_LogicalUnitLocatorType_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsLogicalUnitLocatorType::GetMediaUri() const
{
	return GetBase()->GetMediaUri();
}

Mp7JrsInlineMediaPtr Mp7JrsLogicalUnitLocatorType::GetInlineMedia() const
{
	return GetBase()->GetInlineMedia();
}

unsigned Mp7JrsLogicalUnitLocatorType::GetStreamID() const
{
	return GetBase()->GetStreamID();
}

// Element is optional
bool Mp7JrsLogicalUnitLocatorType::IsValidStreamID() const
{
	return GetBase()->IsValidStreamID();
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsLogicalUnitLocatorType::SetMediaUri(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType::SetMediaUri().");
	}
	GetBase()->SetMediaUri(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsLogicalUnitLocatorType::SetInlineMedia(const Mp7JrsInlineMediaPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType::SetInlineMedia().");
	}
	GetBase()->SetInlineMedia(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLogicalUnitLocatorType::SetStreamID(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType::SetStreamID().");
	}
	GetBase()->SetStreamID(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsLogicalUnitLocatorType::InvalidateStreamID()
{
	GetBase()->InvalidateStreamID();
}

Mp7JrsNodeEnum Mp7JrsLogicalUnitLocatorType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("LogicalUnit")) == 0)
	{
		// LogicalUnit is contained in itemtype LogicalUnitLocatorType_LocalType
		// in choice collection LogicalUnitLocatorType_CollectionType
		
		context->Found = true;
		Mp7JrsLogicalUnitLocatorType_CollectionPtr coll = GetLogicalUnitLocatorType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateLogicalUnitLocatorType_CollectionType;
				SetLogicalUnitLocatorType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsLogicalUnitLocatorType_LocalPtr)coll->elementAt(i))->GetLogicalUnit()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsLogicalUnitLocatorType_LocalPtr item = CreateLogicalUnitLocatorType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:LogicalUnitLocatorType_LogicalUnit_LocalType0")))) != empty)
			{
				// Is type allowed
				Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsLogicalUnitLocatorType_LocalPtr)coll->elementAt(i))->SetLogicalUnit(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsLogicalUnitLocatorType_LocalPtr)coll->elementAt(i))->GetLogicalUnit()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ReferenceUnit")) == 0)
	{
		// ReferenceUnit is contained in itemtype LogicalUnitLocatorType_LocalType
		// in choice collection LogicalUnitLocatorType_CollectionType
		
		context->Found = true;
		Mp7JrsLogicalUnitLocatorType_CollectionPtr coll = GetLogicalUnitLocatorType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateLogicalUnitLocatorType_CollectionType;
				SetLogicalUnitLocatorType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsLogicalUnitLocatorType_LocalPtr)coll->elementAt(i))->GetReferenceUnit()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsLogicalUnitLocatorType_LocalPtr item = CreateLogicalUnitLocatorType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:LogicalUnitLocatorType_ReferenceUnit_LocalType0")))) != empty)
			{
				// Is type allowed
				Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsLogicalUnitLocatorType_LocalPtr)coll->elementAt(i))->SetReferenceUnit(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsLogicalUnitLocatorType_LocalPtr)coll->elementAt(i))->GetReferenceUnit()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for LogicalUnitLocatorType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "LogicalUnitLocatorType");
	}
	return result;
}

XMLCh * Mp7JrsLogicalUnitLocatorType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsLogicalUnitLocatorType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsLogicalUnitLocatorType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("LogicalUnitLocatorType"));
	// Element serialization:
	if (m_LogicalUnitLocatorType_LocalType != Mp7JrsLogicalUnitLocatorType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_LogicalUnitLocatorType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsLogicalUnitLocatorType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsMediaLocatorType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		// Deserialise Choice Collection
		if((parent != NULL) && (
			// urn:mpeg:mpeg7:schema:2004:LogicalUnit
			Mp7JrsUtil::HasNodeName(parent, X("LogicalUnit"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:LogicalUnit")) == 0)
				||
			// urn:mpeg:mpeg7:schema:2004:ReferenceUnit
			Mp7JrsUtil::HasNodeName(parent, X("ReferenceUnit"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ReferenceUnit")) == 0)
				))
		{
			// Deserialize factory type
			Mp7JrsLogicalUnitLocatorType_CollectionPtr tmp = CreateLogicalUnitLocatorType_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetLogicalUnitLocatorType_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  // Choice Collection
  if(
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("LogicalUnit"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("LogicalUnit")) == 0)
	||
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("ReferenceUnit"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("ReferenceUnit")) == 0)
	)
  {
	Mp7JrsLogicalUnitLocatorType_CollectionPtr tmp = CreateLogicalUnitLocatorType_CollectionType;
	this->SetLogicalUnitLocatorType_LocalType(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsLogicalUnitLocatorType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetLogicalUnitLocatorType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetLogicalUnitLocatorType_LocalType());
	if (GetInlineMedia() != Mp7JrsNodePtr())
		result.Insert(GetInlineMedia());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// begin extension included
// file Mp7JrsLogicalUnitLocatorType_ExtMethodImpl.h
Mp7JrsmediaTimePointPtr Mp7JrsLogicalUnitLocatorType::GetMediaTimeBase(void) const
{
	return this->GetBase()->GetMediaTimeBase();
}
void Mp7JrsLogicalUnitLocatorType::SetMediaTimeBase(const Mp7JrsmediaTimePointPtr &timePoint, Mp7JrsClientID client)
{
	return this->GetBase()->SetMediaTimeBase(timePoint, client);
}
// end extension included


