 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtImplInclude.h



#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0.h"
#include "Mp7JrsLogicalUnitLocatorType_ReferenceUnit_LocalType0.h"
#include "Mp7JrsLogicalUnitLocatorType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsLogicalUnitLocatorType_LocalType::IMp7JrsLogicalUnitLocatorType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtPropInit.h

}

IMp7JrsLogicalUnitLocatorType_LocalType::~IMp7JrsLogicalUnitLocatorType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtPropCleanup.h

}

Mp7JrsLogicalUnitLocatorType_LocalType::Mp7JrsLogicalUnitLocatorType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsLogicalUnitLocatorType_LocalType::~Mp7JrsLogicalUnitLocatorType_LocalType()
{
	Cleanup();
}

void Mp7JrsLogicalUnitLocatorType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_LogicalUnit = Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr(); // Class
	m_ReferenceUnit = Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr(); // Class


// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtMyPropInit.h

}

void Mp7JrsLogicalUnitLocatorType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_LogicalUnit);
	// Mp7JrsFactory::DeleteObject(m_ReferenceUnit);
}

void Mp7JrsLogicalUnitLocatorType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use LogicalUnitLocatorType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ILogicalUnitLocatorType_LocalType
	const Mp7JrsPtr< Mp7JrsLogicalUnitLocatorType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_LogicalUnit);
		this->SetLogicalUnit(Mp7JrsFactory::CloneObject(tmp->GetLogicalUnit()));
		// Mp7JrsFactory::DeleteObject(m_ReferenceUnit);
		this->SetReferenceUnit(Mp7JrsFactory::CloneObject(tmp->GetReferenceUnit()));
}

Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr Mp7JrsLogicalUnitLocatorType_LocalType::GetLogicalUnit() const
{
		return m_LogicalUnit;
}

Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr Mp7JrsLogicalUnitLocatorType_LocalType::GetReferenceUnit() const
{
		return m_ReferenceUnit;
}

// implementing setter for choice 
/* element */
void Mp7JrsLogicalUnitLocatorType_LocalType::SetLogicalUnit(const Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType_LocalType::SetLogicalUnit().");
	}
	if (m_LogicalUnit != item)
	{
		// Mp7JrsFactory::DeleteObject(m_LogicalUnit);
		m_LogicalUnit = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_LogicalUnit) m_LogicalUnit->SetParent(m_myself.getPointer());
		if (m_LogicalUnit && m_LogicalUnit->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:LogicalUnitLocatorType_LogicalUnit_LocalType0"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_LogicalUnit->UseTypeAttribute = true;
		}
		if(m_LogicalUnit != Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_LogicalUnit->SetContentName(XMLString::transcode("LogicalUnit"));
		}
	// Mp7JrsFactory::DeleteObject(m_ReferenceUnit);
	m_ReferenceUnit = Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsLogicalUnitLocatorType_LocalType::SetReferenceUnit(const Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType_LocalType::SetReferenceUnit().");
	}
	if (m_ReferenceUnit != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ReferenceUnit);
		m_ReferenceUnit = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ReferenceUnit) m_ReferenceUnit->SetParent(m_myself.getPointer());
		if (m_ReferenceUnit && m_ReferenceUnit->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:LogicalUnitLocatorType_ReferenceUnit_LocalType0"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ReferenceUnit->UseTypeAttribute = true;
		}
		if(m_ReferenceUnit != Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ReferenceUnit->SetContentName(XMLString::transcode("ReferenceUnit"));
		}
	// Mp7JrsFactory::DeleteObject(m_LogicalUnit);
	m_LogicalUnit = Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: LogicalUnitLocatorType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsLogicalUnitLocatorType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsLogicalUnitLocatorType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsLogicalUnitLocatorType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsLogicalUnitLocatorType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_LogicalUnit != Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_LogicalUnit->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("LogicalUnit"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_LogicalUnit->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ReferenceUnit != Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ReferenceUnit->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ReferenceUnit"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ReferenceUnit->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsLogicalUnitLocatorType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
	{
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("LogicalUnit"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("LogicalUnit")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateLogicalUnitLocatorType_LogicalUnit_LocalType0;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetLogicalUnit(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ReferenceUnit"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ReferenceUnit")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateLogicalUnitLocatorType_ReferenceUnit_LocalType0;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetReferenceUnit(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
	} while(false);
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("LogicalUnit")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateLogicalUnitLocatorType_LogicalUnit_LocalType0;
	}
	this->SetLogicalUnit(child);
  }
  if (XMLString::compareString(elementname, X("ReferenceUnit")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateLogicalUnitLocatorType_ReferenceUnit_LocalType0;
	}
	this->SetReferenceUnit(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsLogicalUnitLocatorType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetLogicalUnit() != Mp7JrsNodePtr())
		result.Insert(GetLogicalUnit());
	if (GetReferenceUnit() != Mp7JrsNodePtr())
		result.Insert(GetReferenceUnit());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtMethodImpl.h


