 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0_ExtImplInclude.h



#include "Mp7JrstermReferenceType.h"
#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionType.h"
#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType.h" // Sequence collection SubUnit
#include "Mp7JrsMediaLocatorType.h" // Sequence collection element SubUnit

#include <assert.h>
IMp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::IMp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0_ExtPropInit.h

}

IMp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::~IMp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0_ExtPropCleanup.h

}

Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::~Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0()
{
	Cleanup();
}

void Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Init()
{

	// Init attributes
	m_unit = Mp7JrstermReferencePtr(); // Create emtpy class ptr
	m_value = NULL; // String

	// Init elements (element, union sequence choice all any)
	
	m_LogicalUnitLocatorType_LogicalUnit_LocalType = Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0_ExtMyPropInit.h

}

void Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_unit);
	XMLString::release(&m_value); // String
	// Mp7JrsFactory::DeleteObject(m_LogicalUnitLocatorType_LogicalUnit_LocalType);
}

void Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use LogicalUnitLocatorType_LogicalUnit_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in ILogicalUnitLocatorType_LogicalUnit_LocalType0
	const Mp7JrsPtr< Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_unit);
		this->Setunit(Mp7JrsFactory::CloneObject(tmp->Getunit()));
	}
	{
	XMLString::release(&m_value); // String
		this->Setvalue(XMLString::replicate(tmp->Getvalue()));
	}
		// Mp7JrsFactory::DeleteObject(m_LogicalUnitLocatorType_LogicalUnit_LocalType);
		this->SetLogicalUnitLocatorType_LogicalUnit_LocalType(Mp7JrsFactory::CloneObject(tmp->GetLogicalUnitLocatorType_LogicalUnit_LocalType()));
}

Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrstermReferencePtr Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Getunit() const
{
	return m_unit;
}

void Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Setunit(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Setunit().");
	}
	m_unit = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_unit) m_unit->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Getvalue() const
{
	return m_value;
}

void Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Setvalue(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Setvalue().");
	}
	m_value = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionPtr Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::GetLogicalUnitLocatorType_LogicalUnit_LocalType() const
{
		return m_LogicalUnitLocatorType_LogicalUnit_LocalType;
}

void Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::SetLogicalUnitLocatorType_LogicalUnit_LocalType(const Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::SetLogicalUnitLocatorType_LogicalUnit_LocalType().");
	}
	if (m_LogicalUnitLocatorType_LogicalUnit_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_LogicalUnitLocatorType_LogicalUnit_LocalType);
		m_LogicalUnitLocatorType_LogicalUnit_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_LogicalUnitLocatorType_LogicalUnit_LocalType) m_LogicalUnitLocatorType_LogicalUnit_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  2, 2 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 2
//- N; unit,  T:urn:mpeg:mpeg7:schema:2004:termReferenceType, C:Class 
//- N; value,  T:http://www.w3.org/2001/XMLSchema:string, C:String 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("unit")) == 0)
	{
		// unit is simple attribute termReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = Getunit()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrstermReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					Setunit(p, client);
					if((p = Getunit()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("value")) == 0)
	{
		// value is simple attribute string
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "XMLCh *");
	}
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("SubUnit")) == 0)
	{
		// SubUnit is contained in itemtype LogicalUnitLocatorType_LogicalUnit_LocalType
		// in sequence collection LogicalUnitLocatorType_LogicalUnit_CollectionType

		context->Found = true;
		Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionPtr coll = GetLogicalUnitLocatorType_LogicalUnit_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateLogicalUnitLocatorType_LogicalUnit_CollectionType;
				SetLogicalUnitLocatorType_LogicalUnit_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr)coll->elementAt(i))->GetSubUnit()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr item = CreateLogicalUnitLocatorType_LogicalUnit_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr)coll->elementAt(j))->SetSubUnit(
						((Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr)coll->elementAt(j+1))->GetSubUnit());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr)coll->elementAt(j))->SetSubUnit(
						((Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr)coll->elementAt(j-1))->GetSubUnit());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaLocatorType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaLocatorPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr)coll->elementAt(i))->SetSubUnit(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalPtr)coll->elementAt(i))->GetSubUnit()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for LogicalUnitLocatorType_LogicalUnit_LocalType0
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "LogicalUnitLocatorType_LogicalUnit_LocalType0");
	}
	return result;
}

XMLCh * Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("LogicalUnitLocatorType_LogicalUnit_LocalType0"));
	// Attribute Serialization:
	// Class
	if (m_unit != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_unit->ToText();
		element->setAttributeNS(X(""), X("unit"), tmp);
		XMLString::release(&tmp);
	}
	// Attribute Serialization:
	// String
	if(m_value != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("value"), m_value);
	}
	// Element serialization:
	if (m_LogicalUnitLocatorType_LogicalUnit_LocalType != Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_LogicalUnitLocatorType_LogicalUnit_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("unit")))
	{
		// Deserialize class type
		Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
		tmp->Parse(parent->getAttribute(X("unit")));
		this->Setunit(tmp);
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("value")))
	{
		// Deserialize string type
		this->Setvalue(Mp7JrsConvert::TextToString(parent->getAttribute(X("value"))));
		* current = parent;
	}

	parent = Mp7JrsUtil::GetNextChild(parent);
		// Sequence Collection
		if((parent != NULL) && (
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SubUnit")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("SubUnit"), X("urn:mpeg:mpeg7:schema:2004")))
				))
		{
			// Deserialize factory type
			Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionPtr tmp = CreateLogicalUnitLocatorType_LogicalUnit_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetLogicalUnitLocatorType_LogicalUnit_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
	// local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
	Mp7JrsLogicalUnitLocatorType_LogicalUnit_CollectionPtr tmp = CreateLogicalUnitLocatorType_LogicalUnit_CollectionType;
	this->SetLogicalUnitLocatorType_LogicalUnit_LocalType(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetLogicalUnitLocatorType_LogicalUnit_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetLogicalUnitLocatorType_LogicalUnit_LocalType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0_ExtMethodImpl.h


