 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType_ExtImplInclude.h



#include "Mp7JrsnonNegativeReal.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType::IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType_ExtPropInit.h

}

IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType::~IMp7JrsMediaFormatType_AudioCoding_Sample_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType_ExtPropCleanup.h

}

Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::~Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType()
{
	Cleanup();
}

void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Init()
{

	// Init attributes
	m_rate = CreatenonNegativeReal; // Create a valid class
	m_rate->SetContent(0.0); // Use Value initialiser (xxx2)
	m_rate_Exist = false;
	m_bitsPer = 0; // Value
	m_bitsPer_Exist = false;



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType_ExtMyPropInit.h

}

void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_rate);
}

void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaFormatType_AudioCoding_Sample_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaFormatType_AudioCoding_Sample_LocalType
	const Mp7JrsPtr< Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_rate);
	if (tmp->Existrate())
	{
		this->Setrate(Mp7JrsFactory::CloneObject(tmp->Getrate()));
	}
	else
	{
		Invalidaterate();
	}
	}
	{
	if (tmp->ExistbitsPer())
	{
		this->SetbitsPer(tmp->GetbitsPer());
	}
	else
	{
		InvalidatebitsPer();
	}
	}
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsnonNegativeRealPtr Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Getrate() const
{
	return m_rate;
}

bool Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Existrate() const
{
	return m_rate_Exist;
}
void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Setrate(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Setrate().");
	}
	m_rate = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_rate) m_rate->SetParent(m_myself.getPointer());
	m_rate_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Invalidaterate()
{
	m_rate_Exist = false;
}
unsigned Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::GetbitsPer() const
{
	return m_bitsPer;
}

bool Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::ExistbitsPer() const
{
	return m_bitsPer_Exist;
}
void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::SetbitsPer(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::SetbitsPer().");
	}
	m_bitsPer = item;
	m_bitsPer_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::InvalidatebitsPer()
{
	m_bitsPer_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  2, 2 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaFormatType_AudioCoding_Sample_LocalType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_rate_Exist)
	{
	// Class
	if (m_rate != Mp7JrsnonNegativeRealPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_rate->ToText();
		element->setAttributeNS(X(""), X("rate"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Attribute Serialization:
		

	// Optional attriute
	if(m_bitsPer_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_bitsPer);
		element->setAttributeNS(X(""), X("bitsPer"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("rate")))
	{
		// Deserialize class type
		Mp7JrsnonNegativeRealPtr tmp = CreatenonNegativeReal;
		tmp->Parse(parent->getAttribute(X("rate")));
		this->Setrate(tmp);
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("bitsPer")))
	{
		// deserialize value type
		this->SetbitsPer(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("bitsPer"))));
		* current = parent;
	}

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType_ExtMethodImpl.h


