 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtImplInclude.h



#include "Mp7JrsMediaFormatType_VisualCoding_Format_LocalType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType.h"
#include "Mp7JrsColorSamplingType.h"
#include "Mp7JrsMediaFormatType_VisualCoding_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsMediaFormatType_VisualCoding_LocalType::IMp7JrsMediaFormatType_VisualCoding_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtPropInit.h

}

IMp7JrsMediaFormatType_VisualCoding_LocalType::~IMp7JrsMediaFormatType_VisualCoding_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtPropCleanup.h

}

Mp7JrsMediaFormatType_VisualCoding_LocalType::Mp7JrsMediaFormatType_VisualCoding_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaFormatType_VisualCoding_LocalType::~Mp7JrsMediaFormatType_VisualCoding_LocalType()
{
	Cleanup();
}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Format = Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr(); // Class
	m_Format_Exist = false;
	m_Pixel = Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr(); // Class
	m_Pixel_Exist = false;
	m_Frame = Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr(); // Class
	m_Frame_Exist = false;
	m_ColorSampling = Mp7JrsColorSamplingPtr(); // Class
	m_ColorSampling_Exist = false;


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtMyPropInit.h

}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Format);
	// Mp7JrsFactory::DeleteObject(m_Pixel);
	// Mp7JrsFactory::DeleteObject(m_Frame);
	// Mp7JrsFactory::DeleteObject(m_ColorSampling);
}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaFormatType_VisualCoding_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaFormatType_VisualCoding_LocalType
	const Mp7JrsPtr< Mp7JrsMediaFormatType_VisualCoding_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	if (tmp->IsValidFormat())
	{
		// Mp7JrsFactory::DeleteObject(m_Format);
		this->SetFormat(Mp7JrsFactory::CloneObject(tmp->GetFormat()));
	}
	else
	{
		InvalidateFormat();
	}
	if (tmp->IsValidPixel())
	{
		// Mp7JrsFactory::DeleteObject(m_Pixel);
		this->SetPixel(Mp7JrsFactory::CloneObject(tmp->GetPixel()));
	}
	else
	{
		InvalidatePixel();
	}
	if (tmp->IsValidFrame())
	{
		// Mp7JrsFactory::DeleteObject(m_Frame);
		this->SetFrame(Mp7JrsFactory::CloneObject(tmp->GetFrame()));
	}
	else
	{
		InvalidateFrame();
	}
	if (tmp->IsValidColorSampling())
	{
		// Mp7JrsFactory::DeleteObject(m_ColorSampling);
		this->SetColorSampling(Mp7JrsFactory::CloneObject(tmp->GetColorSampling()));
	}
	else
	{
		InvalidateColorSampling();
	}
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_VisualCoding_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMediaFormatType_VisualCoding_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr Mp7JrsMediaFormatType_VisualCoding_LocalType::GetFormat() const
{
		return m_Format;
}

// Element is optional
bool Mp7JrsMediaFormatType_VisualCoding_LocalType::IsValidFormat() const
{
	return m_Format_Exist;
}

Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr Mp7JrsMediaFormatType_VisualCoding_LocalType::GetPixel() const
{
		return m_Pixel;
}

// Element is optional
bool Mp7JrsMediaFormatType_VisualCoding_LocalType::IsValidPixel() const
{
	return m_Pixel_Exist;
}

Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr Mp7JrsMediaFormatType_VisualCoding_LocalType::GetFrame() const
{
		return m_Frame;
}

// Element is optional
bool Mp7JrsMediaFormatType_VisualCoding_LocalType::IsValidFrame() const
{
	return m_Frame_Exist;
}

Mp7JrsColorSamplingPtr Mp7JrsMediaFormatType_VisualCoding_LocalType::GetColorSampling() const
{
		return m_ColorSampling;
}

// Element is optional
bool Mp7JrsMediaFormatType_VisualCoding_LocalType::IsValidColorSampling() const
{
	return m_ColorSampling_Exist;
}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::SetFormat(const Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_LocalType::SetFormat().");
	}
	if (m_Format != item || m_Format_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Format);
		m_Format = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Format) m_Format->SetParent(m_myself.getPointer());
		if (m_Format && m_Format->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_VisualCoding_Format_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Format->UseTypeAttribute = true;
		}
		m_Format_Exist = true;
		if(m_Format != Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Format->SetContentName(XMLString::transcode("Format"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::InvalidateFormat()
{
	m_Format_Exist = false;
}
void Mp7JrsMediaFormatType_VisualCoding_LocalType::SetPixel(const Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_LocalType::SetPixel().");
	}
	if (m_Pixel != item || m_Pixel_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Pixel);
		m_Pixel = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Pixel) m_Pixel->SetParent(m_myself.getPointer());
		if (m_Pixel && m_Pixel->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_VisualCoding_Pixel_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Pixel->UseTypeAttribute = true;
		}
		m_Pixel_Exist = true;
		if(m_Pixel != Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Pixel->SetContentName(XMLString::transcode("Pixel"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::InvalidatePixel()
{
	m_Pixel_Exist = false;
}
void Mp7JrsMediaFormatType_VisualCoding_LocalType::SetFrame(const Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_LocalType::SetFrame().");
	}
	if (m_Frame != item || m_Frame_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Frame);
		m_Frame = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Frame) m_Frame->SetParent(m_myself.getPointer());
		if (m_Frame && m_Frame->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_VisualCoding_Frame_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Frame->UseTypeAttribute = true;
		}
		m_Frame_Exist = true;
		if(m_Frame != Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Frame->SetContentName(XMLString::transcode("Frame"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::InvalidateFrame()
{
	m_Frame_Exist = false;
}
void Mp7JrsMediaFormatType_VisualCoding_LocalType::SetColorSampling(const Mp7JrsColorSamplingPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_VisualCoding_LocalType::SetColorSampling().");
	}
	if (m_ColorSampling != item || m_ColorSampling_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_ColorSampling);
		m_ColorSampling = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ColorSampling) m_ColorSampling->SetParent(m_myself.getPointer());
		if (m_ColorSampling && m_ColorSampling->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ColorSamplingType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ColorSampling->UseTypeAttribute = true;
		}
		m_ColorSampling_Exist = true;
		if(m_ColorSampling != Mp7JrsColorSamplingPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ColorSampling->SetContentName(XMLString::transcode("ColorSampling"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_VisualCoding_LocalType::InvalidateColorSampling()
{
	m_ColorSampling_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_VisualCoding_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Format")) == 0)
	{
		// Format is simple element MediaFormatType_VisualCoding_Format_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetFormat()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_VisualCoding_Format_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetFormat(p, client);
					if((p = GetFormat()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Pixel")) == 0)
	{
		// Pixel is simple element MediaFormatType_VisualCoding_Pixel_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPixel()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_VisualCoding_Pixel_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPixel(p, client);
					if((p = GetPixel()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Frame")) == 0)
	{
		// Frame is simple element MediaFormatType_VisualCoding_Frame_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetFrame()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_VisualCoding_Frame_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetFrame(p, client);
					if((p = GetFrame()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ColorSampling")) == 0)
	{
		// ColorSampling is simple element ColorSamplingType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetColorSampling()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ColorSamplingType")))) != empty)
			{
				// Is type allowed
				Mp7JrsColorSamplingPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetColorSampling(p, client);
					if((p = GetColorSampling()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MediaFormatType_VisualCoding_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MediaFormatType_VisualCoding_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsMediaFormatType_VisualCoding_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaFormatType_VisualCoding_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMediaFormatType_VisualCoding_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaFormatType_VisualCoding_LocalType"));
	// Element serialization:
	// Class
	
	if (m_Format != Mp7JrsMediaFormatType_VisualCoding_Format_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Format->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Format"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Format->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Pixel != Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Pixel->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Pixel"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Pixel->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Frame != Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Frame->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Frame"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Frame->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ColorSampling != Mp7JrsColorSamplingPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ColorSampling->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ColorSampling"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ColorSampling->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMediaFormatType_VisualCoding_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Format"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Format")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMediaFormatType_VisualCoding_Format_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetFormat(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Pixel"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Pixel")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMediaFormatType_VisualCoding_Pixel_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetPixel(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Frame"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Frame")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMediaFormatType_VisualCoding_Frame_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetFrame(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ColorSampling"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ColorSampling")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateColorSamplingType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetColorSampling(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_VisualCoding_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Format")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMediaFormatType_VisualCoding_Format_LocalType;
	}
	this->SetFormat(child);
  }
  if (XMLString::compareString(elementname, X("Pixel")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMediaFormatType_VisualCoding_Pixel_LocalType;
	}
	this->SetPixel(child);
  }
  if (XMLString::compareString(elementname, X("Frame")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMediaFormatType_VisualCoding_Frame_LocalType;
	}
	this->SetFrame(child);
  }
  if (XMLString::compareString(elementname, X("ColorSampling")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateColorSamplingType;
	}
	this->SetColorSampling(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_VisualCoding_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetFormat() != Mp7JrsNodePtr())
		result.Insert(GetFormat());
	if (GetPixel() != Mp7JrsNodePtr())
		result.Insert(GetPixel());
	if (GetFrame() != Mp7JrsNodePtr())
		result.Insert(GetFrame());
	if (GetColorSampling() != Mp7JrsNodePtr())
		result.Insert(GetColorSampling());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_LocalType_ExtMethodImpl.h


