 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtImplInclude.h



#include "Mp7JrsDType.h"
#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsMediaTranscodingHintsType_MotionHint_LocalType.h"
#include "Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType.h"
#include "Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType.h"
#include "Mp7JrsMediaTranscodingHintsType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsMediaTranscodingHintsType::IMp7JrsMediaTranscodingHintsType()
{

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtPropInit.h

}

IMp7JrsMediaTranscodingHintsType::~IMp7JrsMediaTranscodingHintsType()
{
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtPropCleanup.h

}

Mp7JrsMediaTranscodingHintsType::Mp7JrsMediaTranscodingHintsType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaTranscodingHintsType::~Mp7JrsMediaTranscodingHintsType()
{
	Cleanup();
}

void Mp7JrsMediaTranscodingHintsType::Init()
{
	// Init base
	m_Base = CreateDType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_difficulty = CreatezeroToOneType; // Create a valid class
	m_difficulty->SetContent(0.0); // Use Value initialiser (xxx2)
	m_difficulty_Exist = false;
	m_importance = CreatezeroToOneType; // Create a valid class
	m_importance->SetContent(0.0); // Use Value initialiser (xxx2)
	m_importance_Exist = false;
	m_spatialResolutionHint = CreatezeroToOneType; // Create a valid class
	m_spatialResolutionHint->SetContent(0.0); // Use Value initialiser (xxx2)
	m_spatialResolutionHint_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_MotionHint = Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr(); // Class
	m_MotionHint_Exist = false;
	m_ShapeHint = Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr(); // Class
	m_ShapeHint_Exist = false;
	m_CodingHints = Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr(); // Class
	m_CodingHints_Exist = false;


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtMyPropInit.h

}

void Mp7JrsMediaTranscodingHintsType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_difficulty);
	// Mp7JrsFactory::DeleteObject(m_importance);
	// Mp7JrsFactory::DeleteObject(m_spatialResolutionHint);
	// Mp7JrsFactory::DeleteObject(m_MotionHint);
	// Mp7JrsFactory::DeleteObject(m_ShapeHint);
	// Mp7JrsFactory::DeleteObject(m_CodingHints);
}

void Mp7JrsMediaTranscodingHintsType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaTranscodingHintsTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaTranscodingHintsType
	const Mp7JrsPtr< Mp7JrsMediaTranscodingHintsType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsDPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMediaTranscodingHintsType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_difficulty);
	if (tmp->Existdifficulty())
	{
		this->Setdifficulty(Mp7JrsFactory::CloneObject(tmp->Getdifficulty()));
	}
	else
	{
		Invalidatedifficulty();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_importance);
	if (tmp->Existimportance())
	{
		this->Setimportance(Mp7JrsFactory::CloneObject(tmp->Getimportance()));
	}
	else
	{
		Invalidateimportance();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_spatialResolutionHint);
	if (tmp->ExistspatialResolutionHint())
	{
		this->SetspatialResolutionHint(Mp7JrsFactory::CloneObject(tmp->GetspatialResolutionHint()));
	}
	else
	{
		InvalidatespatialResolutionHint();
	}
	}
	if (tmp->IsValidMotionHint())
	{
		// Mp7JrsFactory::DeleteObject(m_MotionHint);
		this->SetMotionHint(Mp7JrsFactory::CloneObject(tmp->GetMotionHint()));
	}
	else
	{
		InvalidateMotionHint();
	}
	if (tmp->IsValidShapeHint())
	{
		// Mp7JrsFactory::DeleteObject(m_ShapeHint);
		this->SetShapeHint(Mp7JrsFactory::CloneObject(tmp->GetShapeHint()));
	}
	else
	{
		InvalidateShapeHint();
	}
	if (tmp->IsValidCodingHints())
	{
		// Mp7JrsFactory::DeleteObject(m_CodingHints);
		this->SetCodingHints(Mp7JrsFactory::CloneObject(tmp->GetCodingHints()));
	}
	else
	{
		InvalidateCodingHints();
	}
}

Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDType > Mp7JrsMediaTranscodingHintsType::GetBase() const
{
	return m_Base;
}

Mp7JrszeroToOnePtr Mp7JrsMediaTranscodingHintsType::Getdifficulty() const
{
	return m_difficulty;
}

bool Mp7JrsMediaTranscodingHintsType::Existdifficulty() const
{
	return m_difficulty_Exist;
}
void Mp7JrsMediaTranscodingHintsType::Setdifficulty(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType::Setdifficulty().");
	}
	m_difficulty = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_difficulty) m_difficulty->SetParent(m_myself.getPointer());
	m_difficulty_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType::Invalidatedifficulty()
{
	m_difficulty_Exist = false;
}
Mp7JrszeroToOnePtr Mp7JrsMediaTranscodingHintsType::Getimportance() const
{
	return m_importance;
}

bool Mp7JrsMediaTranscodingHintsType::Existimportance() const
{
	return m_importance_Exist;
}
void Mp7JrsMediaTranscodingHintsType::Setimportance(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType::Setimportance().");
	}
	m_importance = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_importance) m_importance->SetParent(m_myself.getPointer());
	m_importance_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType::Invalidateimportance()
{
	m_importance_Exist = false;
}
Mp7JrszeroToOnePtr Mp7JrsMediaTranscodingHintsType::GetspatialResolutionHint() const
{
	return m_spatialResolutionHint;
}

bool Mp7JrsMediaTranscodingHintsType::ExistspatialResolutionHint() const
{
	return m_spatialResolutionHint_Exist;
}
void Mp7JrsMediaTranscodingHintsType::SetspatialResolutionHint(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType::SetspatialResolutionHint().");
	}
	m_spatialResolutionHint = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_spatialResolutionHint) m_spatialResolutionHint->SetParent(m_myself.getPointer());
	m_spatialResolutionHint_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType::InvalidatespatialResolutionHint()
{
	m_spatialResolutionHint_Exist = false;
}
Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr Mp7JrsMediaTranscodingHintsType::GetMotionHint() const
{
		return m_MotionHint;
}

// Element is optional
bool Mp7JrsMediaTranscodingHintsType::IsValidMotionHint() const
{
	return m_MotionHint_Exist;
}

Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr Mp7JrsMediaTranscodingHintsType::GetShapeHint() const
{
		return m_ShapeHint;
}

// Element is optional
bool Mp7JrsMediaTranscodingHintsType::IsValidShapeHint() const
{
	return m_ShapeHint_Exist;
}

Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr Mp7JrsMediaTranscodingHintsType::GetCodingHints() const
{
		return m_CodingHints;
}

// Element is optional
bool Mp7JrsMediaTranscodingHintsType::IsValidCodingHints() const
{
	return m_CodingHints_Exist;
}

void Mp7JrsMediaTranscodingHintsType::SetMotionHint(const Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType::SetMotionHint().");
	}
	if (m_MotionHint != item || m_MotionHint_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_MotionHint);
		m_MotionHint = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MotionHint) m_MotionHint->SetParent(m_myself.getPointer());
		if (m_MotionHint && m_MotionHint->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTranscodingHintsType_MotionHint_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MotionHint->UseTypeAttribute = true;
		}
		m_MotionHint_Exist = true;
		if(m_MotionHint != Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MotionHint->SetContentName(XMLString::transcode("MotionHint"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType::InvalidateMotionHint()
{
	m_MotionHint_Exist = false;
}
void Mp7JrsMediaTranscodingHintsType::SetShapeHint(const Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType::SetShapeHint().");
	}
	if (m_ShapeHint != item || m_ShapeHint_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_ShapeHint);
		m_ShapeHint = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ShapeHint) m_ShapeHint->SetParent(m_myself.getPointer());
		if (m_ShapeHint && m_ShapeHint->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTranscodingHintsType_ShapeHint_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ShapeHint->UseTypeAttribute = true;
		}
		m_ShapeHint_Exist = true;
		if(m_ShapeHint != Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ShapeHint->SetContentName(XMLString::transcode("ShapeHint"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType::InvalidateShapeHint()
{
	m_ShapeHint_Exist = false;
}
void Mp7JrsMediaTranscodingHintsType::SetCodingHints(const Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaTranscodingHintsType::SetCodingHints().");
	}
	if (m_CodingHints != item || m_CodingHints_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_CodingHints);
		m_CodingHints = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CodingHints) m_CodingHints->SetParent(m_myself.getPointer());
		if (m_CodingHints && m_CodingHints->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTranscodingHintsType_CodingHints_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CodingHints->UseTypeAttribute = true;
		}
		m_CodingHints_Exist = true;
		if(m_CodingHints != Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CodingHints->SetContentName(XMLString::transcode("CodingHints"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaTranscodingHintsType::InvalidateCodingHints()
{
	m_CodingHints_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaTranscodingHintsType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  3, 3 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 3
//- N; difficulty,  T:urn:mpeg:mpeg7:schema:2004:zeroToOneType, C:Class 
//- N; importance,  T:urn:mpeg:mpeg7:schema:2004:zeroToOneType, C:Class 
//- N; spatialResolutionHint,  T:urn:mpeg:mpeg7:schema:2004:zeroToOneType, C:Class 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("difficulty")) == 0)
	{
		// difficulty is simple attribute zeroToOneType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = Getdifficulty()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:zeroToOneType")))) != empty)
			{
				// Is type allowed
				Mp7JrszeroToOnePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					Setdifficulty(p, client);
					if((p = Getdifficulty()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("importance")) == 0)
	{
		// importance is simple attribute zeroToOneType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = Getimportance()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:zeroToOneType")))) != empty)
			{
				// Is type allowed
				Mp7JrszeroToOnePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					Setimportance(p, client);
					if((p = Getimportance()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("spatialResolutionHint")) == 0)
	{
		// spatialResolutionHint is simple attribute zeroToOneType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = GetspatialResolutionHint()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:zeroToOneType")))) != empty)
			{
				// Is type allowed
				Mp7JrszeroToOnePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetspatialResolutionHint(p, client);
					if((p = GetspatialResolutionHint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MotionHint")) == 0)
	{
		// MotionHint is simple element MediaTranscodingHintsType_MotionHint_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMotionHint()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTranscodingHintsType_MotionHint_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMotionHint(p, client);
					if((p = GetMotionHint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ShapeHint")) == 0)
	{
		// ShapeHint is simple element MediaTranscodingHintsType_ShapeHint_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetShapeHint()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTranscodingHintsType_ShapeHint_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetShapeHint(p, client);
					if((p = GetShapeHint()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CodingHints")) == 0)
	{
		// CodingHints is simple element MediaTranscodingHintsType_CodingHints_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetCodingHints()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTranscodingHintsType_CodingHints_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetCodingHints(p, client);
					if((p = GetCodingHints()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MediaTranscodingHintsType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MediaTranscodingHintsType");
	}
	return result;
}

XMLCh * Mp7JrsMediaTranscodingHintsType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaTranscodingHintsType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMediaTranscodingHintsType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaTranscodingHintsType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_difficulty_Exist)
	{
	// Class
	if (m_difficulty != Mp7JrszeroToOnePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_difficulty->ToText();
		element->setAttributeNS(X(""), X("difficulty"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Attribute Serialization:
		

	// Optional attriute
	if(m_importance_Exist)
	{
	// Class
	if (m_importance != Mp7JrszeroToOnePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_importance->ToText();
		element->setAttributeNS(X(""), X("importance"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Attribute Serialization:
		

	// Optional attriute
	if(m_spatialResolutionHint_Exist)
	{
	// Class
	if (m_spatialResolutionHint != Mp7JrszeroToOnePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_spatialResolutionHint->ToText();
		element->setAttributeNS(X(""), X("spatialResolutionHint"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_MotionHint != Mp7JrsMediaTranscodingHintsType_MotionHint_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MotionHint->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MotionHint"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MotionHint->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ShapeHint != Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ShapeHint->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ShapeHint"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ShapeHint->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CodingHints != Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CodingHints->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CodingHints"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CodingHints->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMediaTranscodingHintsType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("difficulty")))
	{
		// Deserialize class type
		Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
		tmp->Parse(parent->getAttribute(X("difficulty")));
		this->Setdifficulty(tmp);
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("importance")))
	{
		// Deserialize class type
		Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
		tmp->Parse(parent->getAttribute(X("importance")));
		this->Setimportance(tmp);
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("spatialResolutionHint")))
	{
		// Deserialize class type
		Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
		tmp->Parse(parent->getAttribute(X("spatialResolutionHint")));
		this->SetspatialResolutionHint(tmp);
		* current = parent;
	}

	// Extensionbase is Mp7JrsDType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MotionHint"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MotionHint")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMediaTranscodingHintsType_MotionHint_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetMotionHint(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ShapeHint"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ShapeHint")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMediaTranscodingHintsType_ShapeHint_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetShapeHint(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CodingHints"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CodingHints")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMediaTranscodingHintsType_CodingHints_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetCodingHints(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaTranscodingHintsType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  if (XMLString::compareString(elementname, X("MotionHint")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMediaTranscodingHintsType_MotionHint_LocalType;
	}
	this->SetMotionHint(child);
  }
  if (XMLString::compareString(elementname, X("ShapeHint")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMediaTranscodingHintsType_ShapeHint_LocalType;
	}
	this->SetShapeHint(child);
  }
  if (XMLString::compareString(elementname, X("CodingHints")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMediaTranscodingHintsType_CodingHints_LocalType;
	}
	this->SetCodingHints(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaTranscodingHintsType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMotionHint() != Mp7JrsNodePtr())
		result.Insert(GetMotionHint());
	if (GetShapeHint() != Mp7JrsNodePtr())
		result.Insert(GetShapeHint());
	if (GetCodingHints() != Mp7JrsNodePtr())
		result.Insert(GetCodingHints());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ExtMethodImpl.h


