 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtImplInclude.h



#include "Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalType.h"
#include "Mp7JrsMelodySequenceType_StartingNote_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsMelodySequenceType_StartingNote_LocalType::IMp7JrsMelodySequenceType_StartingNote_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtPropInit.h

}

IMp7JrsMelodySequenceType_StartingNote_LocalType::~IMp7JrsMelodySequenceType_StartingNote_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtPropCleanup.h

}

Mp7JrsMelodySequenceType_StartingNote_LocalType::Mp7JrsMelodySequenceType_StartingNote_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMelodySequenceType_StartingNote_LocalType::~Mp7JrsMelodySequenceType_StartingNote_LocalType()
{
	Cleanup();
}

void Mp7JrsMelodySequenceType_StartingNote_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_StartingFrequency = (0.0); // Value

	m_StartingFrequency_Exist = false;
	m_StartingPitch = Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr(); // Class
	m_StartingPitch_Exist = false;


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtMyPropInit.h

}

void Mp7JrsMelodySequenceType_StartingNote_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_StartingPitch);
}

void Mp7JrsMelodySequenceType_StartingNote_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MelodySequenceType_StartingNote_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMelodySequenceType_StartingNote_LocalType
	const Mp7JrsPtr< Mp7JrsMelodySequenceType_StartingNote_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	if (tmp->IsValidStartingFrequency())
	{
		this->SetStartingFrequency(tmp->GetStartingFrequency());
	}
	else
	{
		InvalidateStartingFrequency();
	}
	if (tmp->IsValidStartingPitch())
	{
		// Mp7JrsFactory::DeleteObject(m_StartingPitch);
		this->SetStartingPitch(Mp7JrsFactory::CloneObject(tmp->GetStartingPitch()));
	}
	else
	{
		InvalidateStartingPitch();
	}
}

Mp7JrsNodePtr Mp7JrsMelodySequenceType_StartingNote_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMelodySequenceType_StartingNote_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


float Mp7JrsMelodySequenceType_StartingNote_LocalType::GetStartingFrequency() const
{
		return m_StartingFrequency;
}

// Element is optional
bool Mp7JrsMelodySequenceType_StartingNote_LocalType::IsValidStartingFrequency() const
{
	return m_StartingFrequency_Exist;
}

Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr Mp7JrsMelodySequenceType_StartingNote_LocalType::GetStartingPitch() const
{
		return m_StartingPitch;
}

// Element is optional
bool Mp7JrsMelodySequenceType_StartingNote_LocalType::IsValidStartingPitch() const
{
	return m_StartingPitch_Exist;
}

void Mp7JrsMelodySequenceType_StartingNote_LocalType::SetStartingFrequency(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMelodySequenceType_StartingNote_LocalType::SetStartingFrequency().");
	}
	if (m_StartingFrequency != item || m_StartingFrequency_Exist == false)
	{
		m_StartingFrequency = item;
		m_StartingFrequency_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMelodySequenceType_StartingNote_LocalType::InvalidateStartingFrequency()
{
	m_StartingFrequency_Exist = false;
}
void Mp7JrsMelodySequenceType_StartingNote_LocalType::SetStartingPitch(const Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMelodySequenceType_StartingNote_LocalType::SetStartingPitch().");
	}
	if (m_StartingPitch != item || m_StartingPitch_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_StartingPitch);
		m_StartingPitch = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StartingPitch) m_StartingPitch->SetParent(m_myself.getPointer());
		if (m_StartingPitch && m_StartingPitch->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MelodySequenceType_StartingNote_StartingPitch_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_StartingPitch->UseTypeAttribute = true;
		}
		m_StartingPitch_Exist = true;
		if(m_StartingPitch != Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_StartingPitch->SetContentName(XMLString::transcode("StartingPitch"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMelodySequenceType_StartingNote_LocalType::InvalidateStartingPitch()
{
	m_StartingPitch_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMelodySequenceType_StartingNote_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("StartingPitch")) == 0)
	{
		// StartingPitch is simple element MelodySequenceType_StartingNote_StartingPitch_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetStartingPitch()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MelodySequenceType_StartingNote_StartingPitch_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetStartingPitch(p, client);
					if((p = GetStartingPitch()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MelodySequenceType_StartingNote_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MelodySequenceType_StartingNote_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsMelodySequenceType_StartingNote_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMelodySequenceType_StartingNote_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMelodySequenceType_StartingNote_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MelodySequenceType_StartingNote_LocalType"));
	// Element serialization:
	if(m_StartingFrequency_Exist)
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_StartingFrequency);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("StartingFrequency"), true);
		XMLString::release(&tmp);
	}
	// Class
	
	if (m_StartingPitch != Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_StartingPitch->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("StartingPitch"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_StartingPitch->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMelodySequenceType_StartingNote_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	// Deserialize value element
	if(Mp7JrsUtil::HasNodeName(parent, X("StartingFrequency"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		XMLCh * tmp = Mp7JrsUtil::GetElementText(parent);
		this->SetStartingFrequency(Mp7JrsConvert::TextToFloat(tmp));
		XMLString::release(&tmp);
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("StartingPitch"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("StartingPitch")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMelodySequenceType_StartingNote_StartingPitch_LocalType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetStartingPitch(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMelodySequenceType_StartingNote_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("StartingPitch")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMelodySequenceType_StartingNote_StartingPitch_LocalType;
	}
	this->SetStartingPitch(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMelodySequenceType_StartingNote_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetStartingPitch() != Mp7JrsNodePtr())
		result.Insert(GetStartingPitch());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_LocalType_ExtMethodImpl.h


