 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtImplInclude.h



#include "Mp7JrsMixedCollectionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsMixedCollectionType_LocalType2.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsMixedCollectionType_LocalType2::IMp7JrsMixedCollectionType_LocalType2()
{

// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtPropInit.h

}

IMp7JrsMixedCollectionType_LocalType2::~IMp7JrsMixedCollectionType_LocalType2()
{
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtPropCleanup.h

}

Mp7JrsMixedCollectionType_LocalType2::Mp7JrsMixedCollectionType_LocalType2()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMixedCollectionType_LocalType2::~Mp7JrsMixedCollectionType_LocalType2()
{
	Cleanup();
}

void Mp7JrsMixedCollectionType_LocalType2::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_MixedCollection = Mp7JrsMixedCollectionPtr(); // Class
	m_MixedCollectionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtMyPropInit.h

}

void Mp7JrsMixedCollectionType_LocalType2::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_MixedCollection);
	// Mp7JrsFactory::DeleteObject(m_MixedCollectionRef);
}

void Mp7JrsMixedCollectionType_LocalType2::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MixedCollectionType_LocalType2Ptr, since we
	// might need GetBase(), which isn't defined in IMixedCollectionType_LocalType2
	const Mp7JrsPtr< Mp7JrsMixedCollectionType_LocalType2 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_MixedCollection);
		this->SetMixedCollection(Mp7JrsFactory::CloneObject(tmp->GetMixedCollection()));
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionRef);
		this->SetMixedCollectionRef(Mp7JrsFactory::CloneObject(tmp->GetMixedCollectionRef()));
}

Mp7JrsNodePtr Mp7JrsMixedCollectionType_LocalType2::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMixedCollectionType_LocalType2::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsMixedCollectionPtr Mp7JrsMixedCollectionType_LocalType2::GetMixedCollection() const
{
		return m_MixedCollection;
}

Mp7JrsReferencePtr Mp7JrsMixedCollectionType_LocalType2::GetMixedCollectionRef() const
{
		return m_MixedCollectionRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsMixedCollectionType_LocalType2::SetMixedCollection(const Mp7JrsMixedCollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType_LocalType2::SetMixedCollection().");
	}
	if (m_MixedCollection != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MixedCollection);
		m_MixedCollection = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MixedCollection) m_MixedCollection->SetParent(m_myself.getPointer());
		if (m_MixedCollection && m_MixedCollection->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MixedCollectionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MixedCollection->UseTypeAttribute = true;
		}
		if(m_MixedCollection != Mp7JrsMixedCollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MixedCollection->SetContentName(XMLString::transcode("MixedCollection"));
		}
	// Mp7JrsFactory::DeleteObject(m_MixedCollectionRef);
	m_MixedCollectionRef = Mp7JrsReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMixedCollectionType_LocalType2::SetMixedCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixedCollectionType_LocalType2::SetMixedCollectionRef().");
	}
	if (m_MixedCollectionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MixedCollectionRef);
		m_MixedCollectionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MixedCollectionRef) m_MixedCollectionRef->SetParent(m_myself.getPointer());
		if (m_MixedCollectionRef && m_MixedCollectionRef->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MixedCollectionRef->UseTypeAttribute = true;
		}
		if(m_MixedCollectionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MixedCollectionRef->SetContentName(XMLString::transcode("MixedCollectionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_MixedCollection);
	m_MixedCollection = Mp7JrsMixedCollectionPtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: MixedCollectionType_LocalType2: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsMixedCollectionType_LocalType2::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsMixedCollectionType_LocalType2::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMixedCollectionType_LocalType2::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMixedCollectionType_LocalType2::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_MixedCollection != Mp7JrsMixedCollectionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MixedCollection->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MixedCollection"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MixedCollection->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MixedCollectionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MixedCollectionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MixedCollectionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MixedCollectionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMixedCollectionType_LocalType2::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
	{
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MixedCollection"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MixedCollection")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMixedCollectionType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetMixedCollection(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MixedCollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MixedCollectionRef")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateReferenceType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetMixedCollectionRef(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
	} while(false);
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMixedCollectionType_LocalType2::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("MixedCollection")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMixedCollectionType;
	}
	this->SetMixedCollection(child);
  }
  if (XMLString::compareString(elementname, X("MixedCollectionRef")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateReferenceType;
	}
	this->SetMixedCollectionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMixedCollectionType_LocalType2::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMixedCollection() != Mp7JrsNodePtr())
		result.Insert(GetMixedCollection());
	if (GetMixedCollectionRef() != Mp7JrsNodePtr())
		result.Insert(GetMixedCollectionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType2_ExtMethodImpl.h


