
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsParametricMotionType_motionModel_LocalType_ExtImplInclude.h


#include "Mp7JrsParametricMotionType_motionModel_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsParametricMotionType_motionModel_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsParametricMotionType_motionModel_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsParametricMotionType_motionModel_LocalType::ToText(Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/translational:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("translational");
			break;
		case /*Enumeration::*/rotationOrScaling:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("rotationOrScaling");
			break;
		case /*Enumeration::*/affine:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("affine");
			break;
		case /*Enumeration::*/perspective:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("perspective");
			break;
		case /*Enumeration::*/quadratic:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("quadratic");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration Mp7JrsParametricMotionType_motionModel_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsParametricMotionType_motionModel_LocalType::Enumeration result = Mp7JrsParametricMotionType_motionModel_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "translational") == 0)
	{
		result = Mp7JrsParametricMotionType_motionModel_LocalType::/*Enumeration::*/translational;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "rotationOrScaling") == 0)
	{
		result = Mp7JrsParametricMotionType_motionModel_LocalType::/*Enumeration::*/rotationOrScaling;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "affine") == 0)
	{
		result = Mp7JrsParametricMotionType_motionModel_LocalType::/*Enumeration::*/affine;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "perspective") == 0)
	{
		result = Mp7JrsParametricMotionType_motionModel_LocalType::/*Enumeration::*/perspective;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "quadratic") == 0)
	{
		result = Mp7JrsParametricMotionType_motionModel_LocalType::/*Enumeration::*/quadratic;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
