 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtImplInclude.h



#include "Mp7JrsHeaderType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionType.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Token

#include <assert.h>
IMp7JrsPhoneticTranscriptionLexiconType::IMp7JrsPhoneticTranscriptionLexiconType()
{

// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtPropInit.h

}

IMp7JrsPhoneticTranscriptionLexiconType::~IMp7JrsPhoneticTranscriptionLexiconType()
{
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtPropCleanup.h

}

Mp7JrsPhoneticTranscriptionLexiconType::Mp7JrsPhoneticTranscriptionLexiconType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPhoneticTranscriptionLexiconType::~Mp7JrsPhoneticTranscriptionLexiconType()
{
	Cleanup();
}

void Mp7JrsPhoneticTranscriptionLexiconType::Init()
{
	// Init base
	m_Base = CreateHeaderType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_lang = NULL; // String
	m_lang_Exist = false;
	m_phoneticAlphabet = Mp7JrsphoneticAlphabetType::UninitializedEnumeration;
	m_phoneticAlphabet_Default = Mp7JrsphoneticAlphabetType::sampa; // Default enumeration
	m_phoneticAlphabet_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Token = Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtMyPropInit.h

}

void Mp7JrsPhoneticTranscriptionLexiconType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	XMLString::release(&m_lang); // String
	// Mp7JrsFactory::DeleteObject(m_Token);
}

void Mp7JrsPhoneticTranscriptionLexiconType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PhoneticTranscriptionLexiconTypePtr, since we
	// might need GetBase(), which isn't defined in IPhoneticTranscriptionLexiconType
	const Mp7JrsPtr< Mp7JrsPhoneticTranscriptionLexiconType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsHeaderPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsPhoneticTranscriptionLexiconType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	XMLString::release(&m_lang); // String
	if (tmp->Existlang())
	{
		this->Setlang(XMLString::replicate(tmp->Getlang()));
	}
	else
	{
		Invalidatelang();
	}
	}
	{
	if (tmp->ExistphoneticAlphabet())
	{
		this->SetphoneticAlphabet(tmp->GetphoneticAlphabet());
	}
	else
	{
		InvalidatephoneticAlphabet();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_Token);
		this->SetToken(Mp7JrsFactory::CloneObject(tmp->GetToken()));
}

Mp7JrsNodePtr Mp7JrsPhoneticTranscriptionLexiconType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsPhoneticTranscriptionLexiconType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsHeaderType > Mp7JrsPhoneticTranscriptionLexiconType::GetBase() const
{
	return m_Base;
}

XMLCh * Mp7JrsPhoneticTranscriptionLexiconType::Getlang() const
{
	return m_lang;
}

bool Mp7JrsPhoneticTranscriptionLexiconType::Existlang() const
{
	return m_lang_Exist;
}
void Mp7JrsPhoneticTranscriptionLexiconType::Setlang(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPhoneticTranscriptionLexiconType::Setlang().");
	}
	m_lang = item;
	m_lang_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPhoneticTranscriptionLexiconType::Invalidatelang()
{
	m_lang_Exist = false;
}
Mp7JrsphoneticAlphabetType::Enumeration Mp7JrsPhoneticTranscriptionLexiconType::GetphoneticAlphabet() const
{
	if (this->ExistphoneticAlphabet()) {
		return m_phoneticAlphabet;
	} else {
		return m_phoneticAlphabet_Default;
	}
}

bool Mp7JrsPhoneticTranscriptionLexiconType::ExistphoneticAlphabet() const
{
	return m_phoneticAlphabet_Exist;
}
void Mp7JrsPhoneticTranscriptionLexiconType::SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPhoneticTranscriptionLexiconType::SetphoneticAlphabet().");
	}
	m_phoneticAlphabet = item;
	m_phoneticAlphabet_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPhoneticTranscriptionLexiconType::InvalidatephoneticAlphabet()
{
	m_phoneticAlphabet_Exist = false;
}
Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr Mp7JrsPhoneticTranscriptionLexiconType::GetToken() const
{
		return m_Token;
}

void Mp7JrsPhoneticTranscriptionLexiconType::SetToken(const Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPhoneticTranscriptionLexiconType::SetToken().");
	}
	if (m_Token != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Token);
		m_Token = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Token) m_Token->SetParent(m_myself.getPointer());
		if(m_Token != Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Token->SetContentName(XMLString::transcode("Token"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsPhoneticTranscriptionLexiconType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsPhoneticTranscriptionLexiconType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsPhoneticTranscriptionLexiconType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPhoneticTranscriptionLexiconType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPhoneticTranscriptionLexiconType::Invalidateid()
{
	GetBase()->Invalidateid();
}

Mp7JrsNodeEnum Mp7JrsPhoneticTranscriptionLexiconType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  2, 3 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 2
//- N; id,  T:http://www.w3.org/2001/XMLSchema:ID, C:String 
//- N; lang,  T:http://www.w3.org/XML/1998/namespace:lang, C:String 
//- N; phoneticAlphabet,  T:urn:mpeg:mpeg7:schema:2004:phoneticAlphabetType, C:Enumeration 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("lang")) == 0)
	{
		// lang is simple attribute lang
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "XMLCh *");
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("phoneticAlphabet")) == 0)
	{
		// phoneticAlphabet is simple attribute phoneticAlphabetType
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "Mp7JrsphoneticAlphabetType::Enumeration");
	}
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Token")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Token is item of type PhoneticTranscriptionLexiconType_Token_LocalType
		// in element collection PhoneticTranscriptionLexiconType_Token_CollectionType
		
		context->Found = true;
		Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr coll = GetToken();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreatePhoneticTranscriptionLexiconType_Token_CollectionType;
				SetToken(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PhoneticTranscriptionLexiconType_Token_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for PhoneticTranscriptionLexiconType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "PhoneticTranscriptionLexiconType");
	}
	return result;
}

XMLCh * Mp7JrsPhoneticTranscriptionLexiconType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPhoneticTranscriptionLexiconType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsPhoneticTranscriptionLexiconType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PhoneticTranscriptionLexiconType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_lang_Exist)
	{
	// String
	if(m_lang != (XMLCh *)NULL)
	{
		element->setAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("xml:lang"), m_lang);
	}
		
	} // Optional attriute
	
	// Attribute Serialization:
		

	// Optional attriute
	if(m_phoneticAlphabet_Exist)
	{
	// Enumeration
	if(m_phoneticAlphabet != Mp7JrsphoneticAlphabetType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsphoneticAlphabetType::ToText(m_phoneticAlphabet);
		element->setAttributeNS(X(""), X("phoneticAlphabet"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_Token != Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Token->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsPhoneticTranscriptionLexiconType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// Qualified namespace handling required 
	if(parent->hasAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang")))
	{
		// Deserialize string type
		this->Setlang(Mp7JrsConvert::TextToString(parent->getAttributeNS(X("http://www.w3.org/XML/1998/namespace"), X("lang"))));
		* current = parent;
	}
	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("phoneticAlphabet")))
	{
		this->SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Parse(parent->getAttribute(X("phoneticAlphabet"))));
		* current = parent;
	}

	// Extensionbase is Mp7JrsHeaderType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		
		// Element Collection
		if((parent != NULL) && 
		Mp7JrsUtil::HasNodeName(parent, X("Token"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD		(XMLString::compareString(parent->getNodeName(), X("Token")) == 0))
		{
			// Deserialize factory type
			Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr tmp = CreatePhoneticTranscriptionLexiconType_Token_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetToken(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPhoneticTranscriptionLexiconType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Token")) == 0))
  {
	Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionPtr tmp = CreatePhoneticTranscriptionLexiconType_Token_CollectionType;
	this->SetToken(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPhoneticTranscriptionLexiconType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetToken() != Mp7JrsNodePtr())
		result.Insert(GetToken());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPhoneticTranscriptionLexiconType_ExtMethodImpl.h


