 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType_ExtImplInclude.h



#include "Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsPlaceType_StructuredInternalCoordinates_LocalType::IMp7JrsPlaceType_StructuredInternalCoordinates_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType_ExtPropInit.h

}

IMp7JrsPlaceType_StructuredInternalCoordinates_LocalType::~IMp7JrsPlaceType_StructuredInternalCoordinates_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType_ExtPropCleanup.h

}

Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::~Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType()
{
	Cleanup();
}

void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_RoomNumber = NULL; // Optional String
	m_RoomNumber_Exist = false;
	m_RoomName = NULL; // Optional String
	m_RoomName_Exist = false;
	m_BuildingName = NULL; // Optional String
	m_BuildingName_Exist = false;


// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType_ExtMyPropInit.h

}

void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType_ExtMyPropCleanup.h


	XMLString::release(&this->m_RoomNumber);
	this->m_RoomNumber = NULL;
	XMLString::release(&this->m_RoomName);
	this->m_RoomName = NULL;
	XMLString::release(&this->m_BuildingName);
	this->m_BuildingName = NULL;
}

void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PlaceType_StructuredInternalCoordinates_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPlaceType_StructuredInternalCoordinates_LocalType
	const Mp7JrsPtr< Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	if (tmp->IsValidRoomNumber())
	{
		this->SetRoomNumber(XMLString::replicate(tmp->GetRoomNumber()));
	}
	else
	{
		InvalidateRoomNumber();
	}
	if (tmp->IsValidRoomName())
	{
		this->SetRoomName(XMLString::replicate(tmp->GetRoomName()));
	}
	else
	{
		InvalidateRoomName();
	}
	if (tmp->IsValidBuildingName())
	{
		this->SetBuildingName(XMLString::replicate(tmp->GetBuildingName()));
	}
	else
	{
		InvalidateBuildingName();
	}
}

Mp7JrsNodePtr Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::GetRoomNumber() const
{
		return m_RoomNumber;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::IsValidRoomNumber() const
{
	return m_RoomNumber_Exist;
}

XMLCh * Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::GetRoomName() const
{
		return m_RoomName;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::IsValidRoomName() const
{
	return m_RoomName_Exist;
}

XMLCh * Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::GetBuildingName() const
{
		return m_BuildingName;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::IsValidBuildingName() const
{
	return m_BuildingName_Exist;
}

void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::SetRoomNumber(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::SetRoomNumber().");
	}
	if (m_RoomNumber != item || m_RoomNumber_Exist == false)
	{
		XMLString::release(&m_RoomNumber);
		m_RoomNumber = item;
		m_RoomNumber_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::InvalidateRoomNumber()
{
	m_RoomNumber_Exist = false;
}
void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::SetRoomName(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::SetRoomName().");
	}
	if (m_RoomName != item || m_RoomName_Exist == false)
	{
		XMLString::release(&m_RoomName);
		m_RoomName = item;
		m_RoomName_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::InvalidateRoomName()
{
	m_RoomName_Exist = false;
}
void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::SetBuildingName(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::SetBuildingName().");
	}
	if (m_BuildingName != item || m_BuildingName_Exist == false)
	{
		XMLString::release(&m_BuildingName);
		m_BuildingName = item;
		m_BuildingName_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::InvalidateBuildingName()
{
	m_BuildingName_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PlaceType_StructuredInternalCoordinates_LocalType"));
	// Element serialization:
	 // String
	if(m_RoomNumber != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_RoomNumber, X("urn:mpeg:mpeg7:schema:2004"), X("RoomNumber"), true);
	 // String
	if(m_RoomName != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_RoomName, X("urn:mpeg:mpeg7:schema:2004"), X("RoomName"), true);
	 // String
	if(m_BuildingName != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_BuildingName, X("urn:mpeg:mpeg7:schema:2004"), X("BuildingName"), true);

}

bool Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("RoomNumber"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetRoomNumber(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetRoomNumber(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("RoomName"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetRoomName(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetRoomName(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("BuildingName"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetBuildingName(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetBuildingName(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredInternalCoordinates_LocalType_ExtMethodImpl.h


