 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredPostalAddress_LocalType_ExtImplInclude.h



#include "Mp7JrscountryCode.h"
#include "Mp7JrsTextualType.h"
#include "Mp7JrsPlaceType_StructuredPostalAddress_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsPlaceType_StructuredPostalAddress_LocalType::IMp7JrsPlaceType_StructuredPostalAddress_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredPostalAddress_LocalType_ExtPropInit.h

}

IMp7JrsPlaceType_StructuredPostalAddress_LocalType::~IMp7JrsPlaceType_StructuredPostalAddress_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredPostalAddress_LocalType_ExtPropCleanup.h

}

Mp7JrsPlaceType_StructuredPostalAddress_LocalType::Mp7JrsPlaceType_StructuredPostalAddress_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPlaceType_StructuredPostalAddress_LocalType::~Mp7JrsPlaceType_StructuredPostalAddress_LocalType()
{
	Cleanup();
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_StreetNumber = NULL; // Optional String
	m_StreetNumber_Exist = false;
	m_StreetName = NULL; // Optional String
	m_StreetName_Exist = false;
	m_PostalTown = NULL; // Optional String
	m_PostalTown_Exist = false;
	m_City = NULL; // Optional String
	m_City_Exist = false;
	m_StateProvinceCounty = NULL; // Optional String
	m_StateProvinceCounty_Exist = false;
	m_Country = Mp7JrscountryCodePtr(); // Pattern
	m_Country_Exist = false;
	m_PostingIdentifier = Mp7JrsTextualPtr(); // Class
	m_PostingIdentifier_Exist = false;


// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredPostalAddress_LocalType_ExtMyPropInit.h

}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredPostalAddress_LocalType_ExtMyPropCleanup.h


	XMLString::release(&this->m_StreetNumber);
	this->m_StreetNumber = NULL;
	XMLString::release(&this->m_StreetName);
	this->m_StreetName = NULL;
	XMLString::release(&this->m_PostalTown);
	this->m_PostalTown = NULL;
	XMLString::release(&this->m_City);
	this->m_City = NULL;
	XMLString::release(&this->m_StateProvinceCounty);
	this->m_StateProvinceCounty = NULL;
	// Mp7JrsFactory::DeleteObject(m_Country);
	// Mp7JrsFactory::DeleteObject(m_PostingIdentifier);
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PlaceType_StructuredPostalAddress_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPlaceType_StructuredPostalAddress_LocalType
	const Mp7JrsPtr< Mp7JrsPlaceType_StructuredPostalAddress_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	if (tmp->IsValidStreetNumber())
	{
		this->SetStreetNumber(XMLString::replicate(tmp->GetStreetNumber()));
	}
	else
	{
		InvalidateStreetNumber();
	}
	if (tmp->IsValidStreetName())
	{
		this->SetStreetName(XMLString::replicate(tmp->GetStreetName()));
	}
	else
	{
		InvalidateStreetName();
	}
	if (tmp->IsValidPostalTown())
	{
		this->SetPostalTown(XMLString::replicate(tmp->GetPostalTown()));
	}
	else
	{
		InvalidatePostalTown();
	}
	if (tmp->IsValidCity())
	{
		this->SetCity(XMLString::replicate(tmp->GetCity()));
	}
	else
	{
		InvalidateCity();
	}
	if (tmp->IsValidStateProvinceCounty())
	{
		this->SetStateProvinceCounty(XMLString::replicate(tmp->GetStateProvinceCounty()));
	}
	else
	{
		InvalidateStateProvinceCounty();
	}
	if (tmp->IsValidCountry())
	{
		// Mp7JrsFactory::DeleteObject(m_Country);
		this->SetCountry(Mp7JrsFactory::CloneObject(tmp->GetCountry()));
	}
	else
	{
		InvalidateCountry();
	}
	if (tmp->IsValidPostingIdentifier())
	{
		// Mp7JrsFactory::DeleteObject(m_PostingIdentifier);
		this->SetPostingIdentifier(Mp7JrsFactory::CloneObject(tmp->GetPostingIdentifier()));
	}
	else
	{
		InvalidatePostingIdentifier();
	}
}

Mp7JrsNodePtr Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetStreetNumber() const
{
		return m_StreetNumber;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::IsValidStreetNumber() const
{
	return m_StreetNumber_Exist;
}

XMLCh * Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetStreetName() const
{
		return m_StreetName;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::IsValidStreetName() const
{
	return m_StreetName_Exist;
}

XMLCh * Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetPostalTown() const
{
		return m_PostalTown;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::IsValidPostalTown() const
{
	return m_PostalTown_Exist;
}

XMLCh * Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetCity() const
{
		return m_City;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::IsValidCity() const
{
	return m_City_Exist;
}

XMLCh * Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetStateProvinceCounty() const
{
		return m_StateProvinceCounty;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::IsValidStateProvinceCounty() const
{
	return m_StateProvinceCounty_Exist;
}

Mp7JrscountryCodePtr Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetCountry() const
{
		return m_Country;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::IsValidCountry() const
{
	return m_Country_Exist;
}

Mp7JrsTextualPtr Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetPostingIdentifier() const
{
		return m_PostingIdentifier;
}

// Element is optional
bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::IsValidPostingIdentifier() const
{
	return m_PostingIdentifier_Exist;
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetStreetNumber(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetStreetNumber().");
	}
	if (m_StreetNumber != item || m_StreetNumber_Exist == false)
	{
		XMLString::release(&m_StreetNumber);
		m_StreetNumber = item;
		m_StreetNumber_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::InvalidateStreetNumber()
{
	m_StreetNumber_Exist = false;
}
void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetStreetName(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetStreetName().");
	}
	if (m_StreetName != item || m_StreetName_Exist == false)
	{
		XMLString::release(&m_StreetName);
		m_StreetName = item;
		m_StreetName_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::InvalidateStreetName()
{
	m_StreetName_Exist = false;
}
void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetPostalTown(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetPostalTown().");
	}
	if (m_PostalTown != item || m_PostalTown_Exist == false)
	{
		XMLString::release(&m_PostalTown);
		m_PostalTown = item;
		m_PostalTown_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::InvalidatePostalTown()
{
	m_PostalTown_Exist = false;
}
void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetCity(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetCity().");
	}
	if (m_City != item || m_City_Exist == false)
	{
		XMLString::release(&m_City);
		m_City = item;
		m_City_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::InvalidateCity()
{
	m_City_Exist = false;
}
void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetStateProvinceCounty(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetStateProvinceCounty().");
	}
	if (m_StateProvinceCounty != item || m_StateProvinceCounty_Exist == false)
	{
		XMLString::release(&m_StateProvinceCounty);
		m_StateProvinceCounty = item;
		m_StateProvinceCounty_Exist = true;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::InvalidateStateProvinceCounty()
{
	m_StateProvinceCounty_Exist = false;
}
void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetCountry(const Mp7JrscountryCodePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetCountry().");
	}
	if (m_Country != item || m_Country_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Country);
		m_Country = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Country) m_Country->SetParent(m_myself.getPointer());
		if (m_Country && m_Country->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:countryCode"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Country->UseTypeAttribute = true;
		}
		m_Country_Exist = true;
		if(m_Country != Mp7JrscountryCodePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Country->SetContentName(XMLString::transcode("Country"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::InvalidateCountry()
{
	m_Country_Exist = false;
}
void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetPostingIdentifier(const Mp7JrsTextualPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPlaceType_StructuredPostalAddress_LocalType::SetPostingIdentifier().");
	}
	if (m_PostingIdentifier != item || m_PostingIdentifier_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_PostingIdentifier);
		m_PostingIdentifier = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PostingIdentifier) m_PostingIdentifier->SetParent(m_myself.getPointer());
		if (m_PostingIdentifier && m_PostingIdentifier->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_PostingIdentifier->UseTypeAttribute = true;
		}
		m_PostingIdentifier_Exist = true;
		if(m_PostingIdentifier != Mp7JrsTextualPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PostingIdentifier->SetContentName(XMLString::transcode("PostingIdentifier"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::InvalidatePostingIdentifier()
{
	m_PostingIdentifier_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Country")) == 0)
	{
		// Country is simple element countryCode
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetCountry()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:countryCode")))) != empty)
			{
				// Is type allowed
				Mp7JrscountryCodePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetCountry(p, client);
					if((p = GetCountry()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PostingIdentifier")) == 0)
	{
		// PostingIdentifier is simple element TextualType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPostingIdentifier()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextualPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPostingIdentifier(p, client);
					if((p = GetPostingIdentifier()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for PlaceType_StructuredPostalAddress_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "PlaceType_StructuredPostalAddress_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsPlaceType_StructuredPostalAddress_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsPlaceType_StructuredPostalAddress_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PlaceType_StructuredPostalAddress_LocalType"));
	// Element serialization:
	 // String
	if(m_StreetNumber != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_StreetNumber, X("urn:mpeg:mpeg7:schema:2004"), X("StreetNumber"), true);
	 // String
	if(m_StreetName != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_StreetName, X("urn:mpeg:mpeg7:schema:2004"), X("StreetName"), true);
	 // String
	if(m_PostalTown != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_PostalTown, X("urn:mpeg:mpeg7:schema:2004"), X("PostalTown"), true);
	 // String
	if(m_City != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_City, X("urn:mpeg:mpeg7:schema:2004"), X("City"), true);
	 // String
	if(m_StateProvinceCounty != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_StateProvinceCounty, X("urn:mpeg:mpeg7:schema:2004"), X("StateProvinceCounty"), true);
	if(m_Country != Mp7JrscountryCodePtr()) // Pattern FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Pattern
		// CON contentname already set in element setter -- not needed here
//		XMLCh * contentname = XMLString::transcode("Country");
//		m_Country->SetContentName(contentname);
		m_Country->UseTypeAttribute = this->UseTypeAttribute;
		m_Country->Serialize(doc, element);
	}
	// Class
	
	if (m_PostingIdentifier != Mp7JrsTextualPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_PostingIdentifier->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("PostingIdentifier"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_PostingIdentifier->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsPlaceType_StructuredPostalAddress_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("StreetNumber"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetStreetNumber(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetStreetNumber(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("StreetName"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetStreetName(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetStreetName(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("PostalTown"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetPostalTown(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetPostalTown(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("City"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetCity(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetCity(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("StateProvinceCounty"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetStateProvinceCounty(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetStateProvinceCounty(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
		// Deserialize pattern element
	if(Mp7JrsUtil::HasNodeName(parent, X("Country"), X("urn:mpeg:mpeg7:schema:2004")))
//			if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Country")) == 0))
		{
			Mp7JrscountryCodePtr tmp = CreatecountryCode;
			tmp->Deserialize(doc, parent, current);
			this->SetCountry(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("PostingIdentifier"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("PostingIdentifier")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateTextualType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetPostingIdentifier(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredPostalAddress_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPlaceType_StructuredPostalAddress_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Country")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreatecountryCode;
	}
	this->SetCountry(child);
  }
  if (XMLString::compareString(elementname, X("PostingIdentifier")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateTextualType;
	}
	this->SetPostingIdentifier(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPlaceType_StructuredPostalAddress_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCountry() != Mp7JrsNodePtr())
		result.Insert(GetCountry());
	if (GetPostingIdentifier() != Mp7JrsNodePtr())
		result.Insert(GetPostingIdentifier());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPlaceType_StructuredPostalAddress_LocalType_ExtMethodImpl.h


