 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtImplInclude.h



#include "Mp7JrsIntegerMatrixType.h"
#include "Mp7JrsRegionLocatorType_Polygon_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsRegionLocatorType_Polygon_LocalType::IMp7JrsRegionLocatorType_Polygon_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtPropInit.h

}

IMp7JrsRegionLocatorType_Polygon_LocalType::~IMp7JrsRegionLocatorType_Polygon_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtPropCleanup.h

}

Mp7JrsRegionLocatorType_Polygon_LocalType::Mp7JrsRegionLocatorType_Polygon_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsRegionLocatorType_Polygon_LocalType::~Mp7JrsRegionLocatorType_Polygon_LocalType()
{
	Cleanup();
}

void Mp7JrsRegionLocatorType_Polygon_LocalType::Init()
{

	// Init attributes
	m_unlocatedRegion = false; // Value
	m_unlocatedRegion_Default = false; // Default value
	m_unlocatedRegion_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Coords = Mp7JrsIntegerMatrixPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtMyPropInit.h

}

void Mp7JrsRegionLocatorType_Polygon_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Coords);
}

void Mp7JrsRegionLocatorType_Polygon_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use RegionLocatorType_Polygon_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IRegionLocatorType_Polygon_LocalType
	const Mp7JrsPtr< Mp7JrsRegionLocatorType_Polygon_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if (tmp->ExistunlocatedRegion())
	{
		this->SetunlocatedRegion(tmp->GetunlocatedRegion());
	}
	else
	{
		InvalidateunlocatedRegion();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_Coords);
		this->SetCoords(Mp7JrsFactory::CloneObject(tmp->GetCoords()));
}

Mp7JrsNodePtr Mp7JrsRegionLocatorType_Polygon_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsRegionLocatorType_Polygon_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


bool Mp7JrsRegionLocatorType_Polygon_LocalType::GetunlocatedRegion() const
{
	if (this->ExistunlocatedRegion()) {
		return m_unlocatedRegion;
	} else {
		return m_unlocatedRegion_Default;
	}
}

bool Mp7JrsRegionLocatorType_Polygon_LocalType::ExistunlocatedRegion() const
{
	return m_unlocatedRegion_Exist;
}
void Mp7JrsRegionLocatorType_Polygon_LocalType::SetunlocatedRegion(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Polygon_LocalType::SetunlocatedRegion().");
	}
	m_unlocatedRegion = item;
	m_unlocatedRegion_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsRegionLocatorType_Polygon_LocalType::InvalidateunlocatedRegion()
{
	m_unlocatedRegion_Exist = false;
}
Mp7JrsIntegerMatrixPtr Mp7JrsRegionLocatorType_Polygon_LocalType::GetCoords() const
{
		return m_Coords;
}

void Mp7JrsRegionLocatorType_Polygon_LocalType::SetCoords(const Mp7JrsIntegerMatrixPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Polygon_LocalType::SetCoords().");
	}
	if (m_Coords != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Coords);
		m_Coords = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Coords) m_Coords->SetParent(m_myself.getPointer());
		if (m_Coords && m_Coords->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:IntegerMatrixType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Coords->UseTypeAttribute = true;
		}
		if(m_Coords != Mp7JrsIntegerMatrixPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Coords->SetContentName(XMLString::transcode("Coords"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsRegionLocatorType_Polygon_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  1, 1 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 1
//- N; unlocatedRegion,  T:http://www.w3.org/2001/XMLSchema:boolean, C:Value 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("unlocatedRegion")) == 0)
	{
		// unlocatedRegion is simple attribute boolean
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "bool");
	}
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Coords")) == 0)
	{
		// Coords is simple element IntegerMatrixType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetCoords()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:IntegerMatrixType")))) != empty)
			{
				// Is type allowed
				Mp7JrsIntegerMatrixPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetCoords(p, client);
					if((p = GetCoords()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for RegionLocatorType_Polygon_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "RegionLocatorType_Polygon_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsRegionLocatorType_Polygon_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsRegionLocatorType_Polygon_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsRegionLocatorType_Polygon_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("RegionLocatorType_Polygon_LocalType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_unlocatedRegion_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_unlocatedRegion);
		element->setAttributeNS(X(""), X("unlocatedRegion"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_Coords != Mp7JrsIntegerMatrixPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Coords->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Coords"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Coords->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsRegionLocatorType_Polygon_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("unlocatedRegion")))
	{
		// deserialize value type
		this->SetunlocatedRegion(Mp7JrsConvert::TextToBool(parent->getAttribute(X("unlocatedRegion"))));
		* current = parent;
	}

	parent = Mp7JrsUtil::GetNextChild(parent);
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Coords"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Coords")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateIntegerMatrixType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetCoords(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsRegionLocatorType_Polygon_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Coords")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateIntegerMatrixType;
	}
	this->SetCoords(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsRegionLocatorType_Polygon_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCoords() != Mp7JrsNodePtr())
		result.Insert(GetCoords());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Polygon_LocalType_ExtMethodImpl.h


