 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtImplInclude.h



#include "Mp7JrsMaskType.h"
#include "Mp7JrsSceneGraphMaskType_CollectionType.h"
#include "Mp7JrsSceneGraphMaskType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsSceneGraphMaskType::IMp7JrsSceneGraphMaskType()
{

// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtPropInit.h

}

IMp7JrsSceneGraphMaskType::~IMp7JrsSceneGraphMaskType()
{
// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtPropCleanup.h

}

Mp7JrsSceneGraphMaskType::Mp7JrsSceneGraphMaskType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSceneGraphMaskType::~Mp7JrsSceneGraphMaskType()
{
	Cleanup();
}

void Mp7JrsSceneGraphMaskType::Init()
{
	// Init base
	m_Base = CreateMaskType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_SceneGraphMaskType_LocalType = Mp7JrsSceneGraphMaskType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtMyPropInit.h

}

void Mp7JrsSceneGraphMaskType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_SceneGraphMaskType_LocalType);
}

void Mp7JrsSceneGraphMaskType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SceneGraphMaskTypePtr, since we
	// might need GetBase(), which isn't defined in ISceneGraphMaskType
	const Mp7JrsPtr< Mp7JrsSceneGraphMaskType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsMaskPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSceneGraphMaskType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_SceneGraphMaskType_LocalType);
		this->SetSceneGraphMaskType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSceneGraphMaskType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsSceneGraphMaskType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSceneGraphMaskType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsMaskType > Mp7JrsSceneGraphMaskType::GetBase() const
{
	return m_Base;
}

Mp7JrsSceneGraphMaskType_CollectionPtr Mp7JrsSceneGraphMaskType::GetSceneGraphMaskType_LocalType() const
{
		return m_SceneGraphMaskType_LocalType;
}

void Mp7JrsSceneGraphMaskType::SetSceneGraphMaskType_LocalType(const Mp7JrsSceneGraphMaskType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSceneGraphMaskType::SetSceneGraphMaskType_LocalType().");
	}
	if (m_SceneGraphMaskType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SceneGraphMaskType_LocalType);
		m_SceneGraphMaskType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SceneGraphMaskType_LocalType) m_SceneGraphMaskType_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSceneGraphMaskType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for SceneGraphMaskType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "SceneGraphMaskType");
	}
	return result;
}

XMLCh * Mp7JrsSceneGraphMaskType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsSceneGraphMaskType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsSceneGraphMaskType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SceneGraphMaskType"));
	// Element serialization:
	if (m_SceneGraphMaskType_LocalType != Mp7JrsSceneGraphMaskType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SceneGraphMaskType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSceneGraphMaskType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsMaskType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		// Deserialise Choice Collection
		if((parent != NULL) && (
			// urn:mpeg:mpeg7:schema:2004:SubGraph
			Mp7JrsUtil::HasNodeName(parent, X("SubGraph"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SubGraph")) == 0)
				||
			// urn:mpeg:mpeg7:schema:2004:SubGraphNum
			Mp7JrsUtil::HasNodeName(parent, X("SubGraphNum"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SubGraphNum")) == 0)
				))
		{
			// Deserialize factory type
			Mp7JrsSceneGraphMaskType_CollectionPtr tmp = CreateSceneGraphMaskType_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetSceneGraphMaskType_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSceneGraphMaskType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  // Choice Collection
  if(
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("SubGraph"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("SubGraph")) == 0)
	||
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("SubGraphNum"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("SubGraphNum")) == 0)
	)
  {
	Mp7JrsSceneGraphMaskType_CollectionPtr tmp = CreateSceneGraphMaskType_CollectionType;
	this->SetSceneGraphMaskType_LocalType(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSceneGraphMaskType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSceneGraphMaskType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSceneGraphMaskType_LocalType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_ExtMethodImpl.h


