 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtImplInclude.h



#include "Mp7JrsMediaFormatType.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrsMediaFormatType_BitRate_LocalType.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType2.h"
#include "Mp7JrsMediaFormatType_VisualCoding_LocalType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_LocalType.h"
#include "Mp7JrsSourcePreferencesType_MediaFormat_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsSourcePreferencesType_MediaFormat_LocalType::IMp7JrsSourcePreferencesType_MediaFormat_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtPropInit.h

}

IMp7JrsSourcePreferencesType_MediaFormat_LocalType::~IMp7JrsSourcePreferencesType_MediaFormat_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtPropCleanup.h

}

Mp7JrsSourcePreferencesType_MediaFormat_LocalType::Mp7JrsSourcePreferencesType_MediaFormat_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSourcePreferencesType_MediaFormat_LocalType::~Mp7JrsSourcePreferencesType_MediaFormat_LocalType()
{
	Cleanup();
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::Init()
{
	// Init base
	m_Base = CreateMediaFormatType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;



// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtMyPropInit.h

}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SourcePreferencesType_MediaFormat_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISourcePreferencesType_MediaFormat_LocalType
	const Mp7JrsPtr< Mp7JrsSourcePreferencesType_MediaFormat_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsMediaFormatPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSourcePreferencesType_MediaFormat_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
}

Mp7JrsNodePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsMediaFormatType > Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrspreferenceValuePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetpreferenceValue().");
	}
	m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
Mp7JrsControlledTermUsePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetContent() const
{
	return GetBase()->GetContent();
}

Mp7JrsControlledTermUsePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetMedium() const
{
	return GetBase()->GetMedium();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidMedium() const
{
	return GetBase()->IsValidMedium();
}

Mp7JrsControlledTermUsePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetFileFormat() const
{
	return GetBase()->GetFileFormat();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidFileFormat() const
{
	return GetBase()->IsValidFileFormat();
}

unsigned Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetFileSize() const
{
	return GetBase()->GetFileSize();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidFileSize() const
{
	return GetBase()->IsValidFileSize();
}

Mp7JrsControlledTermUsePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetSystem() const
{
	return GetBase()->GetSystem();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidSystem() const
{
	return GetBase()->IsValidSystem();
}

float Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetBandwidth() const
{
	return GetBase()->GetBandwidth();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidBandwidth() const
{
	return GetBase()->IsValidBandwidth();
}

Mp7JrsMediaFormatType_BitRate_LocalPtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetBitRate() const
{
	return GetBase()->GetBitRate();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidBitRate() const
{
	return GetBase()->IsValidBitRate();
}

unsigned Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetTargetChannelBitRate() const
{
	return GetBase()->GetTargetChannelBitRate();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidTargetChannelBitRate() const
{
	return GetBase()->IsValidTargetChannelBitRate();
}

Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetScalableCoding() const
{
	return GetBase()->GetScalableCoding();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidScalableCoding() const
{
	return GetBase()->IsValidScalableCoding();
}

Mp7JrsMediaFormatType_VisualCoding_LocalPtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetVisualCoding() const
{
	return GetBase()->GetVisualCoding();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidVisualCoding() const
{
	return GetBase()->IsValidVisualCoding();
}

Mp7JrsMediaFormatType_AudioCoding_LocalPtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetAudioCoding() const
{
	return GetBase()->GetAudioCoding();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidAudioCoding() const
{
	return GetBase()->IsValidAudioCoding();
}

Mp7JrsControlledTermUsePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetSceneCodingFormat() const
{
	return GetBase()->GetSceneCodingFormat();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidSceneCodingFormat() const
{
	return GetBase()->IsValidSceneCodingFormat();
}

Mp7JrsControlledTermUsePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetGraphicsCodingFormat() const
{
	return GetBase()->GetGraphicsCodingFormat();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidGraphicsCodingFormat() const
{
	return GetBase()->IsValidGraphicsCodingFormat();
}

Mp7JrsControlledTermUsePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetOtherCodingFormat() const
{
	return GetBase()->GetOtherCodingFormat();
}

// Element is optional
bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::IsValidOtherCodingFormat() const
{
	return GetBase()->IsValidOtherCodingFormat();
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetContent(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetContent().");
	}
	GetBase()->SetContent(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetMedium(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetMedium().");
	}
	GetBase()->SetMedium(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateMedium()
{
	GetBase()->InvalidateMedium();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetFileFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetFileFormat().");
	}
	GetBase()->SetFileFormat(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateFileFormat()
{
	GetBase()->InvalidateFileFormat();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetFileSize(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetFileSize().");
	}
	GetBase()->SetFileSize(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateFileSize()
{
	GetBase()->InvalidateFileSize();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetSystem(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetSystem().");
	}
	GetBase()->SetSystem(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateSystem()
{
	GetBase()->InvalidateSystem();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetBandwidth(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetBandwidth().");
	}
	GetBase()->SetBandwidth(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateBandwidth()
{
	GetBase()->InvalidateBandwidth();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetBitRate(const Mp7JrsMediaFormatType_BitRate_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetBitRate().");
	}
	GetBase()->SetBitRate(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateBitRate()
{
	GetBase()->InvalidateBitRate();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetTargetChannelBitRate(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetTargetChannelBitRate().");
	}
	GetBase()->SetTargetChannelBitRate(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateTargetChannelBitRate()
{
	GetBase()->InvalidateTargetChannelBitRate();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetScalableCoding(const Mp7JrsMediaFormatType_ScalableCoding_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetScalableCoding().");
	}
	GetBase()->SetScalableCoding(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateScalableCoding()
{
	GetBase()->InvalidateScalableCoding();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetVisualCoding(const Mp7JrsMediaFormatType_VisualCoding_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetVisualCoding().");
	}
	GetBase()->SetVisualCoding(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateVisualCoding()
{
	GetBase()->InvalidateVisualCoding();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetAudioCoding(const Mp7JrsMediaFormatType_AudioCoding_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetAudioCoding().");
	}
	GetBase()->SetAudioCoding(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateAudioCoding()
{
	GetBase()->InvalidateAudioCoding();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetSceneCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetSceneCodingFormat().");
	}
	GetBase()->SetSceneCodingFormat(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateSceneCodingFormat()
{
	GetBase()->InvalidateSceneCodingFormat();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetGraphicsCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetGraphicsCodingFormat().");
	}
	GetBase()->SetGraphicsCodingFormat(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateGraphicsCodingFormat()
{
	GetBase()->InvalidateGraphicsCodingFormat();
}
void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetOtherCodingFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSourcePreferencesType_MediaFormat_LocalType::SetOtherCodingFormat().");
	}
	GetBase()->SetOtherCodingFormat(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::InvalidateOtherCodingFormat()
{
	GetBase()->InvalidateOtherCodingFormat();
}

Mp7JrsNodeEnum Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  1, 1 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 1
//- N; preferenceValue,  T:urn:mpeg:mpeg7:schema:2004:preferenceValueType, C:Class 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("preferenceValue")) == 0)
	{
		// preferenceValue is simple attribute preferenceValueType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = GetpreferenceValue()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:preferenceValueType")))) != empty)
			{
				// Is type allowed
				Mp7JrspreferenceValuePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetpreferenceValue(p, client);
					if((p = GetpreferenceValue()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SourcePreferencesType_MediaFormat_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SourcePreferencesType_MediaFormat_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsSourcePreferencesType_MediaFormat_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsSourcePreferencesType_MediaFormat_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SourcePreferencesType_MediaFormat_LocalType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsSourcePreferencesType_MediaFormat_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttribute(X("preferenceValue")));
		this->SetpreferenceValue(tmp);
		* current = parent;
	}

	// Extensionbase is Mp7JrsMediaFormatType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSourcePreferencesType_MediaFormat_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSourcePreferencesType_MediaFormat_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetContent() != Mp7JrsNodePtr())
		result.Insert(GetContent());
	if (GetMedium() != Mp7JrsNodePtr())
		result.Insert(GetMedium());
	if (GetFileFormat() != Mp7JrsNodePtr())
		result.Insert(GetFileFormat());
	if (GetSystem() != Mp7JrsNodePtr())
		result.Insert(GetSystem());
	if (GetBitRate() != Mp7JrsNodePtr())
		result.Insert(GetBitRate());
	if (GetScalableCoding() != Mp7JrsNodePtr())
		result.Insert(GetScalableCoding());
	if (GetVisualCoding() != Mp7JrsNodePtr())
		result.Insert(GetVisualCoding());
	if (GetAudioCoding() != Mp7JrsNodePtr())
		result.Insert(GetAudioCoding());
	if (GetSceneCodingFormat() != Mp7JrsNodePtr())
		result.Insert(GetSceneCodingFormat());
	if (GetGraphicsCodingFormat() != Mp7JrsNodePtr())
		result.Insert(GetGraphicsCodingFormat());
	if (GetOtherCodingFormat() != Mp7JrsNodePtr())
		result.Insert(GetOtherCodingFormat());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSourcePreferencesType_MediaFormat_LocalType_ExtMethodImpl.h


