
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsSpaceResolutionViewType_order_LocalType_ExtImplInclude.h


#include "Mp7JrsSpaceResolutionViewType_order_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsSpaceResolutionViewType_order_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsSpaceResolutionViewType_order_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsSpaceResolutionViewType_order_LocalType::ToText(Mp7JrsSpaceResolutionViewType_order_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/spaceFrequency:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("spaceFrequency");
			break;
		case /*Enumeration::*/frequencySpace:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("frequencySpace");
			break;
		case /*Enumeration::*/commutative:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("commutative");
			break;
		case /*Enumeration::*/partitionable:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("partitionable");
			break;
		case /*Enumeration::*/mixed:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("mixed");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsSpaceResolutionViewType_order_LocalType::Enumeration Mp7JrsSpaceResolutionViewType_order_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsSpaceResolutionViewType_order_LocalType::Enumeration result = Mp7JrsSpaceResolutionViewType_order_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "spaceFrequency") == 0)
	{
		result = Mp7JrsSpaceResolutionViewType_order_LocalType::/*Enumeration::*/spaceFrequency;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "frequencySpace") == 0)
	{
		result = Mp7JrsSpaceResolutionViewType_order_LocalType::/*Enumeration::*/frequencySpace;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "commutative") == 0)
	{
		result = Mp7JrsSpaceResolutionViewType_order_LocalType::/*Enumeration::*/commutative;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "partitionable") == 0)
	{
		result = Mp7JrsSpaceResolutionViewType_order_LocalType::/*Enumeration::*/partitionable;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "mixed") == 0)
	{
		result = Mp7JrsSpaceResolutionViewType_order_LocalType::/*Enumeration::*/mixed;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
