 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtImplInclude.h



#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType.h" // Sequence collection TimeIncr
#include "Mp7JrsMediaIncrDurationType.h" // Sequence collection element TimeIncr

#include <assert.h>
IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtPropInit.h

}

IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::~IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtPropCleanup.h

}

Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::~Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0()
{
	Cleanup();
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::Init()
{

	// Init attributes
	m_modelType = Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::UninitializedEnumeration;
	m_xOrigin = 0.0; // Value
	m_yOrigin = 0.0; // Value

	// Init elements (element, union sequence choice all any)
	
	m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType = Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtMyPropInit.h

}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType);
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in ISpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0
	const Mp7JrsPtr< Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
		this->SetmodelType(tmp->GetmodelType());
	}
	{
		this->SetxOrigin(tmp->GetxOrigin());
	}
	{
		this->SetyOrigin(tmp->GetyOrigin());
	}
		// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType);
		this->SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType()));
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetmodelType() const
{
	return m_modelType;
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetmodelType(Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetmodelType().");
	}
	m_modelType = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetxOrigin() const
{
	return m_xOrigin;
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetxOrigin(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetxOrigin().");
	}
	m_xOrigin = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetyOrigin() const
{
	return m_yOrigin;
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetyOrigin(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetyOrigin().");
	}
	m_yOrigin = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType() const
{
		return m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType;
}

void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType().");
	}
	if (m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType);
		m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType) m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  3, 3 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 3
//- N; modelType,  T:urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType, C:Enumeration 
//- N; xOrigin,  T:http://www.w3.org/2001/XMLSchema:float, C:Value 
//- N; yOrigin,  T:http://www.w3.org/2001/XMLSchema:float, C:Value 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("modelType")) == 0)
	{
		// modelType is simple attribute Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Enumeration");
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("xOrigin")) == 0)
	{
		// xOrigin is simple attribute float
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "float");
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("yOrigin")) == 0)
	{
		// yOrigin is simple attribute float
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "float");
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("TimeIncr")) == 0)
	{
		// TimeIncr is contained in itemtype Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType
		// in sequence collection Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType

		context->Found = true;
		Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr coll = GetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType;
				SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 65535))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr)coll->elementAt(i))->GetTimeIncr()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr item = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr)coll->elementAt(j))->SetTimeIncr(
						((Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr)coll->elementAt(j+1))->GetTimeIncr());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr)coll->elementAt(j))->SetTimeIncr(
						((Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr)coll->elementAt(j-1))->GetTimeIncr());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaIncrDurationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaIncrDurationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr)coll->elementAt(i))->SetTimeIncr(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr)coll->elementAt(i))->GetTimeIncr()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MotionParams")) == 0)
	{
		// Some primitive nodes types cannot be handled
		Mp7JrsXPathParseContext::ErrorUnsupportedType(context, "float");
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0");
	}
	return result;
}

XMLCh * Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0"));
	// Attribute Serialization:
	// Enumeration
	if(m_modelType != Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::ToText(m_modelType);
		element->setAttributeNS(X(""), X("modelType"), tmp);
		XMLString::release(&tmp);
	}
	// Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_xOrigin);
		element->setAttributeNS(X(""), X("xOrigin"), tmp);
		XMLString::release(&tmp);
	}
	// Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_yOrigin);
		element->setAttributeNS(X(""), X("yOrigin"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:
	if (m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType != Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Spatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("modelType")))
	{
		this->SetmodelType(Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_modelType_LocalType::Parse(parent->getAttribute(X("modelType"))));
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("xOrigin")))
	{
		// deserialize value type
		this->SetxOrigin(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("xOrigin"))));
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("yOrigin")))
	{
		// deserialize value type
		this->SetyOrigin(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("yOrigin"))));
		* current = parent;
	}

	parent = Mp7JrsUtil::GetNextChild(parent);
		// Sequence Collection
		if((parent != NULL) && (
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:TimeIncr")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("TimeIncr"), X("urn:mpeg:mpeg7:schema:2004")))
				||
// Old			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:MotionParams")) == 0)
			(Mp7JrsUtil::HasNodeName(parent, X("MotionParams"), X("urn:mpeg:mpeg7:schema:2004")))
				))
		{
			// Deserialize factory type
			Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  // Non-Choice Collection
	// local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
	Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionPtr tmp = CreateSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionType;
	this->SetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0_ExtMethodImpl.h


