
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType_ExtImplInclude.h


#include "Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::ToText(Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/pixel:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("pixel");
			break;
		case /*Enumeration::*/meter:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("meter");
			break;
		case /*Enumeration::*/pictureHeight:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("pictureHeight");
			break;
		case /*Enumeration::*/pictureWidth:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("pictureWidth");
			break;
		case /*Enumeration::*/pictureWidthAndHeight:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("pictureWidthAndHeight");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Enumeration Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::Enumeration result = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "pixel") == 0)
	{
		result = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::/*Enumeration::*/pixel;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "meter") == 0)
	{
		result = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::/*Enumeration::*/meter;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "pictureHeight") == 0)
	{
		result = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::/*Enumeration::*/pictureHeight;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "pictureWidth") == 0)
	{
		result = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::/*Enumeration::*/pictureWidth;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "pictureWidthAndHeight") == 0)
	{
		result = Mp7JrsSpatial2DCoordinateSystemType_Unit_LocalType::/*Enumeration::*/pictureWidthAndHeight;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
