 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtImplInclude.h



#include "Mp7JrsSpokenContentLinkType.h"
#include "Mp7JrsPhoneLexiconIndexType.h"
#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsnonNegativeReal.h"
#include "Mp7Jrsunsigned16.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtPropInit.h

}

IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::~IMp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtPropCleanup.h

}

Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::~Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType()
{
	Cleanup();
}

void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Init()
{
	// Init base
	m_Base = CreateSpokenContentLinkType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_phone = Mp7JrsPhoneLexiconIndexPtr(); // Create emtpy class ptr



// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtMyPropInit.h

}

void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_phone);
}

void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SpokenContentLatticeType_Block_Node_PhoneLink_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISpokenContentLatticeType_Block_Node_PhoneLink_LocalType
	const Mp7JrsPtr< Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsSpokenContentLinkPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_phone);
		this->Setphone(Mp7JrsFactory::CloneObject(tmp->Getphone()));
	}
}

Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsSpokenContentLinkType > Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsPhoneLexiconIndexPtr Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Getphone() const
{
	return m_phone;
}

void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Setphone(const Mp7JrsPhoneLexiconIndexPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Setphone().");
	}
	m_phone = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_phone) m_phone->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrszeroToOnePtr Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Getprobability() const
{
	return GetBase()->Getprobability();
}

bool Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Existprobability() const
{
	return GetBase()->Existprobability();
}
void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Setprobability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Setprobability().");
	}
	GetBase()->Setprobability(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Invalidateprobability()
{
	GetBase()->Invalidateprobability();
}
Mp7JrsnonNegativeRealPtr Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::GetacousticScore() const
{
	return GetBase()->GetacousticScore();
}

bool Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::ExistacousticScore() const
{
	return GetBase()->ExistacousticScore();
}
void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::SetacousticScore(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::SetacousticScore().");
	}
	GetBase()->SetacousticScore(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::InvalidateacousticScore()
{
	GetBase()->InvalidateacousticScore();
}
Mp7Jrsunsigned16Ptr Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::GetnodeOffset() const
{
	return GetBase()->GetnodeOffset();
}

bool Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::ExistnodeOffset() const
{
	return GetBase()->ExistnodeOffset();
}
void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::SetnodeOffset(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::SetnodeOffset().");
	}
	GetBase()->SetnodeOffset(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::InvalidatenodeOffset()
{
	GetBase()->InvalidatenodeOffset();
}

Mp7JrsNodeEnum Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  1, 4 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 1
//- N; probability,  T:urn:mpeg:mpeg7:schema:2004:zeroToOneType, C:Class 
//- N; acousticScore,  T:urn:mpeg:mpeg7:schema:2004:nonNegativeReal, C:Class 
//- N; nodeOffset,  T:urn:mpeg:mpeg7:schema:2004:unsigned16, C:Class 
//- N; phone,  T:urn:mpeg:mpeg7:schema:2004:PhoneLexiconIndexType, C:Class 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("phone")) == 0)
	{
		// phone is simple attribute PhoneLexiconIndexType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = Getphone()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PhoneLexiconIndexType")))) != empty)
			{
				// Is type allowed
				Mp7JrsPhoneLexiconIndexPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					Setphone(p, client);
					if((p = Getphone()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SpokenContentLatticeType_Block_Node_PhoneLink_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SpokenContentLatticeType_Block_Node_PhoneLink_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SpokenContentLatticeType_Block_Node_PhoneLink_LocalType"));
	// Attribute Serialization:
	// Class
	if (m_phone != Mp7JrsPhoneLexiconIndexPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_phone->ToText();
		element->setAttributeNS(X(""), X("phone"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:

}

bool Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("phone")))
	{
		// Deserialize class type
		Mp7JrsPhoneLexiconIndexPtr tmp = CreatePhoneLexiconIndexType;
		tmp->Parse(parent->getAttribute(X("phone")));
		this->Setphone(tmp);
		* current = parent;
	}

	// Extensionbase is Mp7JrsSpokenContentLinkType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalType_ExtMethodImpl.h


