 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrsStructuredCollectionType_CollectionType.h"
#include "Mp7JrsStructuredCollectionType_CollectionType0.h"
#include "Mp7JrsStructuredCollectionType_CollectionType1.h"
#include "Mp7JrsStructuredCollectionType_CollectionType2.h"
#include "Mp7JrsStructuredCollectionType_Relationships_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsStructuredCollectionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsStructuredCollectionType_LocalType.h" // Choice collection Collection
#include "Mp7JrsCollectionType.h" // Choice collection element Collection
#include "Mp7JrsReferenceType.h" // Choice collection element CollectionRef
#include "Mp7JrsStructuredCollectionType_LocalType0.h" // Choice collection CollectionModel
#include "Mp7JrsCollectionModelType.h" // Choice collection element CollectionModel
#include "Mp7JrsStructuredCollectionType_LocalType1.h" // Choice collection ClusterModel
#include "Mp7JrsClusterModelType.h" // Choice collection element ClusterModel
#include "Mp7JrsStructuredCollectionType_LocalType2.h" // Choice collection StructuredCollection
#include "Mp7JrsStructuredCollectionType.h" // Choice collection element StructuredCollection
#include "Mp7JrsGraphType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Relationships

#include <assert.h>
IMp7JrsStructuredCollectionType::IMp7JrsStructuredCollectionType()
{

// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtPropInit.h

}

IMp7JrsStructuredCollectionType::~IMp7JrsStructuredCollectionType()
{
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtPropCleanup.h

}

Mp7JrsStructuredCollectionType::Mp7JrsStructuredCollectionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsStructuredCollectionType::~Mp7JrsStructuredCollectionType()
{
	Cleanup();
}

void Mp7JrsStructuredCollectionType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_StructuredCollectionType_LocalType = Mp7JrsStructuredCollectionType_CollectionPtr(); // Collection
	m_StructuredCollectionType_LocalType0 = Mp7JrsStructuredCollectionType_Collection0Ptr(); // Collection
	m_StructuredCollectionType_LocalType1 = Mp7JrsStructuredCollectionType_Collection1Ptr(); // Collection
	m_StructuredCollectionType_LocalType2 = Mp7JrsStructuredCollectionType_Collection2Ptr(); // Collection
	m_Relationships = Mp7JrsStructuredCollectionType_Relationships_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtMyPropInit.h

}

void Mp7JrsStructuredCollectionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType);
	// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType0);
	// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType1);
	// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType2);
	// Mp7JrsFactory::DeleteObject(m_Relationships);
}

void Mp7JrsStructuredCollectionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use StructuredCollectionTypePtr, since we
	// might need GetBase(), which isn't defined in IStructuredCollectionType
	const Mp7JrsPtr< Mp7JrsStructuredCollectionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsStructuredCollectionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType);
		this->SetStructuredCollectionType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetStructuredCollectionType_LocalType()));
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType0);
		this->SetStructuredCollectionType_LocalType0(Mp7JrsFactory::CloneObject(tmp->GetStructuredCollectionType_LocalType0()));
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType1);
		this->SetStructuredCollectionType_LocalType1(Mp7JrsFactory::CloneObject(tmp->GetStructuredCollectionType_LocalType1()));
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType2);
		this->SetStructuredCollectionType_LocalType2(Mp7JrsFactory::CloneObject(tmp->GetStructuredCollectionType_LocalType2()));
		// Mp7JrsFactory::DeleteObject(m_Relationships);
		this->SetRelationships(Mp7JrsFactory::CloneObject(tmp->GetRelationships()));
}

Mp7JrsNodePtr Mp7JrsStructuredCollectionType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsStructuredCollectionType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsStructuredCollectionType::GetBase() const
{
	return m_Base;
}

Mp7JrsStructuredCollectionType_CollectionPtr Mp7JrsStructuredCollectionType::GetStructuredCollectionType_LocalType() const
{
		return m_StructuredCollectionType_LocalType;
}

Mp7JrsStructuredCollectionType_Collection0Ptr Mp7JrsStructuredCollectionType::GetStructuredCollectionType_LocalType0() const
{
		return m_StructuredCollectionType_LocalType0;
}

Mp7JrsStructuredCollectionType_Collection1Ptr Mp7JrsStructuredCollectionType::GetStructuredCollectionType_LocalType1() const
{
		return m_StructuredCollectionType_LocalType1;
}

Mp7JrsStructuredCollectionType_Collection2Ptr Mp7JrsStructuredCollectionType::GetStructuredCollectionType_LocalType2() const
{
		return m_StructuredCollectionType_LocalType2;
}

Mp7JrsStructuredCollectionType_Relationships_CollectionPtr Mp7JrsStructuredCollectionType::GetRelationships() const
{
		return m_Relationships;
}

void Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType(const Mp7JrsStructuredCollectionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType().");
	}
	if (m_StructuredCollectionType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType);
		m_StructuredCollectionType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StructuredCollectionType_LocalType) m_StructuredCollectionType_LocalType->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType0(const Mp7JrsStructuredCollectionType_Collection0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType0().");
	}
	if (m_StructuredCollectionType_LocalType0 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType0);
		m_StructuredCollectionType_LocalType0 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StructuredCollectionType_LocalType0) m_StructuredCollectionType_LocalType0->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType1(const Mp7JrsStructuredCollectionType_Collection1Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType1().");
	}
	if (m_StructuredCollectionType_LocalType1 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType1);
		m_StructuredCollectionType_LocalType1 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StructuredCollectionType_LocalType1) m_StructuredCollectionType_LocalType1->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType2(const Mp7JrsStructuredCollectionType_Collection2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetStructuredCollectionType_LocalType2().");
	}
	if (m_StructuredCollectionType_LocalType2 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionType_LocalType2);
		m_StructuredCollectionType_LocalType2 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StructuredCollectionType_LocalType2) m_StructuredCollectionType_LocalType2->SetParent(m_myself.getPointer());
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::SetRelationships(const Mp7JrsStructuredCollectionType_Relationships_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetRelationships().");
	}
	if (m_Relationships != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Relationships);
		m_Relationships = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Relationships) m_Relationships->SetParent(m_myself.getPointer());
		if(m_Relationships != Mp7JrsStructuredCollectionType_Relationships_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Relationships->SetContentName(XMLString::transcode("Relationships"));
		}
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsStructuredCollectionType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsStructuredCollectionType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsStructuredCollectionType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsStructuredCollectionType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsStructuredCollectionType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsStructuredCollectionType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsStructuredCollectionType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsStructuredCollectionType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsStructuredCollectionType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsStructuredCollectionType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsStructuredCollectionType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsStructuredCollectionType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsStructuredCollectionType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsStructuredCollectionType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsStructuredCollectionType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsStructuredCollectionType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsStructuredCollectionType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsStructuredCollectionType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsStructuredCollectionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 5 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Collection")) == 0)
	{
		// Collection is contained in itemtype StructuredCollectionType_LocalType
		// in choice collection StructuredCollectionType_CollectionType
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_CollectionPtr coll = GetStructuredCollectionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType;
				SetStructuredCollectionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_LocalPtr)coll->elementAt(i))->GetCollection()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_LocalPtr item = CreateStructuredCollectionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsCollectionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_LocalPtr)coll->elementAt(i))->SetCollection(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_LocalPtr)coll->elementAt(i))->GetCollection()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CollectionRef")) == 0)
	{
		// CollectionRef is contained in itemtype StructuredCollectionType_LocalType
		// in choice collection StructuredCollectionType_CollectionType
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_CollectionPtr coll = GetStructuredCollectionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType;
				SetStructuredCollectionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_LocalPtr)coll->elementAt(i))->GetCollectionRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_LocalPtr item = CreateStructuredCollectionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_LocalPtr)coll->elementAt(i))->SetCollectionRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_LocalPtr)coll->elementAt(i))->GetCollectionRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CollectionModel")) == 0)
	{
		// CollectionModel is contained in itemtype StructuredCollectionType_LocalType0
		// in choice collection StructuredCollectionType_CollectionType0
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_Collection0Ptr coll = GetStructuredCollectionType_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType0;
				SetStructuredCollectionType_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_Local0Ptr)coll->elementAt(i))->GetCollectionModel()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_Local0Ptr item = CreateStructuredCollectionType_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CollectionModelType")))) != empty)
			{
				// Is type allowed
				Mp7JrsCollectionModelPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_Local0Ptr)coll->elementAt(i))->SetCollectionModel(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_Local0Ptr)coll->elementAt(i))->GetCollectionModel()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CollectionModelRef")) == 0)
	{
		// CollectionModelRef is contained in itemtype StructuredCollectionType_LocalType0
		// in choice collection StructuredCollectionType_CollectionType0
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_Collection0Ptr coll = GetStructuredCollectionType_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType0;
				SetStructuredCollectionType_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_Local0Ptr)coll->elementAt(i))->GetCollectionModelRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_Local0Ptr item = CreateStructuredCollectionType_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_Local0Ptr)coll->elementAt(i))->SetCollectionModelRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_Local0Ptr)coll->elementAt(i))->GetCollectionModelRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ClusterModel")) == 0)
	{
		// ClusterModel is contained in itemtype StructuredCollectionType_LocalType1
		// in choice collection StructuredCollectionType_CollectionType1
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_Collection1Ptr coll = GetStructuredCollectionType_LocalType1();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType1;
				SetStructuredCollectionType_LocalType1(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_Local1Ptr)coll->elementAt(i))->GetClusterModel()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_Local1Ptr item = CreateStructuredCollectionType_LocalType1;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ClusterModelType")))) != empty)
			{
				// Is type allowed
				Mp7JrsClusterModelPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_Local1Ptr)coll->elementAt(i))->SetClusterModel(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_Local1Ptr)coll->elementAt(i))->GetClusterModel()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ClusterModelRef")) == 0)
	{
		// ClusterModelRef is contained in itemtype StructuredCollectionType_LocalType1
		// in choice collection StructuredCollectionType_CollectionType1
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_Collection1Ptr coll = GetStructuredCollectionType_LocalType1();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType1;
				SetStructuredCollectionType_LocalType1(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_Local1Ptr)coll->elementAt(i))->GetClusterModelRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_Local1Ptr item = CreateStructuredCollectionType_LocalType1;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_Local1Ptr)coll->elementAt(i))->SetClusterModelRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_Local1Ptr)coll->elementAt(i))->GetClusterModelRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("StructuredCollection")) == 0)
	{
		// StructuredCollection is contained in itemtype StructuredCollectionType_LocalType2
		// in choice collection StructuredCollectionType_CollectionType2
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_Collection2Ptr coll = GetStructuredCollectionType_LocalType2();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType2;
				SetStructuredCollectionType_LocalType2(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_Local2Ptr)coll->elementAt(i))->GetStructuredCollection()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_Local2Ptr item = CreateStructuredCollectionType_LocalType2;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:StructuredCollectionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsStructuredCollectionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_Local2Ptr)coll->elementAt(i))->SetStructuredCollection(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_Local2Ptr)coll->elementAt(i))->GetStructuredCollection()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("StructuredCollectionRef")) == 0)
	{
		// StructuredCollectionRef is contained in itemtype StructuredCollectionType_LocalType2
		// in choice collection StructuredCollectionType_CollectionType2
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_Collection2Ptr coll = GetStructuredCollectionType_LocalType2();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_CollectionType2;
				SetStructuredCollectionType_LocalType2(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsStructuredCollectionType_Local2Ptr)coll->elementAt(i))->GetStructuredCollectionRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsStructuredCollectionType_Local2Ptr item = CreateStructuredCollectionType_LocalType2;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsStructuredCollectionType_Local2Ptr)coll->elementAt(i))->SetStructuredCollectionRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsStructuredCollectionType_Local2Ptr)coll->elementAt(i))->GetStructuredCollectionRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Relationships")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Relationships is item of type GraphType
		// in element collection StructuredCollectionType_Relationships_CollectionType
		
		context->Found = true;
		Mp7JrsStructuredCollectionType_Relationships_CollectionPtr coll = GetRelationships();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateStructuredCollectionType_Relationships_CollectionType;
				SetRelationships(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:GraphType")))) != empty)
			{
				// Is type allowed
				Mp7JrsGraphPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for StructuredCollectionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "StructuredCollectionType");
	}
	return result;
}

XMLCh * Mp7JrsStructuredCollectionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsStructuredCollectionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsStructuredCollectionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("StructuredCollectionType"));
	// Element serialization:
	if (m_StructuredCollectionType_LocalType != Mp7JrsStructuredCollectionType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_StructuredCollectionType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_StructuredCollectionType_LocalType0 != Mp7JrsStructuredCollectionType_Collection0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_StructuredCollectionType_LocalType0->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_StructuredCollectionType_LocalType1 != Mp7JrsStructuredCollectionType_Collection1Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_StructuredCollectionType_LocalType1->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_StructuredCollectionType_LocalType2 != Mp7JrsStructuredCollectionType_Collection2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_StructuredCollectionType_LocalType2->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Relationships != Mp7JrsStructuredCollectionType_Relationships_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Relationships->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsStructuredCollectionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
		// Deserialise Choice Collection
		if((parent != NULL) && (
			// urn:mpeg:mpeg7:schema:2004:Collection
			Mp7JrsUtil::HasNodeName(parent, X("Collection"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Collection")) == 0)
				||
			// urn:mpeg:mpeg7:schema:2004:CollectionRef
			Mp7JrsUtil::HasNodeName(parent, X("CollectionRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:CollectionRef")) == 0)
				))
		{
			// Deserialize factory type
			Mp7JrsStructuredCollectionType_CollectionPtr tmp = CreateStructuredCollectionType_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetStructuredCollectionType_LocalType(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialise Choice Collection
		if((parent != NULL) && (
			// urn:mpeg:mpeg7:schema:2004:CollectionModel
			Mp7JrsUtil::HasNodeName(parent, X("CollectionModel"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:CollectionModel")) == 0)
				||
			// urn:mpeg:mpeg7:schema:2004:CollectionModelRef
			Mp7JrsUtil::HasNodeName(parent, X("CollectionModelRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:CollectionModelRef")) == 0)
				))
		{
			// Deserialize factory type
			Mp7JrsStructuredCollectionType_Collection0Ptr tmp = CreateStructuredCollectionType_CollectionType0;
			tmp->Deserialize(doc, parent, current);
			this->SetStructuredCollectionType_LocalType0(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialise Choice Collection
		if((parent != NULL) && (
			// urn:mpeg:mpeg7:schema:2004:ClusterModel
			Mp7JrsUtil::HasNodeName(parent, X("ClusterModel"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ClusterModel")) == 0)
				||
			// urn:mpeg:mpeg7:schema:2004:ClusterModelRef
			Mp7JrsUtil::HasNodeName(parent, X("ClusterModelRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:ClusterModelRef")) == 0)
				))
		{
			// Deserialize factory type
			Mp7JrsStructuredCollectionType_Collection1Ptr tmp = CreateStructuredCollectionType_CollectionType1;
			tmp->Deserialize(doc, parent, current);
			this->SetStructuredCollectionType_LocalType1(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		// Deserialise Choice Collection
		if((parent != NULL) && (
			// urn:mpeg:mpeg7:schema:2004:StructuredCollection
			Mp7JrsUtil::HasNodeName(parent, X("StructuredCollection"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:StructuredCollection")) == 0)
				||
			// urn:mpeg:mpeg7:schema:2004:StructuredCollectionRef
			Mp7JrsUtil::HasNodeName(parent, X("StructuredCollectionRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD			(XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:StructuredCollectionRef")) == 0)
				))
		{
			// Deserialize factory type
			Mp7JrsStructuredCollectionType_Collection2Ptr tmp = CreateStructuredCollectionType_CollectionType2;
			tmp->Deserialize(doc, parent, current);
			this->SetStructuredCollectionType_LocalType2(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
		
		// Element Collection
		if((parent != NULL) && 
		Mp7JrsUtil::HasNodeName(parent, X("Relationships"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD		(XMLString::compareString(parent->getNodeName(), X("Relationships")) == 0))
		{
			// Deserialize factory type
			Mp7JrsStructuredCollectionType_Relationships_CollectionPtr tmp = CreateStructuredCollectionType_Relationships_CollectionType;
			tmp->Deserialize(doc, parent, current);
			this->SetRelationships(tmp);
			found = true;
			parent = * current; // For collections
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		}
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsStructuredCollectionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  // Choice Collection
  if(
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("Collection"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("Collection")) == 0)
	||
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("CollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("CollectionRef")) == 0)
	)
  {
	Mp7JrsStructuredCollectionType_CollectionPtr tmp = CreateStructuredCollectionType_CollectionType;
	this->SetStructuredCollectionType_LocalType(tmp);
	child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("CollectionModel"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("CollectionModel")) == 0)
	||
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("CollectionModelRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("CollectionModelRef")) == 0)
	)
  {
	Mp7JrsStructuredCollectionType_Collection0Ptr tmp = CreateStructuredCollectionType_CollectionType0;
	this->SetStructuredCollectionType_LocalType0(tmp);
	child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("ClusterModel"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("ClusterModel")) == 0)
	||
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("ClusterModelRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("ClusterModelRef")) == 0)
	)
  {
	Mp7JrsStructuredCollectionType_Collection1Ptr tmp = CreateStructuredCollectionType_CollectionType1;
	this->SetStructuredCollectionType_LocalType1(tmp);
	child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("StructuredCollection"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("StructuredCollection")) == 0)
	||
// TODO better use this	
//  (Mp7JrsUtil::HasNodeName(parent, X("StructuredCollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
	(XMLString::compareString(elementname, X("StructuredCollectionRef")) == 0)
	)
  {
	Mp7JrsStructuredCollectionType_Collection2Ptr tmp = CreateStructuredCollectionType_CollectionType2;
	this->SetStructuredCollectionType_LocalType2(tmp);
	child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Relationships")) == 0))
  {
	Mp7JrsStructuredCollectionType_Relationships_CollectionPtr tmp = CreateStructuredCollectionType_Relationships_CollectionType;
	this->SetRelationships(tmp);
	child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsStructuredCollectionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetStructuredCollectionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetStructuredCollectionType_LocalType());
	if (GetStructuredCollectionType_LocalType0() != Mp7JrsNodePtr())
		result.Insert(GetStructuredCollectionType_LocalType0());
	if (GetStructuredCollectionType_LocalType1() != Mp7JrsNodePtr())
		result.Insert(GetStructuredCollectionType_LocalType1());
	if (GetStructuredCollectionType_LocalType2() != Mp7JrsNodePtr())
		result.Insert(GetStructuredCollectionType_LocalType2());
	if (GetRelationships() != Mp7JrsNodePtr())
		result.Insert(GetRelationships());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_ExtMethodImpl.h


