 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType2_ExtImplInclude.h



#include "Mp7JrsStructuredCollectionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsStructuredCollectionType_LocalType2.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsStructuredCollectionType_LocalType2::IMp7JrsStructuredCollectionType_LocalType2()
{

// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType2_ExtPropInit.h

}

IMp7JrsStructuredCollectionType_LocalType2::~IMp7JrsStructuredCollectionType_LocalType2()
{
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType2_ExtPropCleanup.h

}

Mp7JrsStructuredCollectionType_LocalType2::Mp7JrsStructuredCollectionType_LocalType2()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsStructuredCollectionType_LocalType2::~Mp7JrsStructuredCollectionType_LocalType2()
{
	Cleanup();
}

void Mp7JrsStructuredCollectionType_LocalType2::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_StructuredCollection = Mp7JrsStructuredCollectionPtr(); // Class
	m_StructuredCollectionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType2_ExtMyPropInit.h

}

void Mp7JrsStructuredCollectionType_LocalType2::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType2_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_StructuredCollection);
	// Mp7JrsFactory::DeleteObject(m_StructuredCollectionRef);
}

void Mp7JrsStructuredCollectionType_LocalType2::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use StructuredCollectionType_LocalType2Ptr, since we
	// might need GetBase(), which isn't defined in IStructuredCollectionType_LocalType2
	const Mp7JrsPtr< Mp7JrsStructuredCollectionType_LocalType2 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_StructuredCollection);
		this->SetStructuredCollection(Mp7JrsFactory::CloneObject(tmp->GetStructuredCollection()));
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionRef);
		this->SetStructuredCollectionRef(Mp7JrsFactory::CloneObject(tmp->GetStructuredCollectionRef()));
}

Mp7JrsNodePtr Mp7JrsStructuredCollectionType_LocalType2::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsStructuredCollectionType_LocalType2::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsStructuredCollectionPtr Mp7JrsStructuredCollectionType_LocalType2::GetStructuredCollection() const
{
		return m_StructuredCollection;
}

Mp7JrsReferencePtr Mp7JrsStructuredCollectionType_LocalType2::GetStructuredCollectionRef() const
{
		return m_StructuredCollectionRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsStructuredCollectionType_LocalType2::SetStructuredCollection(const Mp7JrsStructuredCollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType_LocalType2::SetStructuredCollection().");
	}
	if (m_StructuredCollection != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StructuredCollection);
		m_StructuredCollection = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StructuredCollection) m_StructuredCollection->SetParent(m_myself.getPointer());
		if (m_StructuredCollection && m_StructuredCollection->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:StructuredCollectionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_StructuredCollection->UseTypeAttribute = true;
		}
		if(m_StructuredCollection != Mp7JrsStructuredCollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_StructuredCollection->SetContentName(XMLString::transcode("StructuredCollection"));
		}
	// Mp7JrsFactory::DeleteObject(m_StructuredCollectionRef);
	m_StructuredCollectionRef = Mp7JrsReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsStructuredCollectionType_LocalType2::SetStructuredCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType_LocalType2::SetStructuredCollectionRef().");
	}
	if (m_StructuredCollectionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_StructuredCollectionRef);
		m_StructuredCollectionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_StructuredCollectionRef) m_StructuredCollectionRef->SetParent(m_myself.getPointer());
		if (m_StructuredCollectionRef && m_StructuredCollectionRef->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_StructuredCollectionRef->UseTypeAttribute = true;
		}
		if(m_StructuredCollectionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_StructuredCollectionRef->SetContentName(XMLString::transcode("StructuredCollectionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_StructuredCollection);
	m_StructuredCollection = Mp7JrsStructuredCollectionPtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: StructuredCollectionType_LocalType2: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsStructuredCollectionType_LocalType2::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsStructuredCollectionType_LocalType2::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsStructuredCollectionType_LocalType2::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsStructuredCollectionType_LocalType2::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_StructuredCollection != Mp7JrsStructuredCollectionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_StructuredCollection->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("StructuredCollection"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_StructuredCollection->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_StructuredCollectionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_StructuredCollectionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("StructuredCollectionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_StructuredCollectionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsStructuredCollectionType_LocalType2::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
	{
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("StructuredCollection"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("StructuredCollection")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateStructuredCollectionType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetStructuredCollection(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("StructuredCollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("StructuredCollectionRef")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateReferenceType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetStructuredCollectionRef(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
	} while(false);
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType2_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsStructuredCollectionType_LocalType2::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("StructuredCollection")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateStructuredCollectionType;
	}
	this->SetStructuredCollection(child);
  }
  if (XMLString::compareString(elementname, X("StructuredCollectionRef")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateReferenceType;
	}
	this->SetStructuredCollectionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsStructuredCollectionType_LocalType2::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetStructuredCollection() != Mp7JrsNodePtr())
		result.Insert(GetStructuredCollection());
	if (GetStructuredCollectionRef() != Mp7JrsNodePtr())
		result.Insert(GetStructuredCollectionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType2_ExtMethodImpl.h


