 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtImplInclude.h



#include "Mp7JrsSubjectTermDefinitionType.h"
#include "Mp7JrstermRelationQualifierType.h"
#include "Mp7JrsSubjectTermDefinitionType_CollectionType.h"
#include "Mp7JrsTermDefinitionBaseType_Name_CollectionType.h"
#include "Mp7JrsTermDefinitionBaseType_Definition_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsSubjectTermDefinitionType_Term_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsTermDefinitionBaseType_Name_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Definition

#include <assert.h>
IMp7JrsSubjectTermDefinitionType_Term_LocalType::IMp7JrsSubjectTermDefinitionType_Term_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtPropInit.h

}

IMp7JrsSubjectTermDefinitionType_Term_LocalType::~IMp7JrsSubjectTermDefinitionType_Term_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtPropCleanup.h

}

Mp7JrsSubjectTermDefinitionType_Term_LocalType::Mp7JrsSubjectTermDefinitionType_Term_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSubjectTermDefinitionType_Term_LocalType::~Mp7JrsSubjectTermDefinitionType_Term_LocalType()
{
	Cleanup();
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::Init()
{
	// Init base
	m_Base = CreateSubjectTermDefinitionType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_relation = Mp7JrstermRelationQualifierPtr(); // Create emtpy class ptr
	m_relation_Exist = false;



// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtMyPropInit.h

}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_relation);
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SubjectTermDefinitionType_Term_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISubjectTermDefinitionType_Term_LocalType
	const Mp7JrsPtr< Mp7JrsSubjectTermDefinitionType_Term_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsSubjectTermDefinitionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSubjectTermDefinitionType_Term_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_relation);
	if (tmp->Existrelation())
	{
		this->Setrelation(Mp7JrsFactory::CloneObject(tmp->Getrelation()));
	}
	else
	{
		Invalidaterelation();
	}
	}
}

Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsSubjectTermDefinitionType > Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrstermRelationQualifierPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::Getrelation() const
{
	if (this->Existrelation()) {
		return m_relation;
	} else {
		return m_relation_Default;
	}
}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::Existrelation() const
{
	return m_relation_Exist;
}
void Mp7JrsSubjectTermDefinitionType_Term_LocalType::Setrelation(const Mp7JrstermRelationQualifierPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::Setrelation().");
	}
	m_relation = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_relation) m_relation->SetParent(m_myself.getPointer());
	m_relation_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::Invalidaterelation()
{
	m_relation_Exist = false;
}
Mp7JrsSubjectTermDefinitionType_CollectionPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetSubjectTermDefinitionType_LocalType() const
{
	return GetBase()->GetSubjectTermDefinitionType_LocalType();
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetSubjectTermDefinitionType_LocalType(const Mp7JrsSubjectTermDefinitionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetSubjectTermDefinitionType_LocalType().");
	}
	GetBase()->SetSubjectTermDefinitionType_LocalType(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSubjectTermDefinitionType_Term_LocalType::GettermID() const
{
	return GetBase()->GetBase()->GettermID();
}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::ExisttermID() const
{
	return GetBase()->GetBase()->ExisttermID();
}
void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SettermID(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SettermID().");
	}
	GetBase()->GetBase()->SettermID(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::InvalidatetermID()
{
	GetBase()->GetBase()->InvalidatetermID();
}
Mp7JrsTermDefinitionBaseType_Name_CollectionPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetName() const
{
	return GetBase()->GetBase()->GetName();
}

Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetDefinition() const
{
	return GetBase()->GetBase()->GetDefinition();
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetName(const Mp7JrsTermDefinitionBaseType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetName().");
	}
	GetBase()->GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetDefinition(const Mp7JrsTermDefinitionBaseType_Definition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetDefinition().");
	}
	GetBase()->GetBase()->SetDefinition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSubjectTermDefinitionType_Term_LocalType::Getid() const
{
	return GetBase()->GetBase()->GetBase()->Getid();
}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::Existid() const
{
	return GetBase()->GetBase()->GetBase()->Existid();
}
void Mp7JrsSubjectTermDefinitionType_Term_LocalType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::Setid().");
	}
	GetBase()->GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::Invalidateid()
{
	GetBase()->GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GettimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::ExisttimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SettimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::InvalidatetimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GettimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SettimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetHeader() const
{
	return GetBase()->GetBase()->GetBase()->GetHeader();
}

void Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSubjectTermDefinitionType_Term_LocalType::SetHeader().");
	}
	GetBase()->GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  1, 7 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 1
//- N; id,  T:http://www.w3.org/2001/XMLSchema:ID, C:String 
//- N; timeBase,  T:urn:mpeg:mpeg7:schema:2004:xPathRefType, C:Pattern 
//- N; timeUnit,  T:urn:mpeg:mpeg7:schema:2004:durationType, C:Pattern 
//- N; mediaTimeBase,  T:urn:mpeg:mpeg7:schema:2004:xPathRefType, C:Pattern 
//- N; mediaTimeUnit,  T:urn:mpeg:mpeg7:schema:2004:mediaDurationType, C:Pattern 
//- N; termID,  T:http://www.w3.org/2001/XMLSchema:NMTOKEN, C:String 
//- N; relation,  T:urn:mpeg:mpeg7:schema:2004:termRelationQualifierType, C:Class 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("relation")) == 0)
	{
		// relation is simple attribute termRelationQualifierType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = Getrelation()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termRelationQualifierType")))) != empty)
			{
				// Is type allowed
				Mp7JrstermRelationQualifierPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					Setrelation(p, client);
					if((p = Getrelation()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SubjectTermDefinitionType_Term_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SubjectTermDefinitionType_Term_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsSubjectTermDefinitionType_Term_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsSubjectTermDefinitionType_Term_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SubjectTermDefinitionType_Term_LocalType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_relation_Exist)
	{
	// Class
	if (m_relation != Mp7JrstermRelationQualifierPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_relation->ToText();
		element->setAttributeNS(X(""), X("relation"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsSubjectTermDefinitionType_Term_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("relation")))
	{
		// Deserialize class type
		Mp7JrstermRelationQualifierPtr tmp = CreatetermRelationQualifierType;
		tmp->Parse(parent->getAttribute(X("relation")));
		this->Setrelation(tmp);
		* current = parent;
	}

	// Extensionbase is Mp7JrsSubjectTermDefinitionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSubjectTermDefinitionType_Term_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSubjectTermDefinitionType_Term_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSubjectTermDefinitionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSubjectTermDefinitionType_LocalType());
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetDefinition() != Mp7JrsNodePtr())
		result.Insert(GetDefinition());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_Term_LocalType_ExtMethodImpl.h


