 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtImplInclude.h



#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsMediaIncrDurationType.h"
#include "Mp7JrsTemporalInterpolationType_WholeInterval_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsTemporalInterpolationType_WholeInterval_LocalType::IMp7JrsTemporalInterpolationType_WholeInterval_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtPropInit.h

}

IMp7JrsTemporalInterpolationType_WholeInterval_LocalType::~IMp7JrsTemporalInterpolationType_WholeInterval_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtPropCleanup.h

}

Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::Mp7JrsTemporalInterpolationType_WholeInterval_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::~Mp7JrsTemporalInterpolationType_WholeInterval_LocalType()
{
	Cleanup();
}

void Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_MediaDuration = Mp7JrsmediaDurationPtr(); // Pattern
	m_MediaIncrDuration = Mp7JrsMediaIncrDurationPtr(); // Class with content 


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtMyPropInit.h

}

void Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_MediaDuration);
	// Mp7JrsFactory::DeleteObject(m_MediaIncrDuration);
}

void Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use TemporalInterpolationType_WholeInterval_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ITemporalInterpolationType_WholeInterval_LocalType
	const Mp7JrsPtr< Mp7JrsTemporalInterpolationType_WholeInterval_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_MediaDuration);
		this->SetMediaDuration(Mp7JrsFactory::CloneObject(tmp->GetMediaDuration()));
		// Mp7JrsFactory::DeleteObject(m_MediaIncrDuration);
		this->SetMediaIncrDuration(Mp7JrsFactory::CloneObject(tmp->GetMediaIncrDuration()));
}

Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsmediaDurationPtr Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::GetMediaDuration() const
{
		return m_MediaDuration;
}

Mp7JrsMediaIncrDurationPtr Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::GetMediaIncrDuration() const
{
		return m_MediaIncrDuration;
}

// implementing setter for choice 
/* element */
void Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::SetMediaDuration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::SetMediaDuration().");
	}
	if (m_MediaDuration != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaDuration);
		m_MediaDuration = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaDuration) m_MediaDuration->SetParent(m_myself.getPointer());
		if (m_MediaDuration && m_MediaDuration->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:mediaDurationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaDuration->UseTypeAttribute = true;
		}
		if(m_MediaDuration != Mp7JrsmediaDurationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaDuration->SetContentName(XMLString::transcode("MediaDuration"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaIncrDuration);
	m_MediaIncrDuration = Mp7JrsMediaIncrDurationPtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::SetMediaIncrDuration(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::SetMediaIncrDuration().");
	}
	if (m_MediaIncrDuration != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaIncrDuration);
		m_MediaIncrDuration = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaIncrDuration) m_MediaIncrDuration->SetParent(m_myself.getPointer());
		if (m_MediaIncrDuration && m_MediaIncrDuration->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaIncrDurationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaIncrDuration->UseTypeAttribute = true;
		}
		if(m_MediaIncrDuration != Mp7JrsMediaIncrDurationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaIncrDuration->SetContentName(XMLString::transcode("MediaIncrDuration"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaDuration);
	m_MediaDuration = Mp7JrsmediaDurationPtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  0, 0 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	// Element ------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("MediaDuration")) == 0)
	{
		// MediaDuration is simple element mediaDurationType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMediaDuration()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:mediaDurationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsmediaDurationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMediaDuration(p, client);
					if((p = GetMediaDuration()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	// Element ------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaIncrDuration")) == 0)
	{
		// MediaIncrDuration is simple element MediaIncrDurationType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMediaIncrDuration()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaIncrDurationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaIncrDurationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMediaIncrDuration(p, client);
					if((p = GetMediaIncrDuration()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for TemporalInterpolationType_WholeInterval_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "TemporalInterpolationType_WholeInterval_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("TemporalInterpolationType_WholeInterval_LocalType"));
	// Element serialization:
	if(m_MediaDuration != Mp7JrsmediaDurationPtr()) // Pattern FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Pattern
		// CON contentname already set in element setter -- not needed here
//		XMLCh * contentname = XMLString::transcode("MediaDuration");
//		m_MediaDuration->SetContentName(contentname);
		m_MediaDuration->UseTypeAttribute = this->UseTypeAttribute;
		m_MediaDuration->Serialize(doc, element);
	}
	// Class with content		
	
	if (m_MediaIncrDuration != Mp7JrsMediaIncrDurationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaIncrDuration->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaIncrDuration"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaIncrDuration->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
	{
		// Deserialize pattern element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaDuration"), X("urn:mpeg:mpeg7:schema:2004")))
//			if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaDuration")) == 0))
		{
			Mp7JrsmediaDurationPtr tmp = CreatemediaDurationType;
			tmp->Deserialize(doc, parent, current);
			this->SetMediaDuration(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaIncrDuration"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaIncrDuration")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateMediaIncrDurationType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetMediaIncrDuration(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
	} while(false);
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("MediaDuration")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreatemediaDurationType;
	}
	this->SetMediaDuration(child);
  }
  if (XMLString::compareString(elementname, X("MediaIncrDuration")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateMediaIncrDurationType;
	}
	this->SetMediaIncrDuration(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsTemporalInterpolationType_WholeInterval_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMediaDuration() != Mp7JrsNodePtr())
		result.Insert(GetMediaDuration());
	if (GetMediaIncrDuration() != Mp7JrsNodePtr())
		result.Insert(GetMediaIncrDuration());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_WholeInterval_LocalType_ExtMethodImpl.h


