
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_Direction_LocalType_ExtImplInclude.h


#include "Mp7JrsTextureBrowsingType_Direction_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_Direction_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsTextureBrowsingType_Direction_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsTextureBrowsingType_Direction_LocalType::ToText(Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/noDirectionality:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("noDirectionality");
			break;
		case /*Enumeration::*/_0Degree:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("0Degree");
			break;
		case /*Enumeration::*/_30Degree:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("30Degree");
			break;
		case /*Enumeration::*/_60Degree:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("60Degree");
			break;
		case /*Enumeration::*/_90Degree:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("90Degree");
			break;
		case /*Enumeration::*/_120Degree:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("120Degree");
			break;
		case /*Enumeration::*/_150Degree:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("150Degree");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration Mp7JrsTextureBrowsingType_Direction_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsTextureBrowsingType_Direction_LocalType::Enumeration result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "noDirectionality") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/noDirectionality;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "0Degree") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/_0Degree;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "30Degree") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/_30Degree;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "60Degree") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/_60Degree;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "90Degree") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/_90Degree;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "120Degree") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/_120Degree;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "150Degree") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Direction_LocalType::/*Enumeration::*/_150Degree;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
