 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtImplInclude.h



#include "Mp7JrsVideoViewGraphType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsVideoViewGraphType_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsVideoViewGraphType_LocalType0::IMp7JrsVideoViewGraphType_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtPropInit.h

}

IMp7JrsVideoViewGraphType_LocalType0::~IMp7JrsVideoViewGraphType_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtPropCleanup.h

}

Mp7JrsVideoViewGraphType_LocalType0::Mp7JrsVideoViewGraphType_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsVideoViewGraphType_LocalType0::~Mp7JrsVideoViewGraphType_LocalType0()
{
	Cleanup();
}

void Mp7JrsVideoViewGraphType_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_TimeFrequencyChild = Mp7JrsVideoViewGraphPtr(); // Class
	m_TimeFrequencyChildRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtMyPropInit.h

}

void Mp7JrsVideoViewGraphType_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChild);
	// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChildRef);
}

void Mp7JrsVideoViewGraphType_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use VideoViewGraphType_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in IVideoViewGraphType_LocalType0
	const Mp7JrsPtr< Mp7JrsVideoViewGraphType_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChild);
		this->SetTimeFrequencyChild(Mp7JrsFactory::CloneObject(tmp->GetTimeFrequencyChild()));
		// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChildRef);
		this->SetTimeFrequencyChildRef(Mp7JrsFactory::CloneObject(tmp->GetTimeFrequencyChildRef()));
}

Mp7JrsNodePtr Mp7JrsVideoViewGraphType_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsVideoViewGraphType_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsVideoViewGraphPtr Mp7JrsVideoViewGraphType_LocalType0::GetTimeFrequencyChild() const
{
		return m_TimeFrequencyChild;
}

Mp7JrsReferencePtr Mp7JrsVideoViewGraphType_LocalType0::GetTimeFrequencyChildRef() const
{
		return m_TimeFrequencyChildRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsVideoViewGraphType_LocalType0::SetTimeFrequencyChild(const Mp7JrsVideoViewGraphPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsVideoViewGraphType_LocalType0::SetTimeFrequencyChild().");
	}
	if (m_TimeFrequencyChild != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChild);
		m_TimeFrequencyChild = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TimeFrequencyChild) m_TimeFrequencyChild->SetParent(m_myself.getPointer());
		if (m_TimeFrequencyChild && m_TimeFrequencyChild->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:VideoViewGraphType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TimeFrequencyChild->UseTypeAttribute = true;
		}
		if(m_TimeFrequencyChild != Mp7JrsVideoViewGraphPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TimeFrequencyChild->SetContentName(XMLString::transcode("TimeFrequencyChild"));
		}
	// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChildRef);
	m_TimeFrequencyChildRef = Mp7JrsReferencePtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsVideoViewGraphType_LocalType0::SetTimeFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsVideoViewGraphType_LocalType0::SetTimeFrequencyChildRef().");
	}
	if (m_TimeFrequencyChildRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChildRef);
		m_TimeFrequencyChildRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TimeFrequencyChildRef) m_TimeFrequencyChildRef->SetParent(m_myself.getPointer());
		if (m_TimeFrequencyChildRef && m_TimeFrequencyChildRef->GetClassId() 
	!= Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TimeFrequencyChildRef->UseTypeAttribute = true;
		}
		if(m_TimeFrequencyChildRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TimeFrequencyChildRef->SetContentName(XMLString::transcode("TimeFrequencyChildRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_TimeFrequencyChild);
	m_TimeFrequencyChild = Mp7JrsVideoViewGraphPtr();
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: VideoViewGraphType_LocalType0: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsVideoViewGraphType_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsVideoViewGraphType_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsVideoViewGraphType_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsVideoViewGraphType_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_TimeFrequencyChild != Mp7JrsVideoViewGraphPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TimeFrequencyChild->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TimeFrequencyChild"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TimeFrequencyChild->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_TimeFrequencyChildRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TimeFrequencyChildRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TimeFrequencyChildRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TimeFrequencyChildRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsVideoViewGraphType_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
	{
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TimeFrequencyChild"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TimeFrequencyChild")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateVideoViewGraphType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetTimeFrequencyChild(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
		// Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TimeFrequencyChildRef"), X("urn:mpeg:mpeg7:schema:2004")))
//		if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TimeFrequencyChildRef")) == 0))
		{
			// We have to deal with xsi:type classes...
			// Deserialize factory type
			Mp7JrsPtr< Mp7JrsNode > tmp;
			if(parent->hasAttribute(X("xsi:type")))
			{
			  NamespaceHelper result;
			  Mp7JrsUtil::GetXsiType(parent, doc, &result);
			  XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//			  tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
			  if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
			}else 
			{
			  tmp = CreateReferenceType;
			}
			tmp->Deserialize(doc, parent, current);
			
			if(parent->hasAttribute(X("xsi:type"))) {
					tmp->UseTypeAttribute = true;
			}
			this->SetTimeFrequencyChildRef(tmp);
			found = true;
			* current = parent; // We must adjust it!
			parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
			continue;	   // For choices
		}
	} while(false);
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsVideoViewGraphType_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("TimeFrequencyChild")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateVideoViewGraphType;
	}
	this->SetTimeFrequencyChild(child);
  }
  if (XMLString::compareString(elementname, X("TimeFrequencyChildRef")) == 0) {
	// We check for xsi:type
	if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
	  child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
	} else { // no xsi:type
	  child = CreateReferenceType;
	}
	this->SetTimeFrequencyChildRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsVideoViewGraphType_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTimeFrequencyChild() != Mp7JrsNodePtr())
		result.Insert(GetTimeFrequencyChild());
	if (GetTimeFrequencyChildRef() != Mp7JrsNodePtr())
		result.Insert(GetTimeFrequencyChildRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtMethodImpl.h


