 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtImplInclude.h



#include "Mp7JrsWordType.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType2.h"
#include "Mp7JrsWordLexiconType_Token_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
#include "Mp7JrsXPathParseContext.h" // XPath stuff

#include <assert.h>
IMp7JrsWordLexiconType_Token_LocalType::IMp7JrsWordLexiconType_Token_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtPropInit.h

}

IMp7JrsWordLexiconType_Token_LocalType::~IMp7JrsWordLexiconType_Token_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtPropCleanup.h

}

Mp7JrsWordLexiconType_Token_LocalType::Mp7JrsWordLexiconType_Token_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsWordLexiconType_Token_LocalType::~Mp7JrsWordLexiconType_Token_LocalType()
{
	Cleanup();
}

void Mp7JrsWordLexiconType_Token_LocalType::Init()
{
	// Init base
	m_Base = CreateWordType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_linguisticUnit = Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr(); // Create emtpy class ptr
	m_linguisticUnit_Exist = false;
	m_representation = Mp7JrsWordLexiconType_Token_representation_LocalType::UninitializedEnumeration;
	m_representation_Default = Mp7JrsWordLexiconType_Token_representation_LocalType::orthographic; // Default enumeration
	m_representation_Exist = false;



// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtMyPropInit.h

}

void Mp7JrsWordLexiconType_Token_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_linguisticUnit);
}

void Mp7JrsWordLexiconType_Token_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use WordLexiconType_Token_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IWordLexiconType_Token_LocalType
	const Mp7JrsPtr< Mp7JrsWordLexiconType_Token_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//	  m_Base = Mp7JrsWordPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsWordLexiconType_Token_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_linguisticUnit);
	if (tmp->ExistlinguisticUnit())
	{
		this->SetlinguisticUnit(Mp7JrsFactory::CloneObject(tmp->GetlinguisticUnit()));
	}
	else
	{
		InvalidatelinguisticUnit();
	}
	}
	{
	if (tmp->Existrepresentation())
	{
		this->Setrepresentation(tmp->Getrepresentation());
	}
	else
	{
		Invalidaterepresentation();
	}
	}
}

Mp7JrsNodePtr Mp7JrsWordLexiconType_Token_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsWordLexiconType_Token_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsWordType > Mp7JrsWordLexiconType_Token_LocalType::GetBase() const
{
	return m_Base;
}

void Mp7JrsWordLexiconType_Token_LocalType::SetContent(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsWordLexiconType_Token_LocalType::SetContent().");
	}
	GetBase()->SetContent(item);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsWordLexiconType_Token_LocalType::GetContent() const
{
	return GetBase()->GetContent();
}
Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr Mp7JrsWordLexiconType_Token_LocalType::GetlinguisticUnit() const
{
	if (this->ExistlinguisticUnit()) {
		return m_linguisticUnit;
	} else {
		return m_linguisticUnit_Default;
	}
}

bool Mp7JrsWordLexiconType_Token_LocalType::ExistlinguisticUnit() const
{
	return m_linguisticUnit_Exist;
}
void Mp7JrsWordLexiconType_Token_LocalType::SetlinguisticUnit(const Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsWordLexiconType_Token_LocalType::SetlinguisticUnit().");
	}
	m_linguisticUnit = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_linguisticUnit) m_linguisticUnit->SetParent(m_myself.getPointer());
	m_linguisticUnit_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsWordLexiconType_Token_LocalType::InvalidatelinguisticUnit()
{
	m_linguisticUnit_Exist = false;
}
Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration Mp7JrsWordLexiconType_Token_LocalType::Getrepresentation() const
{
	if (this->Existrepresentation()) {
		return m_representation;
	} else {
		return m_representation_Default;
	}
}

bool Mp7JrsWordLexiconType_Token_LocalType::Existrepresentation() const
{
	return m_representation_Exist;
}
void Mp7JrsWordLexiconType_Token_LocalType::Setrepresentation(Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsWordLexiconType_Token_LocalType::Setrepresentation().");
	}
	m_representation = item;
	m_representation_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsWordLexiconType_Token_LocalType::Invalidaterepresentation()
{
	m_representation_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsWordLexiconType_Token_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{

// ********* Number of Attributes:  2, 2 ************


	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
//-A*T*T*R*I*B*S: 2
//- N; linguisticUnit,  T:urn:mpeg:mpeg7:schema:2004:WordLexiconType_Token_linguisticUnit_LocalType2, C:Class 
//- N; representation,  T:urn:mpeg:mpeg7:schema:2004:WordLexiconType_Token_representation_LocalType, C:Enumeration 
	// Attribute ------------------------------------------------------------------
	if(context->IsAttribute && XMLString::compareString(context->ElementName, X("linguisticUnit")) == 0)
	{
		// linguisticUnit is simple attribute WordLexiconType_Token_linguisticUnit_LocalType2
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleAttribute(context);

		Mp7JrsNodePtr p;
		if((p = GetlinguisticUnit()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleAttribute(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:WordLexiconType_Token_linguisticUnit_LocalType2")))) != empty)
			{
				// Is type allowed
				Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetlinguisticUnit(p, client);
					if((p = GetlinguisticUnit()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetAttribute(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
	}
	// Attribute ------------------------------------------------------------------
	else if(context->IsAttribute && XMLString::compareString(context->ElementName, X("representation")) == 0)
	{
		// representation is simple attribute WordLexiconType_Token_representation_LocalType
		Mp7JrsXPathParseContext::ErrorUnsupportedAttributeType(context, "Mp7JrsWordLexiconType_Token_representation_LocalType::Enumeration");
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for WordLexiconType_Token_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "WordLexiconType_Token_LocalType");
	}
	return result;
}

XMLCh * Mp7JrsWordLexiconType_Token_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsWordLexiconType_Token_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsWordLexiconType_Token_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsWordLexiconType_Token_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsWordLexiconType_Token_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	// ftt 04 03 2011: or if the base would create a named node with the wrong namespace (base namespace instead of derived one)
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


	// pass newElem to base class, so that it contains new node after return
	m_Base->Serialize(doc, element, newElem);
	element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("WordLexiconType_Token_LocalType"));
	// Attribute Serialization:
		

	// Optional attriute
	if(m_linguisticUnit_Exist)
	{
	// Class
	if (m_linguisticUnit != Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_linguisticUnit->ToText();
		element->setAttributeNS(X(""), X("linguisticUnit"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Attribute Serialization:
		

	// Optional attriute
	if(m_representation_Exist)
	{
	// Enumeration
	if(m_representation != Mp7JrsWordLexiconType_Token_representation_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsWordLexiconType_Token_representation_LocalType::ToText(m_representation);
		element->setAttributeNS(X(""), X("representation"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsWordLexiconType_Token_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("linguisticUnit")))
	{
		// Deserialize class type
		Mp7JrsWordLexiconType_Token_linguisticUnit_Local2Ptr tmp = CreateWordLexiconType_Token_linguisticUnit_LocalType2;
		tmp->Parse(parent->getAttribute(X("linguisticUnit")));
		this->SetlinguisticUnit(tmp);
		* current = parent;
	}

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
	if(parent->hasAttribute(X("representation")))
	{
		this->Setrepresentation(Mp7JrsWordLexiconType_Token_representation_LocalType::Parse(parent->getAttribute(X("representation"))));
		* current = parent;
	}

	// Extensionbase is Mp7JrsWordType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsWordLexiconType_Token_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
	child = Mp7JrsNodePtr();
  } else {
	return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsWordLexiconType_Token_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_LocalType_ExtMethodImpl.h


