
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType_ExtImplInclude.h


#include "Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::ToText(Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/_1_16:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("1/16");
			break;
		case /*Enumeration::*/_1_8:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("1/8");
			break;
		case /*Enumeration::*/_1_4:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("1/4");
			break;
		case /*Enumeration::*/_1_2:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("1/2");
			break;
		case /*Enumeration::*/_1:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("1");
			break;
		case /*Enumeration::*/_2:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("2");
			break;
		case /*Enumeration::*/_4:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("4");
			break;
		case /*Enumeration::*/_8:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("8");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::Enumeration Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::Enumeration result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "1/16") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_1_16;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "1/8") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_1_8;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "1/4") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_1_4;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "1/2") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_1_2;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "1") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_1;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "2") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_2;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "4") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_4;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "8") == 0)
	{
		result = Mp7JrsaudioSpectrumAttributeGrp_octaveResolution_LocalType::/*Enumeration::*/_8;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
