
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsdegreeAccidentalType_ExtImplInclude.h


#include "Mp7JrsdegreeAccidentalType.h"

// no includefile for extension defined 
// file Mp7JrsdegreeAccidentalType_ExtMethodImpl.h


const XMLCh * Mp7JrsdegreeAccidentalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsdegreeAccidentalType::ToText(Mp7JrsdegreeAccidentalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/flat:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("flat");
			break;
		case /*Enumeration::*/natural:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("natural");
			break;
		case /*Enumeration::*/sharp:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("sharp");
			break;
		case /*Enumeration::*/doubleSharp:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("doubleSharp");
			break;
		case /*Enumeration::*/doubleFlat:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("doubleFlat");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsdegreeAccidentalType::Enumeration Mp7JrsdegreeAccidentalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsdegreeAccidentalType::Enumeration result = Mp7JrsdegreeAccidentalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "flat") == 0)
	{
		result = Mp7JrsdegreeAccidentalType::/*Enumeration::*/flat;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "natural") == 0)
	{
		result = Mp7JrsdegreeAccidentalType::/*Enumeration::*/natural;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "sharp") == 0)
	{
		result = Mp7JrsdegreeAccidentalType::/*Enumeration::*/sharp;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "doubleSharp") == 0)
	{
		result = Mp7JrsdegreeAccidentalType::/*Enumeration::*/doubleSharp;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "doubleFlat") == 0)
	{
		result = Mp7JrsdegreeAccidentalType::/*Enumeration::*/doubleFlat;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
