
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsdegreeNoteType_ExtImplInclude.h


#include "Mp7JrsdegreeNoteType.h"

// no includefile for extension defined 
// file Mp7JrsdegreeNoteType_ExtMethodImpl.h


const XMLCh * Mp7JrsdegreeNoteType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsdegreeNoteType::ToText(Mp7JrsdegreeNoteType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/C:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("C");
			break;
		case /*Enumeration::*/D:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("D");
			break;
		case /*Enumeration::*/E:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("E");
			break;
		case /*Enumeration::*/F:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("F");
			break;
		case /*Enumeration::*/G:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("G");
			break;
		case /*Enumeration::*/A:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("A");
			break;
		case /*Enumeration::*/B:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("B");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsdegreeNoteType::Enumeration Mp7JrsdegreeNoteType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsdegreeNoteType::Enumeration result = Mp7JrsdegreeNoteType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "C") == 0)
	{
		result = Mp7JrsdegreeNoteType::/*Enumeration::*/C;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "D") == 0)
	{
		result = Mp7JrsdegreeNoteType::/*Enumeration::*/D;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "E") == 0)
	{
		result = Mp7JrsdegreeNoteType::/*Enumeration::*/E;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "F") == 0)
	{
		result = Mp7JrsdegreeNoteType::/*Enumeration::*/F;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "G") == 0)
	{
		result = Mp7JrsdegreeNoteType::/*Enumeration::*/G;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "A") == 0)
	{
		result = Mp7JrsdegreeNoteType::/*Enumeration::*/A;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "B") == 0)
	{
		result = Mp7JrsdegreeNoteType::/*Enumeration::*/B;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
