
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2013, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtImplInclude.h


#include "Mp7JrssummaryComponentType_LocalType.h"

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrssummaryComponentType_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrssummaryComponentType_LocalType::ToText(Mp7JrssummaryComponentType_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/audio:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("audio");
			break;
		case /*Enumeration::*/visual:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("visual");
			break;
		case /*Enumeration::*/audioVisual:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("audioVisual");
			break;
		case /*Enumeration::*/textual:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("textual");
			break;
		case /*Enumeration::*/keyAudioClips:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("keyAudioClips");
			break;
		case /*Enumeration::*/keyVideoClips:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("keyVideoClips");
			break;
		case /*Enumeration::*/keyAudioVisualClips:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("keyAudioVisualClips");
			break;
		case /*Enumeration::*/keyFrames:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("keyFrames");
			break;
		case /*Enumeration::*/keySounds:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("keySounds");
			break;
		case /*Enumeration::*/keyThemes:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("keyThemes");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrssummaryComponentType_LocalType::Enumeration Mp7JrssummaryComponentType_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrssummaryComponentType_LocalType::Enumeration result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "audio") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/audio;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "visual") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/visual;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "audioVisual") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/audioVisual;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "textual") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/textual;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "keyAudioClips") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/keyAudioClips;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "keyVideoClips") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/keyVideoClips;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "keyAudioVisualClips") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/keyAudioVisualClips;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "keyFrames") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/keyFrames;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "keySounds") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/keySounds;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "keyThemes") == 0)
	{
		result = Mp7JrssummaryComponentType_LocalType::/*Enumeration::*/keyThemes;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
